
#ifdef WIN32

#include <bppvm.h>
#include <bppclass.h>
#include <bppvalue.h>
#include <bppdict.h>
#include <bppvec.h>
#include <bppstrng.h>
#include <bppobjct.h>
#include <bppint.h>
#include <bppprint.h>
#include <bppbuf.h>
#include <bppufunc.h>
#include "bp2wbase.h"
#include "bp2wstruc.h"
#include "bp2cldef.h"

#include <commctrl.h>

#pragma warning(disable:4244)
#pragma warning(disable:4311)
#pragma warning(disable:4312)



/* ===================== Bp2WinMsgHandler ========================== */

int Bp2WinMsgHandler::_hdlOwnerIdx = 0;
const BppString Bp2WinMsgHandler::_className = _T("WinMsgHandler");

bool Bp2WinMsgHandler::ctor(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
	CHKVM;
	CHKOBJECT;
	CHKARGC(1,2);
	if (argc == 2)
	{
		bool ok = false;
		BppObject* p = ARG(1);
		if (p != 0)
		{
			BppClass* pcl = p->getClass();
			if (pcl->isSubtypeOf(Bp2WinBase::_className))
			{
				MEMBER(_hdlOwnerIdx) = BppValue(p,true);
				ok = true;
			}
		}
		else if (ARG(1).getType() == BVT_NULL)
			ok = true;
		if (!ok)  THROW(_T("Window reference expected"));
	}
	*bp = pThis;
	sp = bp;
	return true;
}

bool Bp2WinMsgHandler::setOwner(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
	CHKVM;
	CHKOBJECT;
	CHKARGC(2,2);
	bool ok = false;
	const BppValue& arg = ARG(1);
	if (arg.getType() == BVT_NULL)
	{
		MEMBER(_hdlOwnerIdx) = arg;
		ok = true;
	}
	else
	{
		BppObject* p = arg;
		if (p != 0)
		{
			BppClass* pcl = p->getClass();
			if (pcl->isSubtypeOf(Bp2WinBase::_className))
			{
				MEMBER(_hdlOwnerIdx) = BppValue(p,true);
				ok = true;
			}
		}
	}
	if (!ok)  THROW(_T("Window reference expected"));

	bp->dispose();
	sp = bp;
	return true;
}

bool Bp2WinMsgHandler::getOwner(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
	CHKVM;
	CHKOBJECT;
	ARGCMAX(1);
	(*bp) = (BppObject*) MEMBER(_hdlOwnerIdx);
	sp = bp;
	return true;
}

bool Bp2WinMsgHandler::handleMessage(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
	CHKVM;
	CHKOBJECT;
	CHKARGC(6,6);
	(*bp) = (BppInt) 1;
	sp = bp;
	return true;
}

bool Bp2WinMsgHandler::equals(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
	CHKVM;
	CHKOBJECT;
	CHKARGC(2,2);
	BppObject* p = ARG(1);
	(*bp) = (p == pThis) ? (BppInt) 1 : (BppInt) 0;
	sp = bp;
	return true;
}

void Bp2WinMsgHandler::CreateClass(BppVirtualMachine& vm)
{
	BppClass* pClass = new BppClass(vm);
	if (!vm.registerNativeClass(_className.c_str(),pClass)) return;
	pClass->addDataMember(_T("_owner"));
	pClass->addMethod(_className.c_str(),&ctor);
	pClass->addMethod(_T("setOwner"),&setOwner);
	pClass->addMethod(_T("getOwner"),&getOwner);
	pClass->addMethod(_T("handleMessage"),&handleMessage);
	pClass->addMethod(_T("equals"),&equals);
	pClass->fixupDataDefs();
	_hdlOwnerIdx = pClass->getMemberIndex(_T("_owner"));
}

#ifndef DOXY

	struct HwndTableEntry
	{
		HWND hwnd;
		BppObject* pwin;
	};

	class HwndTable
	{
	public:
		HwndTable():_size(0),_capacity(10)
		{
			_tbl = (HwndTableEntry*) allocmem(_capacity * sizeof(HwndTableEntry));
		}
		~HwndTable()
		{
			if (_tbl != 0) freemem(_tbl);
		}
		bool empty() { return (_size < 1); }



		int getPos(HWND hwnd, int* insPos = 0)
		{
			if (_size < 1) return -1;
			int imin = 0;
			int imax = _size-1;
			HWND hwndmin = _tbl[imin].hwnd;
			HWND hwndmax = _tbl[imax].hwnd;
			if ((hwnd < hwndmin) || (hwnd > hwndmax)) {
				if (insPos) {
					(*insPos) = hwnd < hwndmin ? imin : imax + 1;
				}
				return -1;
			}
			while (imin <= imax)
			{
				if (hwnd == hwndmin) return imin;
				if (hwnd == hwndmax) return imax;
				int imid = imin + ((imax - imin) / 2);
				HWND hwndmid = _tbl[imid].hwnd;
				if (imid == imin) {
					if (insPos) {
						(*insPos) = hwnd < hwndmid ? imid : imid + 1;
					}
					return -1;
				}
				if (hwnd == hwndmid) return imid;
				if (hwnd < hwndmid)
				{
					hwndmax = hwndmid;
					imax = imid;
				}
				else
				{
					hwndmin = hwndmid;
					imin = imid;
				}
			}
			if (insPos) {
				(*insPos) = hwnd < hwndmax ? imax : imax + 1;
			}
			return -1;
		}

	  HwndTableEntry* find(HWND hwnd)
	  {
		  int idx = getPos(hwnd);
		  if (idx >= 0) return &(_tbl[idx]);
		  return 0;
	  }
	  
	  int insert(HWND hwnd, BppObject* pwin)
		{
		    int insPos = 0;
			int i=getPos(hwnd,&insPos);
			if (i < 0) i = insPos;
			else {
				_tbl[i].pwin = pwin;
				return i;
			}
			//for (i=0;i<_size;++i)
			//{
			//	HWND hwndi = _tbl[i].hwnd;
			//	if (hwnd < hwndi) break;
			//	if (hwnd == hwndi)
			//	{
			//		_tbl[i].pwin = pwin;
			//		return i;
			//	}
			//}
			if (_size >= _capacity)
			{
				HwndTableEntry* ptbl = (HwndTableEntry*) reallocmem(_tbl, sizeof(HwndTableEntry) * (_capacity + 10));
				_capacity += 10;
				_tbl = ptbl;
			}
			for (int j=_size;j>i;--j)
				_tbl[j] = _tbl[j-1];
			_tbl[i].hwnd = hwnd;
			_tbl[i].pwin = pwin;
			++_size;
			return i;
		}

		bool erase(HWND hwnd)
		{
			int i = getPos(hwnd);
			if (i<0) return false;
			for (int j=i;j<_size-1;++j) _tbl[j] = _tbl[j+1];
			--_size;
			return true;
		}
	private:
		HwndTableEntry* _tbl;
		int _size;
		int _capacity;
	};
#endif // !DOXY
	static HwndTable _winMap;

	HINSTANCE Bp2WinBase::_hInstance = NULL;
	const BppString Bp2WinBase::_className = _T("WinBase");
	int Bp2WinBase::_hwndIdx = 0;
	int Bp2WinBase::_handlerListIdx = 0;
	int Bp2WinBase::_savedWndProcIdx = 0;
	int Bp2WinBase::_virtualRectIdx = 0;
	int Bp2WinBase::_useVirtualSizeIdx = 0;
	int Bp2WinBase::_scrollBarModeIdx = 0;
	int Bp2WinBase::_sxIdx = 0;
	int Bp2WinBase::_syIdx = 0;
	int Bp2WinBase::_lifeScrollIdx = 0;
	int Bp2WinBase::_foreColorIdx = 0;
	int Bp2WinBase::_backColorIdx = 0;
	int Bp2WinBase::_backBrushIdx = 0;
	int Bp2WinBase::_accelArrayIdx = 0;
	int Bp2WinBase::_haccelIdx = 0;
	int Bp2WinBase::_paintStructIdx = 0;
	BppObject* Bp2WinBase::_pWinCreate = 0;
	const BppString Bp2WinBase::_maxIDNm = _T("_maxID");
	const BppString Bp2WinBase::_returnCodeNm = _T("_returnCode");
	const BppString Bp2WinBase::_autoQuitNm = _T("_autoQuit");

	bool Bp2WinBase::ctor(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		MEMBER(_hwndIdx) = (BppIntPtr) 0;
		MEMBER(_handlerListIdx) = new BppVector();
		MEMBER(_savedWndProcIdx) = (BppIntPtr) 0;
		if (!interpreter->createObject(MEMBER(_virtualRectIdx),Bp2Rect::_className)) return false;
		MEMBER(_useVirtualSizeIdx) = (BppInt) 0;
		MEMBER(_scrollBarModeIdx) = (BppInt) 0;
		MEMBER(_sxIdx) = (BppInt) 10;
		MEMBER(_syIdx) = (BppInt) 10;
		MEMBER(_lifeScrollIdx) = (BppInt) 0;
		MEMBER(_foreColorIdx) = (BppUInt) -1;
		MEMBER(_backColorIdx) = (BppUInt) -1;
		MEMBER(_backBrushIdx) = (BppIntPtr) 0;
		MEMBER(_accelArrayIdx) = new BppVector();
		MEMBER(_haccelIdx) = (BppIntPtr) 0;
		MEMBER(_paintStructIdx) = (BppIntPtr)0;
		sp = bp;
	  return true;
	}
	bool Bp2WinBase::dtor(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HACCEL haccel = (HACCEL) (BppIntPtr) MEMBER(_haccelIdx);
		if (haccel != 0)
		{
			DestroyAcceleratorTable(haccel);
			MEMBER(_haccelIdx) = (BppIntPtr) 0;
		}
		PAINTSTRUCT* paintstruct = (PAINTSTRUCT*) (BppIntPtr)MEMBER(_paintStructIdx);
		if (paintstruct)
		{
			delete paintstruct;
			MEMBER(_paintStructIdx) = (BppIntPtr)0;
		}
		HBRUSH curBrush = (HBRUSH)(BppIntPtr)MEMBER(_backBrushIdx);
		if (curBrush) {
			DeleteObject(curBrush);
			MEMBER(_backBrushIdx) = (BppIntPtr)0;
		}
		_winMap.erase((HWND)(BppIntPtr)(MEMBER(_hwndIdx)));
		bp->dispose();
		sp = bp;
		return true;
	}

		//int create(string wndClass, int hwndParent = 0, int x = CW_USEDEFAULT, int y = CW_USEDEFAULT, int width = 100, int height = 100, 
		// int style = 0, int extStyle = 0, int hMenu_ID = 0, string text = "");

	bool Bp2WinBase::create(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,11);
		 BppString* pwndclass = interpreter->getStringFromValueExtern(ARG(1));
		if (pwndclass == 0)
			return interpreter->badType(ARG(1).getType(),BVT_STRING);
		HWND hwndParent = 0;
		HMENU hMenu = 0;
		BppInt x = CW_USEDEFAULT;
		BppInt y = CW_USEDEFAULT;
		BppInt width = 100;
		BppInt height = 100;
		BppInt style = 0;
		BppInt extStyle = 0;
		BppString* ptext = 0;
		switch (argc)
		{
		case 11:
			ptext = interpreter->getStringFromValueExtern(ARG(10));
			if (ptext == 0)
				return interpreter->badType(ARG(10).getType(),BVT_STRING);
		case 10:
			CHKTYPE(ARG(9), BVT_INTEGRALTYPE);
			hMenu = (HMENU) (BppIntPtr) ARG(9);
		case 9:
			CHKTYPE(ARG(8),BVT_INTNUMBER);
			extStyle = ARG(8);
		case 8:
			CHKTYPE(ARG(7),BVT_INTNUMBER);
			style = ARG(7);
		case 7:
			CHKTYPE(ARG(6),BVT_INTNUMBER);
			height = ARG(6);
			if (height < 0) height = -height;
		case 6:
			CHKTYPE(ARG(5),BVT_INTNUMBER);
			width = ARG(5);
			if (width < 0) width = -width;
		case 5:
			CHKTYPE(ARG(4),BVT_INTNUMBER);
			y = ARG(4);
		case 4:
			CHKTYPE(ARG(3),BVT_INTNUMBER);
			x = ARG(3);
		case 3:
			{
				BppObject* p = ARG(2);
				if ((p == 0) || (!(p->getClass()->isSubtypeOf(Bp2WinBase::_className))))
				{
					 CHKTYPE(ARG(2),BVT_PTRTYPE);
					 hwndParent = (HWND) (BppIntPtr) ARG(2);
				}
				else
				{
					 hwndParent = (HWND)(BppIntPtr)(OBJMEMBER(p,_hwndIdx));
				}
			}
		} // end switch
#ifndef WINCE
		if (hwndParent == 0) hwndParent = GetDesktopWindow();
#endif
		_pWinCreate = pThis;
		const BppChar* title = _T("");
		if (ptext != 0) title = ptext->c_str();
		HWND hwnd = CreateWindowEx((DWORD) extStyle,pwndclass->c_str(),title,(DWORD) style,x,y,width,height,
			hwndParent,hMenu,_hInstance,pThis);
		if (hwnd == NULL)
			THROW(_T("Window creation failed."));

		MEMBER(_hwndIdx) = (BppIntPtr) hwnd;
		WNDPROC wndproc = (WNDPROC) (BppIntPtr) MEMBER(_savedWndProcIdx);
		if (wndproc == 0)
		{ 
#ifndef WINCE
			wndproc = (WNDPROC) GetWindowLongPtr(hwnd,GWLP_WNDPROC);
#else
			wndproc = (WNDPROC) GetWindowLong(hwnd,GWL_WNDPROC);
#endif
			if (wndproc != &globalMsgCallback)
			{
#ifndef WINCE
					wndproc = (WNDPROC) SetWindowLongPtr(hwnd, GWLP_WNDPROC, (LONG_PTR) globalMsgCallback);
#else
					wndproc = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) globalMsgCallback);
#endif
			}
			else
				wndproc = 0;
			MEMBER(_savedWndProcIdx) = (BppIntPtr) wndproc;
		}
		bool ok = (_winMap.insert(hwnd,pThis) >= 0);
		*bp = (BppInt) ((ok) ? 1 : 0);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::createFromHandle(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		BppInt result = 0;
		HWND handle = (HWND) (BppIntPtr) ARG(1);
		if ((handle != 0) && (_winMap.getPos(handle) < 0))
		{
			BppValue& vHwnd = MEMBER(_hwndIdx);
			if (((BppIntPtr) vHwnd) == 0)
			{
				vHwnd = (BppIntPtr) handle;
				MEMBER(_savedWndProcIdx) = (BppIntPtr)
#ifdef WINCE
				SetWindowLong(handle,GWL_WNDPROC,(LONG) globalMsgCallback);
#else
				SetWindowLongPtr(handle,GWLP_WNDPROC,(LONG_PTR) globalMsgCallback);
#endif
				_winMap.insert(handle,pThis);
				result = 1;
			}
		}
		*bp = result;
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getHandle(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		*bp = (BppIntPtr)(MEMBER(_hwndIdx));
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getParentHandle(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hdl = (HWND)(BppIntPtr)(MEMBER(_hwndIdx));
		BppIntPtr result = 0;
		if (hdl != 0)
		{
			result = (BppIntPtr) GetParent(hdl);
		}
		*bp = result;
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getParent(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hdl = (HWND)(BppIntPtr)(MEMBER(_hwndIdx));
		BppObject* result = 0;
		if (hdl != 0)
		{
			HWND hwnd = GetParent(hdl);
			if (hwnd != 0)
			{
				HwndTableEntry* pe = _winMap.find(hwnd);
				if (pe != 0)
					result = pe->pwin;
			}
		}
		if (result != 0)
			*bp = result;
		else
			bp->dispose();
		sp = bp;
		return true;
	}

	bool Bp2WinBase::addChild(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		BppObject* p = ARG(1);
		if ((p == 0) || (!(p->getClass()->isSubtypeOf(Bp2WinBase::_className))))
			THROW(_T("Invalid argument. Window expected."));
		HWND chdl = (HWND)(BppIntPtr)(OBJMEMBER(p,_hwndIdx));
		HWND hdl = (HWND)(BppIntPtr)(MEMBER(_hwndIdx));
		*bp = (BppInt) ((SetParent(chdl,hdl) != 0) ? 1 : 0);
		sp = bp;
		return true;
	}

	static BOOL CALLBACK EnumChildProc( HWND hwnd, LPARAM lParam)
	{
		BppVector* lst = (BppVector*) lParam;
		lst->push_back((BppIntPtr) hwnd);
		return TRUE;
	}
#ifdef WINCE
	typedef BOOL  (CALLBACK *WNDENUMPROC) ( HWND hwnd, LPARAM lParam);
	BOOL EnumChildWindows(HWND hWndParent,
		  WNDENUMPROC lpEnumFunc,
		  LPARAM lParam)
	{
		HWND hchild = GetWindow(hWndParent,GW_CHILD);
		while (hchild != NULL)
		{
			if (!lpEnumFunc(hchild,lParam)) return FALSE;
			hchild = GetWindow(hchild,GW_HWNDNEXT);
		}
		return TRUE;
	}

#endif
	bool Bp2WinBase::getChildrenHandles(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		BppVector* pvec = new BppVector();
		BppValue tmp = pvec;
		EnumChildWindows((HWND)(BppIntPtr)MEMBER(_hwndIdx),&EnumChildProc,(LPARAM) pvec);
		*bp = pvec;
		sp = bp;
		return true;
	}

	static BOOL _getWinRect(HWND hwnd,RECT& rect)
	{
		if (hwnd == 0) return FALSE;
		if (!GetWindowRect(hwnd,&rect)) return FALSE;
		POINT p;
		p.x = rect.left;
		p.y = rect.top;
		if (ScreenToClient(GetParent(hwnd),&p))
		{
			rect.left += p.x;
			rect.right += p.x;
			rect.top += p.y;
			rect.bottom += p.y;
		}
		return TRUE;
	}

	static BOOL _getClientRect(HWND hwnd,RECT& rect)
	{
		if (hwnd == 0) return FALSE;
		if (!GetClientRect(hwnd,&rect)) return FALSE;
		RECT wrect;
		if (!GetWindowRect(hwnd,&wrect)) return FALSE;
		POINT p;
		p.x = wrect.left;
		p.y = wrect.top;
		if (ScreenToClient(hwnd,&p))
		{
			rect.left -= p.x;
			rect.right -= p.x;
			rect.top -= p.y;
			rect.bottom -= p.y;
		}
		return TRUE;
	}

	bool Bp2WinBase::setPosition(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,4);
		BppInt x,y;
		BOOL repaint = TRUE;
		switch (ARG(1).getType())
		{
		case BVT_OBJECT:
		case BVT_OBJECTREF:
		case BVT_STRONGOBJECT:
		case BVT_STRONGOBJECTREF:
			{
				ARGCMAX(3);
				BppObject* ppos = ARG(1);
				if (!ppos->getClass()->isSubtypeOf(Bp2Point::_className))
					THROW(_T("Invalid argument. POINT expected"));
				BppValue v;
				if (!interpreter->invokeMember(v,ppos,_T("getX"))) return false;
				x =  v;
				if (!interpreter->invokeMember(v,ppos,_T("getY"))) return false;
				y =  v;
				if (argc == 3)
					repaint = ( ((BppInt) ARG(2)) != 0) ? TRUE : FALSE;
			}
			break;
		default:
		  if (!interpreter->checkType(ARG(1),BVT_NUMBER))
				  return false;
				ARGCMIN(3);
				x =  ARG(1);
				y =  ARG(2);
				if (argc == 4)
					repaint = ( ((BppInt) ARG(3)) != 0) ? TRUE : FALSE;
		}
		RECT rect;
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		bool ok = (hwnd != 0);
		if (ok)
			 ok = (GetWindowRect(hwnd,&rect) != 0);
		if (ok)
			ok = (MoveWindow(hwnd,x,y,rect.right-rect.left,rect.bottom-rect.top,repaint) != 0);
		*bp = (BppInt) (ok ? 1 : 0);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::setSize(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,4);
		BppInt w,h;
		BOOL repaint = TRUE;
		switch (ARG(1).getType())
		{
		case BVT_OBJECT:
		case BVT_OBJECTREF:
			{
				ARGCMAX(3);
				BppObject* ppos = ARG(1);
				if (!ppos->getClass()->isSubtypeOf(Bp2Size::_className))
					THROW(_T("Invalid argument. SIZE expected"));
				BppValue v;
				if (!interpreter->invokeMember(v,ppos,_T("getW"))) return false;
				w =  v;
				if (!interpreter->invokeMember(v,ppos,_T("getH"))) return false;
				h =  v;
				if (argc == 3)
					repaint = ( ((BppInt) ARG(2)) != 0) ? TRUE : FALSE;
			}
			break;
		default:
		  if (!interpreter->checkType(ARG(1),BVT_NUMBER))
				  return false;
				ARGCMIN(3);
				w =  ARG(1);
				h =  ARG(2);
				if (argc == 4)
					repaint = ( ((BppInt) ARG(3)) != 0) ? TRUE : FALSE;
		}
		RECT rect;
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		bool ok = (hwnd != 0);
		if (ok)
			 ok = (_getWinRect(hwnd,rect) != 0);
		if (ok)
			ok = (MoveWindow(hwnd,rect.left,rect.top,w,h,repaint) != 0);
		*bp = (BppInt) (ok ? 1 : 0);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getWindowRect(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		RECT rect;
		_getWinRect(hwnd,rect);
		BppVector args(4,true);
		args[0] = (BppInt) rect.left;
		args[1] = (BppInt) rect.top;
		args[2] = (BppInt) rect.right;
		args[3] = (BppInt) rect.bottom;
		bool ok =  interpreter->createObject(*bp, Bp2Rect::_className, &args);
		sp = bp;
		return ok;
	}


	bool Bp2WinBase::getClientRect(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		RECT rect;
		_getClientRect(hwnd,rect);
		BppVector args(4,true);
		args[0] = (BppInt) rect.left;
		args[1] = (BppInt) rect.top;
		args[2] = (BppInt) rect.right;
		args[3] = (BppInt) rect.bottom;
		bool ok =  interpreter->createObject(*bp, Bp2Rect::_className, &args);
		sp = bp;
		return ok;
	}

	bool Bp2WinBase::getPosition(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		RECT rect;
		_getWinRect(hwnd,rect);
		BppVector args(2,true);
		args[0] = (BppInt) rect.left;
		args[1] = (BppInt) rect.top;
		bool ok =  interpreter->createObject(*bp, Bp2Point::_className, &args);
		sp = bp;
		return ok;
	}
	bool Bp2WinBase::getClientPos(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		RECT rect;
		_getClientRect(hwnd,rect);
		BppVector args(2,true);
		args[0] = (BppInt) rect.left;
		args[1] = (BppInt) rect.top;
		bool ok =  interpreter->createObject(*bp, Bp2Point::_className, &args);
		sp = bp;
		return ok;
	}

	bool Bp2WinBase::getSize(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		RECT rect;
		_getWinRect(hwnd,rect);
		BppVector args(2,true);
		args[0] = (BppInt) rect.right - rect.left;
		args[1] = (BppInt) rect.bottom - rect.top;
		bool ok =  interpreter->createObject(*bp, Bp2Size::_className, &args);
		sp = bp;
		return ok;
	}

	bool Bp2WinBase::getClientSize(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		RECT rect;
		_getClientRect(hwnd,rect);
		BppVector args(2,true);
		args[0] = (BppInt) rect.right - rect.left;
		args[1] = (BppInt) rect.bottom - rect.top;
		bool ok =  interpreter->createObject(*bp, Bp2Size::_className, &args);
		sp = bp;
		return ok;
	}

	bool Bp2WinBase::getPosX(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		RECT rect;
		_getWinRect(hwnd,rect);
		*bp = (BppInt) rect.left;
		sp = bp;
		return true;
	}
	bool Bp2WinBase::getPosY(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		RECT rect;
		_getWinRect(hwnd,rect);
		*bp = (BppInt) rect.top;
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getClientPosX(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		RECT rect;
		_getClientRect(hwnd,rect);
		*bp = (BppInt) rect.left;
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getClientPosY(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		RECT rect;
		_getClientRect(hwnd,rect);
		*bp = (BppInt) rect.top;
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getWidth(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		RECT rect;
		_getWinRect(hwnd,rect);
		*bp = (BppInt) rect.right - rect.left;
		sp = bp;
		return true;
	}


	bool Bp2WinBase::getHeight(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		RECT rect;
		_getWinRect(hwnd,rect);
		*bp = (BppInt) rect.bottom - rect.top;
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getClientWidth(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		RECT rect;
		_getClientRect(hwnd,rect);
		*bp = (BppInt) rect.right - rect.left;
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getClientHeight(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		RECT rect;
		_getClientRect(hwnd,rect);
		*bp = (BppInt) rect.bottom - rect.top;
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getStyle(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		*bp = (BppInt) GetWindowLong(hwnd,GWL_STYLE);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::hasStyle(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		CHKTYPE(ARG(1),BVT_INTNUMBER);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		BppInt flags = ARG(1);
		*bp = (BppInt) (((GetWindowLong(hwnd,GWL_STYLE) & flags) == flags) ? 1 : 0);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::setStyle(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		CHKTYPE(ARG(1),BVT_INTNUMBER);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		*bp = (BppInt) SetWindowLong(hwnd,GWL_STYLE, (BppInt) ARG(1));
		sp = bp;
		return true;
	}

	bool Bp2WinBase::addStyle(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		CHKTYPE(ARG(1),BVT_INTNUMBER);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		LONG style = GetWindowLong(hwnd,GWL_STYLE);
		style |= (BppInt) ARG(1);
		*bp = (BppInt) SetWindowLong(hwnd,GWL_STYLE, style);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::removeStyle(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		CHKTYPE(ARG(1),BVT_INTNUMBER);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		LONG style = GetWindowLong(hwnd,GWL_STYLE);
		style &= ~((BppInt) ARG(1));
		*bp = (BppInt)SetWindowLong(hwnd, GWL_STYLE, style);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getExtStyle(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		*bp = (BppInt) GetWindowLong(hwnd,GWL_EXSTYLE);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::hasExtStyle(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		CHKTYPE(ARG(1),BVT_INTNUMBER);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		BppInt flags = ARG(1);
		*bp = (BppInt) (((GetWindowLong(hwnd,GWL_EXSTYLE) & flags) == flags) ? 1 : 0);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::setExtStyle(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		CHKTYPE(ARG(1),BVT_INTNUMBER);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		*bp = (BppInt) SetWindowLong(hwnd, GWL_EXSTYLE, (BppInt)ARG(1));
		sp = bp;
		return true;
	}

	bool Bp2WinBase::addExtStyle(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		CHKTYPE(ARG(1),BVT_INTNUMBER);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		LONG style = GetWindowLong(hwnd,GWL_EXSTYLE);
		style |= (BppInt) ARG(1);
		*bp = (BppInt)SetWindowLong(hwnd, GWL_EXSTYLE, style);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::removeExtStyle(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		CHKTYPE(ARG(1),BVT_INTNUMBER);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		LONG style = GetWindowLong(hwnd,GWL_EXSTYLE);
		style &= ~((BppInt) ARG(1));
		*bp = (BppInt)SetWindowLong(hwnd, GWL_EXSTYLE, style);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::isMinimized(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
#ifdef WINCE
		*bp = (BppInt) (IsWindowVisible(hwnd) ? 0 : 1);
#else
		WINDOWPLACEMENT placement;
		placement.length = sizeof(WINDOWPLACEMENT);
		GetWindowPlacement(hwnd,&placement);
		*bp = (BppInt) ((placement.showCmd == SW_SHOWMINIMIZED) ? 1 : 0);
#endif
		sp = bp;
		return true;
	}

	bool Bp2WinBase::isMaximized(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
#ifdef WINCE
		*bp = (BppInt) IsWindowVisible(hwnd);
#else
		WINDOWPLACEMENT placement;
		placement.length = sizeof(WINDOWPLACEMENT);
		GetWindowPlacement(hwnd,&placement);
		*bp = (BppInt) ((placement.showCmd == SW_SHOWMAXIMIZED) ? 1 : 0);
#endif
		sp = bp;
		return true;
	}

	bool Bp2WinBase::isVisible(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
#ifdef WINCE
		*bp = (BppInt) IsWindowVisible(hwnd);
#else
		WINDOWPLACEMENT placement;
		placement.length = sizeof(WINDOWPLACEMENT);
		GetWindowPlacement(hwnd,&placement);
		*bp = (BppInt) ((placement.showCmd != SW_HIDE) ? 1 : 0);
#endif
		sp = bp;
		return true;
	}

	bool Bp2WinBase::minimize(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		*bp = (BppInt) ((ShowWindow(hwnd,SW_MINIMIZE) != 0) ? 1 : 0);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::maximize(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		*bp = (BppInt) ((ShowWindow(hwnd,SW_MAXIMIZE) != 0) ? 1 : 0);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::show(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(1,2);
		int cmdShow = SW_SHOWNORMAL;
		if (argc == 2)
		{
			CHKTYPE(ARG(1),BVT_INTNUMBER);
			cmdShow = (int) (BppInt) ARG(1);
		}
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		*bp = (BppInt) ((ShowWindow(hwnd,cmdShow) != 0) ? 1 : 0);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::restore(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		*bp = (BppInt) ShowWindow(hwnd,SW_RESTORE);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::hide(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		*bp = (BppInt) ShowWindow(hwnd,SW_HIDE);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::preprocessMessage(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		HACCEL haccel = (HACCEL) (BppIntPtr) MEMBER(_haccelIdx);
		if (haccel != 0)
		{
			BppObject* ppos = ARG(1);
			if ((ppos == 0) || (!ppos->getClass()->isSubtypeOf(Bp2Msg::_className)))
				THROW(_T("Invalid argument. MSG expected"));
			BppBuffer* pb = OBJMEMBER(ppos,Bp2Msg::_msgIdx);
			if (pb == 0) THROW(_T("Invalid data (msg)"));
			MSG* pmsg = (MSG*) pb->data();
			HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
			if (TranslateAccelerator(hwnd,haccel,pmsg))
			{
				*bp = (BppInt) 1;
				sp = bp;
				return true;
			}
		}
		BppValue val;
		if (!interpreter->invokeMember(val,pThis,_T("getParent"))) return false;
		BppObject* pparent = val;
		if (pparent != 0)
		{
			BppVector argvec(1,true);
			argvec[0] = ARG(1);
			val.dispose();
			if (!interpreter->invokeMember(val,pparent,_T("preprocessMessage"),&argvec)) return false;
			if ((BppInt) val != 0)
			{
				*bp = (BppInt) 1;
				sp = bp;
				return true;
			}
		}
		*bp = (BppInt) 0;
		sp = bp;
		return true;
	}

	// int handleMessage(int hwnd, int msgId, int wParam, int lParam);

	bool Bp2WinBase::handleMessage(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(5,5);
		BppVector* handlerList = MEMBER(_handlerListIdx);
		if (handlerList != 0)
		{
			unsigned n = handlerList->size();
			if (n > 0)
			{
				BppVector args(5,true);
				args[0] = pThis;
				args[1] = ARG(1);
				args[2] = ARG(2);
				args[3] = ARG(3);
				args[4] = ARG(4);
				BppValue val;
				for (unsigned i=0;i<n;++i)
				{
					BppObject* phandler = (*handlerList)[i];
					if (phandler != 0)
					{
						if (!interpreter->invokeMember(val,phandler,_T("handleMessage"),&args)) return false;
						if (FALSE == (BppIntPtr) val)
						{
							*bp = val;
							sp = bp;
							return true;
						}
					}
				} // for i
			} // if n>0
		} // end if handlerList
	  // TODO: x64-Anpassung (mehrfach!)
		HWND hwnd = (HWND) (BppIntPtr) ARG(1);
		UINT msg = (UINT) (BppUInt) ARG(2);
		WPARAM wParam = (WPARAM) (BppIntPtr) ARG(3);
		LPARAM lParam = (LPARAM) (BppIntPtr) ARG(4);
		if (hwnd == (HWND) (BppIntPtr) MEMBER(_hwndIdx))
		{
			switch (msg)
			{
			case WM_DESTROY:
				{
					HBRUSH backBrush = (HBRUSH) (BppIntPtr) MEMBER(_backBrushIdx);
					if (backBrush != 0)
					{
						DeleteObject(backBrush);
						MEMBER(_backBrushIdx) = (BppInt) 0;
					}
				}
				break;
			case WM_ERASEBKGND:
				{
					HBRUSH backBrush = (HBRUSH) (BppIntPtr) MEMBER(_backBrushIdx);
					if (backBrush != 0)
					{
						RECT rc;
						HDC hdc = (HDC) wParam;
						GetClientRect(hwnd, &rc);
#ifndef WINCE
						SetMapMode(hdc, MM_TEXT);
#endif
						FillRect(hdc, &rc, backBrush);
						*bp = (BppIntPtr) FALSE;
						sp = bp;
						return true;
					}
				}
				break;
			case WM_SIZE:
				{
					if (0 != (BppInt) MEMBER(_useVirtualSizeIdx))
					{
						BppObject* robj = MEMBER(_virtualRectIdx);
						if (robj == 0) THROW(_T("Invalid object structure. RECT expected"));
						BppBuffer* pb = OBJMEMBER(robj,Bp2Rect::_rectIdx);
						if (pb == 0) THROW(_T("Invalid data (_virtualRect)"));
						RECT* pRect = (RECT*) pb->data();
						int d;
						int w = LOWORD(lParam);
						int h = HIWORD(lParam);
						if (w > pRect->right)
						{
							int vw = pRect->right - pRect->left;
							if (w >= vw)
							{
								d = -pRect->left;
							}
							else
							{
								d = w - pRect->right;
							}
							if (d != 0)
							{
								BppVector args(1,true);
								BppValue val;
								args[0] = (BppInt) d;
								if (!interpreter->invokeMember(val,pThis,_T("scrollHorizontal"),&args)) return false;;
								break;
							}
						}
						if (h > pRect->bottom)
						{
							int vh = pRect->bottom - pRect->top;
							if (h >= vh)
							{
								d = -pRect->top;
							}
							else
							{
								d = h - pRect->bottom;
							}
							if (d != 0)
							{
								BppVector args(1,true);
								BppValue val;
								args[0] = (BppInt) d;
								if (!interpreter->invokeMember(val,pThis,_T("scrollVertical"),&args)) return false;;
								break;
							}
						} // end h
						BppValue val;
						if (!interpreter->invokeMember(val,pThis,_T("applyScrollBars"))) return false;
					} // end useVirtualSize
				} // end WM_SIZE
				break;
			case WM_VSCROLL:
			case WM_HSCROLL:
				{
					if (0 != (BppInt) MEMBER(_useVirtualSizeIdx))
					{
						WORD cmd = LOWORD(wParam);
						bool ishor = (msg == WM_HSCROLL);
						const BppChar* scrollfunc = ishor ? _T("scrollHorizontal") : _T("scrollVertical");
						RECT rect;
						_getClientRect(hwnd,rect);
						BppInt w = rect.right - rect.left;
						BppInt h = rect.bottom - rect.top;
						BppInt sx = MEMBER(_sxIdx);
						BppInt sy = MEMBER(_syIdx);
						BppVector args(1,true);
						BppValue val;
						switch (cmd)
						{
						case SB_LINEUP:
							args[0] = ishor ? sx : sy;
							if (!interpreter->invokeMember(val,pThis,scrollfunc,&args)) return false;;
							break;
						case SB_LINEDOWN:
							args[0] = ishor ? -sx : -sy;
							if (!interpreter->invokeMember(val,pThis,scrollfunc,&args)) return false;;
							break;
						case SB_PAGEUP:
							args[0] = ishor ? w : h;
							if (!interpreter->invokeMember(val,pThis,scrollfunc,&args)) return false;;
							break;
						case SB_PAGEDOWN:
							args[0] = ishor ? -w : -h;
							if (!interpreter->invokeMember(val,pThis,scrollfunc,&args)) return false;;
							break;
						case SB_THUMBTRACK:
							if (0 == (BppInt) MEMBER(_lifeScrollIdx)) break;
						case SB_THUMBPOSITION:
							{
								SCROLLINFO si;
								si.cbSize = sizeof(SCROLLINFO);
								si.fMask = SIF_TRACKPOS | SIF_POS;
								if (ishor)
								{
									GetScrollInfo(hwnd,SB_HORZ,&si);
									BppInt offset = si.nPos-si.nTrackPos;
									if ((cmd == SB_THUMBTRACK) && (abs(offset) < abs(sx))) break;
									args[0] = offset;
									if (!interpreter->invokeMember(val,pThis,scrollfunc,&args)) return false;;
								}
								else
								{
									GetScrollInfo(hwnd,SB_VERT,&si);
									BppInt offset = si.nPos-si.nTrackPos;
									if ((cmd == SB_THUMBTRACK) && (abs(offset) < abs(sy))) break;
									args[0] = offset;
									if (!interpreter->invokeMember(val,pThis,scrollfunc,&args)) return false;;
								}
							}
							break;
						} // end switch (cmd)
					} // end useVirtualSize
				} // end WM_V(H)SCROLL
				break;
			} // end switch msg
		} // end if hwnd
		WNDPROC savedWndProc = (WNDPROC) (BppIntPtr) MEMBER(_savedWndProcIdx);
		if (savedWndProc != 0)
			*bp = (BppIntPtr) CallWindowProc(savedWndProc,hwnd,msg,wParam,lParam);
		else
			*bp = (BppIntPtr) DefWindowProc(hwnd,msg,wParam,lParam);
		sp = bp;
		return true;
	}


	bool Bp2WinBase::addMsgHandler(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,3);
		BppObject* phandler = ARG(1);
		if ((phandler == 0) || (!phandler->getClass()->isSubtypeOf(Bp2WinMsgHandler::_className)))
			THROW(_T("Invalid argument. Message handler expected"));
		BppVector* handlerList = MEMBER(_handlerListIdx);
		if (handlerList == 0) THROW(_T("Invalid Object. Message handler list missing."));
		unsigned n = handlerList->size();
		for (unsigned i=0;i<n;++i)
		{
			if ((BppObject*) (*handlerList)[i] == phandler) // handler already in list
			{
				*bp = BppValue::makeBool(false);
				sp = bp;
				return true;
			}
		}
		if ((BppObject*) OBJMEMBER(phandler,Bp2WinMsgHandler::_hdlOwnerIdx) == 0)
		{
			BppVector args(1,true);
			args[0] = BppValue(pThis,true);
			BppValue val;
			if (!interpreter->invokeMember(val,phandler,_T("setOwner"),&args)) return false;
		}
		bool atStart = (argc == 3) ? ARG(2).asBool() : false;
		if (atStart) handlerList->push_front(phandler);
		else handlerList->push_back(phandler);
		*bp = BppValue::makeBool(true);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::removeMsgHandler(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		BppObject* phandler = ARG(1);
		if ((phandler == 0) || (!phandler->getClass()->isSubtypeOf(Bp2WinMsgHandler::_className)))
			THROW(_T("Invalid argument. Message handler expected"));
		BppVector* handlerList = MEMBER(_handlerListIdx);
		if (handlerList == 0) THROW(_T("Invalid Object. Message handler list missing."));
		unsigned n = handlerList->size();
		for (unsigned i=0;i<n;++i)
		{
			if ((BppObject*) (*handlerList)[i] == phandler) // handler found in list
			{
				for (unsigned j=i;j<n-1;++j)
					(*handlerList)[j] = (*handlerList)[j+1];
				handlerList->pop_back();
				*bp = BppValue::makeBool(true);
				sp = bp;
				return true;
			}
		}
		*bp = BppValue::makeBool(false);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::removeAllMsgHandlers(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		BppVector* handlerList = MEMBER(_handlerListIdx);
		if (handlerList == 0) THROW(_T("Invalid Object. Message handler list missing."));
		handlerList->clear();
		bp->dispose();
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getAcceleratorArray(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		*bp = MEMBER(_accelArrayIdx);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::addAccelerator(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(3,4);
		BppVector* accelArray = MEMBER(_accelArrayIdx);
		if (accelArray == 0) THROW(_T("Invalid Object. Accelerator array missing."));
		BppVector args(argc-1);
		for (int i=1;i<argc;++i) args.push_back(ARG(i));
		BppValue val;
		if (!interpreter->createObject(val,Bp2Accel::_className,&args)) return false;
		accelArray->push_back(val);
		BppValue val2;
		if (!interpreter->invokeMember(val2,pThis,_T("applyAccelerators"))) return false;
		*bp = val2;
		sp = bp;
		return true;
	}

	bool Bp2WinBase::applyAccelerators(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		BppVector* accelArray = MEMBER(_accelArrayIdx);
		if (accelArray == 0) THROW(_T("Invalid Object. Accelerator array missing."));
		HACCEL haccel = (HACCEL) (BppIntPtr) MEMBER(_haccelIdx);
		if (haccel != 0)
		{
			 DestroyAcceleratorTable(haccel);
			 haccel = 0;
		}
		unsigned n = accelArray->size();
		if (n > 0)
		{
			ACCEL* paccel = new ACCEL[n];
			for (unsigned i=0;i<n;++i)
			{
				memset(&paccel[i], 0, sizeof(ACCEL));// = 0;
				BppObject* pobj = (*accelArray)[i];
				if (pobj != 0)
				{
					BppBuffer* pb = OBJMEMBER(pobj,Bp2Accel::_accelIdx);
					if (pb != 0)
					{
						paccel[i] = *((ACCEL*) pb->data());
					}
				}
			}
			haccel = CreateAcceleratorTable(paccel,n);
			delete [] paccel;
		}
		MEMBER(_haccelIdx) = (BppIntPtr) haccel;
		bp->dispose();
		sp = bp;
		return true;
	}

	bool Bp2WinBase::registerWindow(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKARGC(1,1);
		ValPtr bp = sp; bp -= argc;
		BppObject* pwin = ARG(0);
		if (pwin == 0)
			THROW(_T("Invalid argument. Object expected."));
		if (!pwin->getClass()->isSubtypeOf(_className))
			THROW(_T("Invalid argument. Window expected."));
		BppValue result;
		if (!interpreter->invokeMember(result,pwin,_T("getHandle")))
			return false;
		HWND hwnd = (HWND) (BppIntPtr) result;
		bool ok = (hwnd != 0);
		if (ok)
			ok = (_winMap.insert(hwnd,pwin) >= 0);
		*bp = BppValue::makeBool(ok);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::unregisterWindow(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKARGC(1,1);
		ValPtr bp = sp; bp -= argc;
		HWND hwnd = (HWND) (BppIntPtr) ARG(0);
		*bp = BppValue::makeBool(_winMap.erase(hwnd));
		sp = bp;
		return true;
	}

	bool Bp2WinBase::findWindow(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKARGC(1,1);
		ValPtr bp = sp; bp -= argc;
		HWND hwnd = (HWND) (BppIntPtr) ARG(0);
		HwndTableEntry* pentry = _winMap.find(hwnd);
		if (pentry != 0)
			*bp = pentry->pwin;
		else
			*bp = BppValue();
		sp = bp;
		return true;
	}

	bool Bp2WinBase::forceQuit(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		ARGCMAX(0);
		BppDictionaryEntry* pclassentry = vm->classes().find(_className);
		BppClass* pclass = (pclassentry != 0) ? pclassentry->getValue() : (BppClass*)0;
		if (pclass == 0)
			THROW(BppString::format(_T("Class %s not found."),_className.c_str()).c_str());
		BppDictionaryEntry* pmember = pclass->findOwnMember(_returnCodeNm);
		if (pmember == 0)
			THROW(BppString::format(_T("Member %s::%s not found."),_className.c_str(),_returnCodeNm.c_str()).c_str());
		PostQuitMessage((int) (BppInt) pmember->getValue());
		sp->dispose();
		return true;
	}

	bool Bp2WinBase::setAutoQuit(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKARGC(1,1);
		ValPtr bp = sp; bp -= argc;
		CHKTYPE(ARG(0),BVT_INTNUMBER);
		BppDictionaryEntry* pclassentry = vm->classes().find(_className);
		BppClass* pclass = (pclassentry != 0) ? pclassentry->getValue() : (BppClass*) 0;
		if (pclass == 0)
			THROW(BppString::format(_T("Class %s not found."),_className.c_str()).c_str());
		BppDictionaryEntry* pmember = pclass->findOwnMember(_autoQuitNm);
		if (pmember == 0)
			THROW(BppString::format(_T("Member %s::%s not found."),_className.c_str(),_autoQuitNm.c_str()).c_str());
		pmember->setValue((BppInt)ARG(0));
		bp->dispose();
		sp = bp;
		return true;
	}

	bool Bp2WinBase::setReturnCode(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKARGC(1,1);
		ValPtr bp = sp; bp -= argc;
		CHKTYPE(ARG(0),BVT_INTNUMBER);
		BppDictionaryEntry* pclassentry = vm->classes().find(_className);
		BppClass* pclass = (pclassentry != 0) ? pclassentry->getValue() : (BppClass*) 0;
		if (pclass == 0)
			THROW(BppString::format(_T("Class %s not found."),_className.c_str()).c_str());
		BppDictionaryEntry* pmember = pclass->findOwnMember(_returnCodeNm);
		if (pmember == 0)
			THROW(BppString::format(_T("Member %s::%s not found."),_className.c_str(),_returnCodeNm.c_str()).c_str());
		pmember->setValue(ARG(0));
		bp->dispose();
		sp = bp;
		return true;
	}

	bool Bp2WinBase::setWindowText(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		BppString* pstr = interpreter->getStringFromValueExtern(ARG(1));
		if (pstr == 0)
			return interpreter->badType(ARG(1).getType(),BVT_STRING);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		*bp = BppValue::makeBool(SetWindowText(hwnd,pstr->c_str()));
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getWindowText(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		int l = GetWindowTextLength(hwnd);
		if (l == 0)
		{
			*bp = new BppString();
		}
		else
		{
			BppChar* pbuf = new BppChar[l+1];
			GetWindowText(hwnd,pbuf,l+1);
			*bp = new BppString((const BppChar*) pbuf);
			delete [] pbuf;
		}
		sp = bp;
		return true;
	}

	bool Bp2WinBase::setBackgroundColor(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		CHKTYPE(ARG(1),BVT_INTNUMBER);
		BppUInt l = ARG(1);
		HBRUSH hbrush = 0;
		if ((l & 0xFFFFFF) == l)
		{
			hbrush = CreateSolidBrush((COLORREF) l);
		}
		if (hbrush != 0)
		{
			BppValue result;
			BppVector args;
			args.push_back((BppIntPtr) hbrush);
			if (!interpreter->invokeMember(result,pThis,_T("setBackgroundBrush"),&args))
			{
				DeleteObject(hbrush);
				return false;
			}
			bool ok = result.asBool();
			if (ok) MEMBER(_backColorIdx) = l;
			else DeleteObject(hbrush);
			*bp = result;
		}
		else
			*bp = BppValue::makeBool(false);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::setBackgroundBrush(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		CHKTYPE(ARG(1),BVT_PTRTYPE);
		HBRUSH hbrush = (HBRUSH) (BppIntPtr) ARG(1);
		if (hbrush == 0)
		{
			*bp = BppValue::makeBool(false);
			sp = bp;
			return true;
		}
		HBRUSH curBrush = (HBRUSH) (BppIntPtr) MEMBER(_backBrushIdx);
		if (hbrush != curBrush)
		{
			if (curBrush != 0)
			  DeleteObject(curBrush);
			MEMBER(_backBrushIdx) = (BppIntPtr) hbrush;
			HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
			if (hwnd != 0)
			{
				RECT rc;
				GetClientRect(hwnd, &rc);
				InvalidateRect(hwnd,&rc,TRUE);
				UpdateWindow(hwnd);
			}
		}
		*bp = BppValue::makeBool(true);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::setForegroundColor(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		CHKTYPE(ARG(1),BVT_INTNUMBER);
		BppUInt l = ARG(1);
		if ((l & 0xFFFFFF) == l)
		{
			MEMBER(_foreColorIdx) = l;
			*bp = (BppInt) 1;
		}
		else
			*bp = (BppInt) 0;
		sp = bp;
		return true;
	}

	bool Bp2WinBase::mainLoop(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		ARGCMAX(0);
		BppVector args(1,true);
		if (!interpreter->createObject(args[0],Bp2Msg::_className))
			return false;
		BppObject* msgObj = args[0];
		BppValue msgVal;
		if(!interpreter->invokeMember(msgVal,msgObj,_T("ptr")))
			return false;
		MSG* pmsg = (MSG*) (BppIntPtr) msgVal; // pmsg points to MSG structure in args[0]
		if (pmsg == 0)
			THROW(_T("Invalid message object."));

		MSG msg;
		int status;
		while ((status = GetMessage(&msg, NULL, 0, 0)))
		{
			if (vm->isInDbg())
				continue;
			if (status == -1)
				break;

			BppObject* pwin = 0;
			if (_winMap.empty()) break;

			HwndTableEntry* pentry = _winMap.find(msg.hwnd);
			if (pentry != 0)
				pwin = pentry->pwin;
			if (pwin != 0)
			{
				*pmsg = msg;
				if (!interpreter->invokeMember(msgVal,pwin,_T("preprocessMessage"),&args))
					return false;
				if (((BppIntPtr) msgVal) != 0)
					continue;
			}
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		BppDictionaryEntry* pclassentry = vm->classes().find(_className);
		BppClass* pclass = (pclassentry != 0) ? pclassentry->getValue() : (BppClass*)0;
		if (pclass == 0)
			THROW(BppString::format(_T("Class %s not found."), _className.c_str()).c_str());
		BppDictionaryEntry* prc = pclass->findOwnMember(_returnCodeNm);
		if (prc == 0) THROW(_T("Class not initialized."));
		(*sp) = prc->getValue();
		return true;
	}

	bool Bp2WinBase::setHInstance(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKARGC(1,1);
		ValPtr bp = sp; bp -= argc;
		CHKTYPE(ARG(0),BVT_PTRTYPE);
		setHInstance((HINSTANCE) (BppIntPtr) ARG(0));
		bp->dispose();
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getHInstance(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKARGC(0,0);
		(*sp) = (BppIntPtr) getHInstance();
		return true;
	}

	bool Bp2WinBase::createID(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKARGC(0,0);
		BppDictionaryEntry* pclassentry = vm->classes().find(_className);
		BppClass* pclass = (pclassentry != 0) ? pclassentry->getValue() : (BppClass*)0;
		if (pclass == 0)
			THROW(BppString::format(_T("Class %s not found."),_className.c_str()).c_str());
		BppDictionaryEntry* pmid = pclass->findOwnMember(_maxIDNm);
		if (pmid == 0) THROW(_T("Class not initialized."));
		BppInt maxid = pmid->getValue();
		(*sp) = ++maxid;
		pmid->setValue(maxid);
		return true;
	}

	bool Bp2WinBase::enableVirtualSize(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		CHKTYPE(ARG(1),BVT_INTNUMBER);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		bool ok = (hwnd != 0);
		if (ok)
		{
			bool enable = ARG(1).asBool();
			bool usevsize = ((BppInt)MEMBER(_useVirtualSizeIdx)) != 0;
			if (enable != usevsize)
			{
				RECT rect;
				ok = (_getClientRect(hwnd,rect) != 0);
				if (ok)
				{
					BppObject* pvrect = MEMBER(_virtualRectIdx);
					ok = pvrect != 0;
					if (ok)
					{
						BppValue result;
						if(!interpreter->invokeMember(result,pvrect,_T("ptr")))
							return false;
						RECT* vrect = (RECT*) (BppIntPtr) result;
						ok = (vrect != 0);
						if (ok)
						{
							vrect->left = 0;
							vrect->top = 0;
							vrect->right = rect.right - rect.left;
							vrect->bottom = rect.bottom - rect.top;
							MEMBER(_useVirtualSizeIdx) = enable ? 1 : 0;
							if(!interpreter->invokeMember(result,pThis,_T("applyScrollBars")))
								return false;
						}
					}
				}
			}
		}
		(*bp) = BppValue::makeBool(ok);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::setLifeScroll(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		CHKTYPE(ARG(1),BVT_INTNUMBER);
		MEMBER(_lifeScrollIdx) = ARG(1);
		bp->dispose();
		sp = bp;
		return true;
	}

	bool Bp2WinBase::setVirtualSize(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,3);
		bool ok = ((BppInt) MEMBER(_useVirtualSizeIdx)) != 0;
		if (ok)
		{
			BppInt width, height;
			if (argc == 2)
			{
				 BppObject* pobj = ARG(1);
				 if (pobj == 0)
					 THROW(_T("Invalid argument. SIZE expected."));
				 BppValue result;
				 if(!interpreter->invokeMember(result,pobj,_T("ptr")))
					 return false;
				 SIZE* psize = (SIZE*) (BppIntPtr) result;
				 ok = (psize != 0);
				 if (ok)
				 {
					 width = psize->cx;
					 height = psize->cy;
				 }
			}
			else
			{
				width = ARG(1);
				height = ARG(2);
			}
			if (ok)
			{
				BppObject* pvrect = MEMBER(_virtualRectIdx);
				ok = pvrect != 0;
				if (ok)
				{
					BppValue result;
					if(!interpreter->invokeMember(result,pvrect,_T("ptr")))
						return false;
					RECT* vrect = (RECT*) (BppIntPtr) result;
					ok = (vrect != 0);
					if (ok)
					{
						vrect->right = vrect->left + width;
						vrect->bottom = vrect->top + height;
						if(!interpreter->invokeMember(result,pThis,_T("applyScrollBars")))
							return false;
					}
				}
			}
		}
		(*bp) = BppValue::makeBool(ok);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getVirtualSize(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		BppObject* pvrect = MEMBER(_virtualRectIdx);
		if (pvrect == 0) THROW(_T("Object not initialized."));
		BppValue result;
		if(!interpreter->invokeMember(result,pvrect,_T("ptr")))
			return false;
		RECT* vrect = (RECT*) (BppIntPtr) result;
		BppVector args(2,true);
		args[0] = (BppInt)(vrect->right - vrect->left);
		args[1] = (BppInt) (vrect->bottom - vrect->top);
		bool ok =  interpreter->createObject(*bp, Bp2Size::_className, &args);
		sp = bp;
		return ok;
	}

	bool Bp2WinBase::fitVirtualSizeToContents(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(1,2);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		bool ok = ((hwnd != 0) && (((BppInt) MEMBER(_useVirtualSizeIdx)) != 0));
		if (ok)
		{
			BppInt borderWidth = (argc == 1) ? 0 : ARG(1);
			if (borderWidth < 0) borderWidth = 0;
			BppValue vecval;
			if(!interpreter->invokeMember(vecval,pThis,_T("getChildrenHandles")))
			  return false;
			BppVector* cvec = vecval;
			unsigned n = cvec->size();
			ok = (n > 0);
			if (ok)
			{
				BppObject* pvrect = MEMBER(_virtualRectIdx);
				if (pvrect == 0) THROW(_T("Object not initialized."));
				BppValue result;
				if(!interpreter->invokeMember(result,pvrect,_T("ptr")))
					return false;
				RECT* vrect = (RECT*) (BppIntPtr) result;
				ok = (vrect != 0);
				if (ok)
				{
					BppInt ox =  vrect->left;
					BppInt oy =  vrect->top;
					BppVector singleArg(1,true);
					BppValue tmp;
					if (ox != 0)
					{
						singleArg[0] = -ox;
						if(!interpreter->invokeMember(tmp,pThis,_T("scrollHorizontal"),&singleArg))
							return false;
					}
					if (oy != 0)
					{
						singleArg[0] = -oy;
						if(!interpreter->invokeMember(tmp,pThis,_T("scrollVertical"),&singleArg))
							return false;
					}
					vrect->bottom = vrect->top = vrect->left = vrect->right = 0;
					for (unsigned i=0;i<n;++i)
					{
						HWND chwnd = (HWND) (BppIntPtr) (*cvec)[i];
						RECT r;
						if (GetWindowRect(chwnd,&r))
						{
							POINT p;
							p.x = r.left; p.y = r.top;
							ScreenToClient(hwnd,&p);
							r.left = p.x; r.top = p.y;
							p.x = r.right; p.y = r.bottom;
							ScreenToClient(hwnd,&p);
							r.right = p.x; r.bottom = p.y;
							if (r.left < vrect->left) vrect->left = r.left;
							if (r.right > vrect->right) vrect->right = r.right;
							if (r.top < vrect->top) vrect->top = r.top;
							if (r.bottom > vrect->bottom) vrect->bottom = r.bottom;
						}
					} // end for
					vrect->right += borderWidth;
					vrect->bottom += borderWidth;
					RECT crect;
					_getClientRect(hwnd,crect);
					BppInt cw = crect.right - crect.left;
					BppInt ch = crect.bottom - crect.top;
					if (vrect->right < cw)
					{
						singleArg[0] = cw - vrect->right;
						if (!interpreter->invokeMember(tmp,pThis,_T("scrollHorizontal"),&singleArg))
							return false;
					}
					if (vrect->bottom < ch)
					{
						singleArg[0] = ch - vrect->bottom;
						if (!interpreter->invokeMember(tmp,pThis,_T("scrollVertical"),&singleArg))
							return false;
					}
					if (!interpreter->invokeMember(tmp,pThis,_T("applyScrollBars")))
						return false;
				}
			}
		}
		(*bp) = BppValue::makeBool(ok);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getVirtualOrigin(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		BppObject* pvrect = MEMBER(_virtualRectIdx);
		if (pvrect == 0) THROW(_T("Object not initialized."));
		BppValue result;
		if(!interpreter->invokeMember(result,pvrect,_T("ptr")))
			return false;
		RECT* vrect = (RECT*) (BppIntPtr) result;
		BppVector args(2,true);
		args[0] = (BppInt) vrect->left;
		args[1] = (BppInt) vrect->top;
		bool ok =  interpreter->createObject(*bp, Bp2Point::_className, &args);
		sp = bp;
		return ok;
	}

	bool Bp2WinBase::scrollHorizontal(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		bool ok = ((hwnd != 0) && (((BppInt) MEMBER(_useVirtualSizeIdx)) != 0));
		if (ok)
		{
			BppObject* pvrect = MEMBER(_virtualRectIdx);
			if (pvrect == 0) THROW(_T("Object not initialized."));
			BppValue result;
			if(!interpreter->invokeMember(result,pvrect,_T("ptr")))
				return false;
			RECT* vrect = (RECT*) (BppIntPtr)result;
			RECT crect;
			_getClientRect(hwnd,crect);
			BppInt w = crect.right - crect.left;
			// long h = crect.bottom - crect.top;
			BppInt offset = ARG(1);

			if (offset < 0) // scroll left
			{
				BppInt minoffs = -(vrect->right -   w);
				if (minoffs > offset)
					offset = minoffs;
			}
			else // scroll right
			{
				BppInt maxoffs = - vrect->left;
				if (offset > maxoffs)
					offset = maxoffs;
			}
			ScrollWindowEx(hwnd,offset,0,0,0,0,0,SW_ERASE|SW_INVALIDATE|SW_SCROLLCHILDREN);
			vrect->left += offset;
			vrect->right += offset;
			BppValue tmp;
			if (!interpreter->invokeMember(tmp,pThis,_T("applyScrollBars")))
				return false;
#ifdef WINCE
		 InvalidateRect(hwnd,0,TRUE);
#else
			InvalidateRgn(hwnd,0,TRUE);
#endif
			UpdateWindow(hwnd);
			(*bp) = offset;
		}
		else
			(*bp) = (BppInt) 0;
		sp = bp;
		return true;
	}

	bool Bp2WinBase::scrollVertical(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		bool ok = ((hwnd != 0) && (((BppInt) MEMBER(_useVirtualSizeIdx)) != 0));
		if (ok)
		{
			BppObject* pvrect = MEMBER(_virtualRectIdx);
			if (pvrect == 0) THROW(_T("Object not initialized."));
			BppValue result;
			if(!interpreter->invokeMember(result,pvrect,_T("ptr")))
				return false;
			RECT* vrect = (RECT*) (BppIntPtr) result;
			RECT crect;
			_getClientRect(hwnd,crect);
			// long w = crect.right - crect.left;
			BppInt h = crect.bottom - crect.top;
			BppInt offset = ARG(1);

			if (offset < 0) // scroll left
			{
				BppInt minoffs = -(vrect->bottom -  h);
				if (minoffs > offset)
					offset = minoffs;
			}
			else // scroll right
			{
				BppInt maxoffs = - vrect->top;
				if (offset > maxoffs)
					offset = maxoffs;
			}
			ScrollWindowEx(hwnd,0,offset,0,0,0,0,SW_ERASE|SW_INVALIDATE|SW_SCROLLCHILDREN);
			vrect->top += offset;
			vrect->bottom += offset;
			BppValue tmp;
			if (!interpreter->invokeMember(tmp,pThis,_T("applyScrollBars")))
				return false;
#ifdef WINCE
		 InvalidateRect(hwnd,0,TRUE);
#else
			InvalidateRgn(hwnd,0,TRUE);
#endif
			UpdateWindow(hwnd);
			(*bp) = offset;
		}
		else
			(*bp) = (BppInt) 0;
		sp = bp;
		return true;
	}

	enum ScrollBarMode
	{
		SbNone = 0,
		SbVertical = 1,
		SbHorizontal= 2,
		SbBoth = SbVertical | SbHorizontal,
		SbAuto = 4
	};
#ifdef WINCE
	BOOL ShowScrollBar(HWND hWnd,int wBar,BOOL bShow)
	{
		DWORD dwStyle = GetWindowLong(hWnd, GWL_STYLE);
		 DWORD flags = 0;
		switch (wBar)
		{
		case SB_VERT:
			flags = WS_VSCROLL;
			break;
		case SB_HORZ:
			flags = WS_HSCROLL;
			break;
		case  SB_BOTH:
			flags = WS_VSCROLL | WS_HSCROLL;
			break;
		default:
			return FALSE;
		}
		if (bShow)
		{
			 SetWindowLong(hWnd, GWL_STYLE, dwStyle | flags);	   
		}
		else
		{
			 SetWindowLong(hWnd, GWL_STYLE, dwStyle & (~flags));	   
		}
		return TRUE;
	}
#endif

	bool Bp2WinBase::setScrollBarMode(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(2,2);
		CHKTYPE(ARG(1),BVT_INTNUMBER);
		BppInt sbmode = MEMBER(_scrollBarModeIdx);
		BppUInt newmode = ARG(1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		bool ok = hwnd && newmode <= SbAuto;
		if (sbmode != newmode)
		{
			if (ok)
			{
				ok = true;
				MEMBER(_scrollBarModeIdx) = (BppInt) newmode;
				switch (newmode)
				{
				case SbNone:
					ShowScrollBar(hwnd,SB_BOTH,FALSE);
					break;
				case SbVertical:
					ShowScrollBar(hwnd,SB_VERT,TRUE);
					ShowScrollBar(hwnd,SB_HORZ,FALSE);
					break;
				case SbHorizontal:
					ShowScrollBar(hwnd,SB_VERT,FALSE);
					ShowScrollBar(hwnd,SB_HORZ,TRUE);
					break;
				case SbBoth:
					ShowScrollBar(hwnd,SB_BOTH,TRUE);
					break;
				default:
					if (((BppInt)MEMBER(_useVirtualSizeIdx)) == 0)
						ShowScrollBar(hwnd, SB_BOTH, FALSE);
				}
			}
		}
		BppValue tmp;
		if (!interpreter->invokeMember(tmp,pThis,_T("applyScrollBars")))
			return false;
		*bp = BppValue::makeBool(ok);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::setScrollSteps(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(1,3);
		BppInt sx = 10;
		BppInt sy = 10;
		if (argc == 3)
			sy = ARG(2);
		if (argc > 1)
			sx = ARG(1);
		MEMBER(_sxIdx) = sx;
		MEMBER(_syIdx) = sy;
		bp->dispose();
		sp = bp;
		return true;
	}

	bool Bp2WinBase::getScrollBarMode(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(1,1);
		*bp = (BppUInt) MEMBER(_scrollBarModeIdx);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::applyScrollBars(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKOBJECT;
		CHKARGC(1,1);
		HWND hwnd = (HWND) (BppIntPtr) MEMBER(_hwndIdx);
		if (hwnd != 0)
		{
			if (0 == (BppInt) MEMBER(_useVirtualSizeIdx))
			{
				ShowScrollBar(hwnd,SB_BOTH,FALSE);
			}
			else
			{
				BppValue tmp;
				if (!interpreter->invokeMember(tmp,pThis,_T("getClientSize")))
					return false;
				BppObject* pobj = tmp;
				BppValue tmp2;
				if (!interpreter->invokeMember(tmp2,pobj,_T("ptr")))
					return false;
				SIZE* psz = (SIZE*) (BppIntPtr) tmp2;
				BppInt w = psz->cx;
				BppInt h = psz->cy;
				if (!interpreter->invokeMember(tmp,pThis,_T("getVirtualSize")))
					return false;
				pobj = tmp;
				if (!interpreter->invokeMember(tmp2,pobj,_T("ptr")))
					return false;
				psz = (SIZE*) (BppIntPtr) tmp2;
				BppInt vw = psz->cx;
				BppInt vh = psz->cy;
				BppInt scrollBarMode = MEMBER(_scrollBarModeIdx);
				BppObject* pvrect = MEMBER(_virtualRectIdx);
				if(!interpreter->invokeMember(tmp,pvrect,_T("ptr")))
					return false;
				RECT* vrect = (RECT*) (BppIntPtr) tmp;

				if (scrollBarMode == SbAuto)
				{
					BOOL shwH = ((vw > w) || (vrect->left < 0)) ? TRUE : FALSE;
					BOOL shwV = ((vh > h) || (vrect->top < 0)) ? TRUE : FALSE;
					if (shwH == shwV)
						ShowScrollBar(hwnd,SB_BOTH,shwH);
					else
					{
						ShowScrollBar(hwnd,SB_HORZ,shwH);
						ShowScrollBar(hwnd,SB_VERT,shwV);
					}
				}
				SCROLLINFO si;
				si.cbSize = sizeof(SCROLLINFO);
				si.fMask = SIF_ALL;
				if (GetScrollInfo(hwnd, SB_HORZ, &si))
				{
					si.nMin = 0;
					si.nMax = (int) vw;
					si.nPage = w;
					si.nPos = 0;
					if (vw > w)
					{
						si.nPos = (int) ( ((double)(-vrect->left)) /
							((double)(vw-w))  * vw);
					}
					SetScrollInfo(hwnd,SB_HORZ,&si,TRUE);
				}
				if (GetScrollInfo(hwnd, SB_VERT, &si))
				{
					si.nMin = 0;
					si.nMax = (int) vh;
					si.nPage = h;
					si.nPos = 0;
					if (vh > h)
					{
						si.nPos = (int) ( ((double)(-vrect->top)) /
							((double)(vh-h))  * vh);
					}
					SetScrollInfo(hwnd,SB_VERT,&si,TRUE);
				}
			}
		}
		bp->dispose();
		sp = bp;
		return true;
	}

	bool Bp2WinBase::beginPaint(BppVirtualMachine * vm, int argc, ValPtr & sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND)(BppIntPtr)MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		PAINTSTRUCT* ps = (PAINTSTRUCT*)(BppIntPtr)MEMBER(_paintStructIdx);
		if (!ps) {
			ps = new PAINTSTRUCT;
			MEMBER(_paintStructIdx) = (BppIntPtr)ps;
		}
		*bp = (BppIntPtr)BeginPaint(hwnd, ps);
		sp = bp;
		return true;
	}

	bool Bp2WinBase::endPaint(BppVirtualMachine * vm, int argc, ValPtr & sp)
	{
		CHKVM;
		CHKOBJECT;
		ARGCMAX(1);
		HWND hwnd = (HWND)(BppIntPtr)MEMBER(_hwndIdx);
		if (hwnd == NULL) THROW(_T("Invalid window handle."));
		PAINTSTRUCT* ps = (PAINTSTRUCT*)(BppIntPtr)MEMBER(_paintStructIdx);
		if (ps) *bp = (BppInt)EndPaint(hwnd, ps);
		else *bp = (BppInt)0;
		sp = bp;
		return 0;
	}

	bool Bp2WinBase::initCommonControls(BppVirtualMachine* vm, int argc, ValPtr& sp)
	{
		CHKVM;
		CHKARGC(1,1);
		ValPtr bp = sp; bp -= argc;
		CHKTYPE(ARG(0),BVT_INTNUMBER);
		INITCOMMONCONTROLSEX icc;
		icc.dwSize = sizeof(INITCOMMONCONTROLSEX);
		icc.dwICC = (DWORD) (BppUInt) ARG(0);
		BppInt result = (BppInt) InitCommonControlsEx(&icc);
		*bp = BppValue::makeBool(result);
		sp = bp;
		return true;
	}

	void Bp2WinBase::CreateClass(BppVirtualMachine& vm)
	{
		BppClass* pClass = new BppClass(vm);
		if (!vm.registerNativeClass(_className.c_str(),pClass)) return;
		pClass->addDataMember(_T("_hwnd"));
		pClass->addDataMember(_T("_handlerList"));
		pClass->addDataMember(_T("_savedWndProc"));
		pClass->addDataMember(_T("_virtualRect"));
		pClass->addDataMember(_T("_useVirtualSize"));
		pClass->addDataMember(_T("_scrollBarMode"));
		pClass->addDataMember(_T("_sx"));
		pClass->addDataMember(_T("_sy"));
		pClass->addDataMember(_T("_lifeScroll"));
		pClass->addDataMember(_T("_foreColor"));
		pClass->addDataMember(_T("_backColor"));
		pClass->addDataMember(_T("_backBrush"));
		pClass->addDataMember(_T("_accelArray"));
		pClass->addDataMember(_T("_haccel"));
		pClass->addDataMember(_T("_paintStruct"));
		pClass->addStaticDataMember(_maxIDNm.c_str(),(BppInt) 0);
		pClass->addStaticDataMember(_returnCodeNm.c_str(),(BppInt) 0);
		pClass->addStaticDataMember(_autoQuitNm.c_str(),(BppInt) 1);

		pClass->addMethod(_className.c_str(),&ctor);
		pClass->addMethod(_T("dtor"),&dtor);
		pClass->addMethod(_T("createFromHandle"),&createFromHandle);
		pClass->addMethod(_T("create"),&create);
		pClass->addMethod(_T("getHandle"),&getHandle);
		pClass->addMethod(_T("getParent"),&getParent);
		pClass->addMethod(_T("addChild"),&addChild);
		pClass->addMethod(_T("getChildrenHandles"),&getChildrenHandles);
		pClass->addMethod(_T("setPosition"),&setPosition);
		pClass->addMethod(_T("setSize"),&setSize);
		pClass->addMethod(_T("getWindowRect"),&getChildrenHandles);
		pClass->addMethod(_T("getClientRect"),&getChildrenHandles);
		pClass->addMethod(_T("getPosition"),&getPosition);
		pClass->addMethod(_T("getClientPos"),&getClientPos);
		pClass->addMethod(_T("getSize"),&getSize);
		pClass->addMethod(_T("getClientSize"),&getClientSize);
		pClass->addMethod(_T("getPosX"),&getPosX);
		pClass->addMethod(_T("getPosY"),&getPosY);
		pClass->addMethod(_T("getClientPosX"),&getClientPosX);
		pClass->addMethod(_T("getClientPosY"),&getClientPosY);
		pClass->addMethod(_T("getWidth"),&getWidth);
		pClass->addMethod(_T("getHeight"),&getHeight);
		pClass->addMethod(_T("getClientWidth"),&getClientWidth);
		pClass->addMethod(_T("getClientHeight"),&getClientHeight);
		pClass->addMethod(_T("getStyle"),&getStyle);
		pClass->addMethod(_T("hasStyle"),&hasStyle);
		pClass->addMethod(_T("setStyle"),&setStyle);
		pClass->addMethod(_T("addStyle"),&addStyle);
		pClass->addMethod(_T("removeStyle"),&removeStyle);
		pClass->addMethod(_T("getExtStyle"),&getExtStyle);
		pClass->addMethod(_T("hasExtStyle"),&hasExtStyle);
		pClass->addMethod(_T("setExtStyle"),&setExtStyle);
		pClass->addMethod(_T("addExtStyle"),&addExtStyle);
		pClass->addMethod(_T("removeExtStyle"),&removeExtStyle);
		pClass->addMethod(_T("isMinimized"),&isMinimized);
		pClass->addMethod(_T("isMaximized"),&isMaximized);
		pClass->addMethod(_T("isVisible"),&isVisible);
		pClass->addMethod(_T("minimize"),&minimize);
		pClass->addMethod(_T("maximize"),&maximize);
		pClass->addMethod(_T("show"),&show);
		pClass->addMethod(_T("restore"),&restore);
		pClass->addMethod(_T("hide"),&hide);
		pClass->addMethod(_T("preprocessMessage"),&preprocessMessage);
		pClass->addMethod(_T("handleMessage"),&handleMessage);
		pClass->addMethod(_T("addMsgHandler"),&addMsgHandler);
		pClass->addMethod(_T("removeMsgHandler"),&removeMsgHandler);
		pClass->addMethod(_T("removeAllMsgHandlers"),&removeAllMsgHandlers);
		pClass->addMethod(_T("getAcceleratorArray"),&getAcceleratorArray);
		pClass->addMethod(_T("addAccelerator"),&addAccelerator);
		pClass->addMethod(_T("applyAccelerators"),&applyAccelerators);
		pClass->addMethod(_T("setWindowText"),&setWindowText);
		pClass->addMethod(_T("getWindowText"),&getWindowText);
		pClass->addMethod(_T("setBackgroundColor"),&setBackgroundColor);
		pClass->addMethod(_T("setBackgroundBrush"),&setBackgroundBrush);
		pClass->addMethod(_T("setForegroundColor"),&setForegroundColor);
		pClass->addMethod(_T("enableVirtualSize"),&enableVirtualSize);
		pClass->addMethod(_T("setLifeScroll"),&setLifeScroll);
		pClass->addMethod(_T("setVirtualSize"),&setVirtualSize);
		pClass->addMethod(_T("getVirtualSize"),&getVirtualSize);
		pClass->addMethod(_T("fitVirtualSizeToContents"),&fitVirtualSizeToContents);
		pClass->addMethod(_T("getVirtualOrigin"),&getVirtualOrigin);
		pClass->addMethod(_T("scrollHorizontal"),&scrollHorizontal);
		pClass->addMethod(_T("scrollVertical"),&scrollVertical);
		pClass->addMethod(_T("setScrollBarMode"),&setScrollBarMode);
		pClass->addMethod(_T("setScrollSteps"),&setScrollSteps);
		pClass->addMethod(_T("getScrollBarMode"),&getScrollBarMode);
		pClass->addMethod(_T("applyScrollBars"),&applyScrollBars);
		pClass->addMethod(_T("beginPaint"), &beginPaint);
		pClass->addMethod(_T("endPaint"), &endPaint);

		pClass->addStaticMethod(_T("registerWindow"),&registerWindow);
		pClass->addStaticMethod(_T("unregisterWindow"),&unregisterWindow);
		pClass->addStaticMethod(_T("findWindow"),&findWindow);
		pClass->addStaticMethod(_T("forceQuit"),&forceQuit);
		pClass->addStaticMethod(_T("setAutoQuit"),&setAutoQuit);
		pClass->addStaticMethod(_T("setReturnCode"),&setReturnCode);
		pClass->addStaticMethod(_T("mainLoop"),&mainLoop);
		pClass->addStaticMethod(_T("setHInstance"),&setHInstance);
		pClass->addStaticMethod(_T("getHInstance"),&getHInstance);
		pClass->addStaticMethod(_T("createID"),&createID);
		pClass->addStaticMethod(_T("initCommonControls"),&initCommonControls);

		pClass->fixupDataDefs();
		_hwndIdx = pClass->getMemberIndex(_T("_hwnd"));
		_handlerListIdx = pClass->getMemberIndex(_T("_handlerList"));;
		_savedWndProcIdx = pClass->getMemberIndex(_T("_savedWndProc"));
		_virtualRectIdx = pClass->getMemberIndex(_T("_virtualRect"));
		_useVirtualSizeIdx = pClass->getMemberIndex(_T("_useVirtualSize"));
		_scrollBarModeIdx = pClass->getMemberIndex(_T("_scrollBarMode"));;
		_sxIdx = pClass->getMemberIndex(_T("_sx"));
		_syIdx = pClass->getMemberIndex(_T("_sy"));
		_lifeScrollIdx = pClass->getMemberIndex(_T("_lifeScroll"));
		_foreColorIdx = pClass->getMemberIndex(_T("_foreColor"));
		_backColorIdx = pClass->getMemberIndex(_T("_backColor"));
		_backBrushIdx = pClass->getMemberIndex(_T("_backBrush"));
		_accelArrayIdx = pClass->getMemberIndex(_T("_accelArray"));
		_haccelIdx = pClass->getMemberIndex(_T("_haccel"));
		_paintStructIdx = pClass->getMemberIndex(_T("_paintStruct"));
	}

	void Bp2WinBase::setHInstance(HINSTANCE hInstance)
	{
		_hInstance = hInstance;
	}

	HINSTANCE Bp2WinBase::getHInstance()
	{
		return _hInstance;
	}
#ifndef DOXY
	LRESULT CALLBACK Bp2WinBase::globalMsgCallback(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
	{
		BppObject* pwin = 0;
		BppClass* pClass = 0;
		HwndTableEntry* pe = _winMap.find(hwnd);
		bool inCreate = false;
		if (pe != 0)
		{
			pwin = pe->pwin;
		}
		if (pwin == NULL)
		{
			if (msg == 
#ifdef WINCE
			 WM_CREATE
#else
			 WM_NCCREATE
#endif
			 ) // it's the first time the window receives a message
			{
				inCreate = true;
				pwin = _pWinCreate;
				_pWinCreate = 0;
			}
		}
		if (pwin != 0)
		{
			pClass = pwin->getClass();
		}
		if (pClass == 0) {
			//if (_pWinCreate) return 0;
			return DefWindowProc(hwnd, msg, wParam, lParam);  // this should never be called
		}
		BppVirtualMachine& vm = pClass->getVM();
		if ((!inCreate) && vm.isInDbg())
			 return 0; //DefWindowProc(hwnd,WM_NULL,wParam,wParam);
		BppVector args(4,true);
		args[0] = (BppIntPtr) hwnd;
		args[1] = (BppUInt) msg;
		args[2] = (BppIntPtr) wParam;
		args[3] = (BppIntPtr) lParam;
		BppValue result;
		// calls the callback function of the Component
		if (!vm.interpreter()->invokeMember(result,pwin,_T("handleMessage"),&args))
			return DefWindowProc(hwnd,msg,wParam,lParam);
		LRESULT retVal = (LRESULT) (BppIntPtr) result;
		if (msg == WM_DESTROY)
		{
			_winMap.erase(hwnd);
		}
		return retVal;
	}
#endif // !DOXY
#endif // WIN32
