#ifdef WIN32

#include <bppvm.h>
#include <bppclass.h>
#include <bppvalue.h>
#include <bppdict.h>
#include <bppvec.h>
#include <bppstrng.h>
#include <bppobjct.h>
#include <bppint.h>
#include <bppprint.h>
#include <bppbuf.h>

#include "bp2wdlg.h"
#include "bp2wbase.h"
#include "bp2wstruc.h"
#include "bp2cldef.h"

#include <commctrl.h>

#ifdef WINCE
#include <Commdlg.h>
#endif

#pragma warning(disable:4244)
#pragma warning(disable:4311)
#pragma warning(disable:4312)



   const BppString Bp2FileDialog::_className = _T("FileDialog");
   int Bp2FileDialog::_filterIdx = 0;
   int Bp2FileDialog::_dirIdx = 0; 
   int Bp2FileDialog::_fnameIdx = 0;
   int Bp2FileDialog::_extIdx = 0;
   int Bp2FileDialog::_titleIdx = 0;

#define NAMEBUFSIZE 1024
static BppChar _nameBuf[NAMEBUFSIZE];

void Bp2FileDialog::CreateClass(BppVirtualMachine& vm)
{
   BppClass* pClass = new BppClass(vm);
   if (!vm.registerNativeClass(_className.c_str(),pClass)) return;
   pClass->addDataMember(_T("_filter"));
   pClass->addDataMember(_T("_dir"));
   pClass->addDataMember(_T("_fname"));
   pClass->addDataMember(_T("_ext"));
   pClass->addDataMember(_T("_title"));
   pClass->addMethod(_className.c_str(),&ctor);
   pClass->addMethod(_T("getFilter"),&getFilter);
   pClass->addMethod(_T("setFilter"),&setFilter);
   pClass->addMethod(_T("getDirectory"),&getDirectory);
   pClass->addMethod(_T("setDirectory"),&setDirectory);
   pClass->addMethod(_T("getFileName"),&getFileName);
   pClass->addMethod(_T("setFileName"),&setFileName);
   pClass->addMethod(_T("getFullName"),&getFullName);
   pClass->addMethod(_T("setFullName"),&setFullName);
   pClass->addMethod(_T("getExtension"),&getExtension);
   pClass->addMethod(_T("setExtension"),&setExtension);
   pClass->addMethod(_T("getFullPath"),&getFullPath);
   pClass->addMethod(_T("setFullPath"),&setFullPath);
   pClass->addMethod(_T("showOpen"),&showOpen);
   pClass->addMethod(_T("showSave"),&showSave);
   pClass->addMethod(_T("getTitle"),&getTitle);
   pClass->addMethod(_T("setTitle"),&setTitle);
   pClass->fixupDataDefs();
   _filterIdx = pClass->getMemberIndex(_T("_filter"));
   _dirIdx = pClass->getMemberIndex(_T("_dir"));
   _fnameIdx = pClass->getMemberIndex(_T("_fname"));
   _extIdx = pClass->getMemberIndex(_T("_ext"));
   _titleIdx = pClass->getMemberIndex(_T("_title"));
}


bool Bp2FileDialog::ctor(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
      CHKVM;
      CHKOBJECT;
      ARGCMAX(1);
      MEMBER(_filterIdx) = new BppVector();
      MEMBER(_dirIdx) = new BppString();
      MEMBER(_fnameIdx) = new BppString();
      MEMBER(_extIdx) = new BppString();
      MEMBER(_titleIdx) = new BppString();
      *bp = pThis;
      sp = bp;
     return true;
}

bool Bp2FileDialog::getFilter(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
      CHKVM;
      CHKOBJECT;
      ARGCMAX(1);
      *bp = MEMBER(_filterIdx);
      sp = bp;
     return true;
}

bool Bp2FileDialog::setFilter(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
      CHKVM;
      CHKOBJECT;
      CHKARGC(2,2);
      BppVector* pvec = ARG(1);
      if (pvec == 0)
      {
         BppObject* pobj = ARG(1);
         if ((pobj != 0) && (pobj->getClass()->isSubtypeOf(_T("Vector"))))
         {
            BppValue v;
            if (!interpreter->invokeMember(v,pobj,_T("vec"))) return false;
            pvec = v;
         }
      }
      if (pvec == 0)
          return interpreter->badType(ARG(1).getType(),BVT_VECTOR);
      MEMBER(_filterIdx) = pvec;
      bp->dispose();
      sp = bp;
     return true;
}

bool Bp2FileDialog::getDirectory(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
      CHKVM;
      CHKOBJECT;
      ARGCMAX(1);
      *bp = new BppString(*(BppString*)MEMBER(_dirIdx));
      sp = bp;
     return true;
}

bool Bp2FileDialog::setDirectory(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
   CHKVM;
   CHKOBJECT;
   CHKARGC(2,2);
   BppString* ptext = interpreter->getStringFromValueExtern(ARG(1));
   if (ptext == 0)
      return interpreter->badType(ARG(1).getType(),BVT_STRING);
   BppString* pdir = new BppString(ptext->c_str());
   pdir->replace(_T('/'),_T('\\'));
   size_t l = pdir->length();
   if ((l > 0) && ((*pdir)[l-1] != _T('\\'))&& ((*pdir)[l-1] != _T(':')))
      (*pdir) += _T('\\');
   MEMBER(_dirIdx) = pdir;
   bp->dispose();
   sp = bp;
   return true;
}

bool Bp2FileDialog::getFileName(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
   CHKVM;
   CHKOBJECT;
   ARGCMAX(1);
   *bp = new BppString(*((BppString*)MEMBER(_fnameIdx)));
   sp = bp;
   return true;
}

bool Bp2FileDialog::setFileName(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
   CHKVM;
   CHKOBJECT;
   CHKARGC(2,2);
   BppString* ptext = interpreter->getStringFromValueExtern(ARG(1));
   if (ptext == 0)
      return interpreter->badType(ARG(1).getType(),BVT_STRING);
   BppString* pfname = new BppString(ptext->c_str());
    MEMBER(_fnameIdx) = pfname;
   bp->dispose();
   sp = bp;
   return true;
}

bool Bp2FileDialog::getFullName(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
   CHKVM;
   CHKOBJECT;
   ARGCMAX(1);
   BppString* presult = new BppString(*((BppString*)MEMBER(_fnameIdx)));
   BppString* pext = MEMBER(_extIdx);
   if (pext->length() > 0)
   {
      (*presult) += _T('.');
      (*presult) += pext->c_str();
   }
   *bp = presult;
   sp = bp;
   return true;
}

bool Bp2FileDialog::setFullName(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
   CHKVM;
   CHKOBJECT;
   CHKARGC(2,2);
   BppString* ptext = interpreter->getStringFromValueExtern(ARG(1));
   if (ptext == 0)
      return interpreter->badType(ARG(1).getType(),BVT_STRING);

   BppString* pfname = new BppString(ptext->c_str());
   BppString* pext = MEMBER(_extIdx);
   pext->clear();
   size_t l = pfname->length();
   int i;
   for (i=l-1;i>=0;--i)
   {
      if ((*pfname)[i] == _T('.'))
      {
         (*pext) = pfname->substr(i+1);
         pfname->erase(i);
         break;
      }
   }
   MEMBER(_fnameIdx) = pfname;
   bp->dispose();
   sp = bp;
   return true;
}

bool Bp2FileDialog::getExtension(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
      CHKVM;
      CHKOBJECT;
      ARGCMAX(1);
      *bp = new BppString(*((BppString*)MEMBER(_extIdx)));
      sp = bp;
     return true;
}

bool Bp2FileDialog::setExtension(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
   CHKVM;
   CHKOBJECT;
   CHKARGC(2,2);
   BppString* ptext = interpreter->getStringFromValueExtern(ARG(1));
   if (ptext == 0)
      return interpreter->badType(ARG(1).getType(),BVT_STRING);
   BppString* pext = new BppString(ptext->c_str());
   MEMBER(_extIdx) = pext;
   bp->dispose();
   sp = bp;
   return true;
}

bool Bp2FileDialog::getFullPath(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
   CHKVM;
   CHKOBJECT;
   ARGCMAX(1);
   BppString* presult = new BppString(*((BppString*)MEMBER(_dirIdx)));
   BppString* pfname = MEMBER(_fnameIdx);
   BppString* pext = MEMBER(_extIdx);
   if (pfname->length() > 0)
   {
      (*presult) += pfname->c_str();
   }
   if (pext->length() > 0)
   {
      (*presult) += _T('.');
      (*presult) += pext->c_str();
   }
   *bp = presult;
   sp = bp;
   return true;
}

bool Bp2FileDialog::setFullPath(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
   CHKVM;
   CHKOBJECT;
   CHKARGC(2,2);
   BppString* ptext = interpreter->getStringFromValueExtern(ARG(1));
   if (ptext == 0)
      return interpreter->badType(ARG(1).getType(),BVT_STRING);
   BppString fullPath = ptext->c_str();
   fullPath.replace(_T('/'),_T('\\'));
   long pos = -1;
   long extpos=0;
   for (extpos=fullPath.find(_T('.'));extpos != BPP_NNPOS;extpos=fullPath.find(_T('.'),extpos+1))
   {
      if (fullPath.find(_T('\\'),extpos) != BPP_NNPOS) continue;
      pos = extpos;
   }
   if (pos>=0)
   {
      MEMBER(_extIdx) = new BppString(fullPath.substr(pos+1));
      fullPath.erase(pos);
   }
   for (pos = fullPath.length()-1; pos >= 0;--pos)
   {
      BppChar c = fullPath[pos];
      if ((c==_T('\\')) || (c == _T(':')))
      {
         MEMBER(_dirIdx) = new BppString(fullPath.substr(0,pos+1));
         fullPath.erase(0,pos+1);
         break;
      }
   }
   MEMBER(_fnameIdx) = new BppString(fullPath);
   bp->dispose();
   sp = bp;
   return true;
}

static void buildFilter(BppInterpreter* interpreter, BppCharBuffer& buf, BppVector* filterArray)
{
   buf.clear();
   if (filterArray != 0)
   {
      unsigned n = filterArray->size();
      unsigned i;
      for (i=0;i<n;++i)
      {
         BppString* s = interpreter->getStringFromValueExtern((*filterArray)[i]);
         if (s == 0) continue;
         size_t pos = s->find(_T('|'));
         if (pos > 0 && pos != BPP_NNPOS)
         {
            const BppChar* p = s->c_str();
            long l = s->length();
            long j;
            for (j=0;j<l;++j)
            {
               if (j == pos)
                  buf.push_back(0);
               else
                  buf.push_back(p[j]);
            }
            buf.push_back(0);
         }
      }
      if (buf.size() == 0)
         buf.push_back(0);
   }
   if (buf.size() == 0)
      buf.push_back(0);
   buf.push_back(0);
}

bool Bp2FileDialog::showOpen(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
   CHKVM;
   CHKOBJECT;
   CHKARGC(1,2);
   HWND parentHwnd = 0;
   if (argc == 2)
   {
      BppObject* pobj = ARG(1);
      if (pobj != 0)
      {
         if (!pobj->getClass()->isSubtypeOf(Bp2WinBase::_className))
            THROW(_T("Invalid argument. Window expected."));
         BppValue v;
         if (!interpreter->invokeMember(v,pobj,_T("getHandle"))) return false;
         parentHwnd = (HWND) (BppIntPtr) v;
      }
      else
      {
         if (ARG(1).getType() > _BVTVALMAX)
            THROW(_T("Invalid argument. Window handle expected."));
         parentHwnd = (HWND) (BppIntPtr) ARG(1);
      }
   }
   OPENFILENAME ofn;
   ofn.lStructSize = sizeof(OPENFILENAME);
   ofn.hwndOwner = parentHwnd;
   BppCharBuffer filter;
   buildFilter(interpreter,filter,MEMBER(_filterIdx));
   ofn.lpstrFilter = filter.data();
   ofn.nFilterIndex = 0;
   ofn.lpstrCustomFilter = 0;
   _nameBuf[0] = 0;
   BppString* pname = MEMBER(_fnameIdx);
   if (pname != 0)
      _tcscpy(_nameBuf,pname->c_str());
   ofn.lpstrFile=_nameBuf;
   ofn.nMaxFile = NAMEBUFSIZE;
   pname = MEMBER(_dirIdx);
   if (pname != 0)
      ofn.lpstrInitialDir = pname->c_str();
   else
      ofn.lpstrInitialDir = 0;
   ofn.lpstrTitle = 0;
   BppString* ptitle = MEMBER(_titleIdx);
   if ((ptitle != 0) && (ptitle->length() > 0))
   {
      ofn.lpstrTitle = ptitle->c_str();
   }
   ofn.lpstrFileTitle = 0;
   ofn.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
   pname = MEMBER(_extIdx);
   if (pname != 0)
      ofn.lpstrDefExt = pname->c_str();
   else
      ofn.lpstrDefExt = 0;
   if (GetOpenFileName(&ofn))
   {
      BppVector resultArgs;
      resultArgs.push_back(new BppString((const BppChar*) _nameBuf));
      BppValue v;
      if (!interpreter->invokeMember(v,pThis,_T("setFullPath"),&resultArgs)) return false;
      *bp = (BppInt) 1;
   }
   else
      *bp = (BppInt) 0;
   sp = bp;
   return true;
}

bool Bp2FileDialog::showSave(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
   CHKVM;
   CHKOBJECT;
   CHKARGC(1,2);
   HWND parentHwnd = 0;
   if (argc == 2)
   {
      BppObject* pobj = ARG(1);
      if (pobj != 0)
      {
         if (!pobj->getClass()->isSubtypeOf(Bp2WinBase::_className))
            THROW(_T("Invalid argument. Window expected."));
         BppValue v;
         if (!interpreter->invokeMember(v,pobj,_T("getHandle"))) return false;
         parentHwnd = (HWND) (BppIntPtr) v;
      }
      else
      {
         if (ARG(1).getType() > _BVTVALMAX)
            THROW(_T("Invalid argument. Window handle expected."));
         parentHwnd = (HWND) (BppIntPtr) ARG(1);
      }
   }
   OPENFILENAME ofn;
   ofn.lStructSize = sizeof(OPENFILENAME);
   ofn.hwndOwner = parentHwnd;
   BppCharBuffer filter;
   buildFilter(interpreter,filter,MEMBER(_filterIdx));
   ofn.lpstrFilter = filter.data();
   ofn.nFilterIndex = 0;
   ofn.lpstrCustomFilter = 0;
   _nameBuf[0] = 0;
   BppString* pname = MEMBER(_fnameIdx);
   if (pname != 0)
      _tcscpy(_nameBuf,pname->c_str());
   ofn.lpstrFile=_nameBuf;
   ofn.nMaxFile = NAMEBUFSIZE;
   pname = MEMBER(_dirIdx);
   if (pname != 0)
      ofn.lpstrInitialDir = pname->c_str();
   else
      ofn.lpstrInitialDir = 0;
   ofn.lpstrTitle = 0;
   BppString* ptitle = MEMBER(_titleIdx);
   if ((ptitle != 0) && (ptitle->length() > 0))
   {
      ofn.lpstrTitle = ptitle->c_str();
   }
   ofn.lpstrFileTitle = 0;
   ofn.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
   pname = MEMBER(_extIdx);
   if (pname != 0)
      ofn.lpstrDefExt = pname->c_str();
   else
      ofn.lpstrDefExt = 0;
   if (GetSaveFileName(&ofn))
   {
      BppVector resultArgs;
      resultArgs.push_back(new BppString((const BppChar*) _nameBuf));
      BppValue v;
      if (!interpreter->invokeMember(v,pThis,_T("setFullPath"),&resultArgs)) return false;
      *bp = (BppInt) 1;
   }
   else
      *bp = (BppInt) 0;
   sp = bp;
   return true;
}

bool Bp2FileDialog::getTitle(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
      CHKVM;
      CHKOBJECT;
      ARGCMAX(1);
      *bp = new BppString(*((BppString*)MEMBER(_titleIdx)));
      sp = bp;
     return true;
}

bool Bp2FileDialog::setTitle(BppVirtualMachine* vm, int argc, ValPtr& sp)
{
   CHKVM;
   CHKOBJECT;
   CHKARGC(2,2);
   BppString* ptext = interpreter->getStringFromValueExtern(ARG(1));
   if (ptext == 0)
      return interpreter->badType(ARG(1).getType(),BVT_STRING);
   BppString* ptitle = new BppString(ptext->c_str());
   MEMBER(_titleIdx) = ptitle;
   bp->dispose();
   sp = bp;
   return true;
}

#endif // WIN32

