#include <stdio.h>
#include <bppvm.h>
#include <bppvec.h>
#include <dictio.h>
#include <bppstrng.h>
#include <bppufunc.h>
#include <bppprint.h>
#ifdef NOCONIO
 #undef NOCONIO
 #ifndef _CONSOLE
	#define NOCONIO
 #endif
#endif
#ifndef NOCONIO
	#if defined(GCC) && !defined(WIN32)
	  #define getch getchar
	#else
	  #include <conio.h>
	#endif
#endif
#ifdef __MSDOS__
	#include <dos.h>
#endif // __MSDOS__

#ifndef OUTNAME
  #define OUTNAME "bp2r"
#endif


#ifdef __MSDOS__
	#define GETPRGNAME getProgName()
	#ifndef MAX_PATH
	#define MAX_PATH 256
	#endif
	char _arg0[MAX_PATH];

	char* getProgName()
	{
		int intvar;
		char far* penv;
		if ((_argv[0] != NULL) && (strlen(_argv[0]) > 0)) return _argv[0];
		intvar = *(int far*) MK_FP(_psp,0x2c); /* get environment segment */
		penv = (char far*) MK_FP(intvar,0); /* get environment pointer */
		while ((penv != NULL) && ((*penv) != '\0'))
		{
			 while ((*penv) != '\0') ++penv;
			 ++penv;
		}
		penv += 3;
		for (intvar = 0; intvar < MAX_PATH; ++intvar, ++penv)
		{
			_arg0[intvar] = *penv;
			if ((*penv) == '\0') break;
		}
		return _arg0;
	 }
#elif (defined _WIN32)
  #define GETPRGNAME getProgName()
  #ifndef MAX_PATH
	 #define MAX_PATH 256
  #endif
  BppChar _arg0[MAX_PATH];
  BppChar* getProgName()
  {
	  GetModuleFileName(NULL, _arg0, MAX_PATH);
	  return _arg0;
  }
#else
#define GETPRGNAME argv[0]
#endif 

static const BppChar* BANNER = _T("B++ v%d.%d Runtime - Copyright (c) 2005-%s, by Ralf-Erik Ebert\n")
_T("usage:\n")
_T(OUTNAME)
_T(" [-i][-t] [objfile [..]] [# userarg [..]]\n")
_T("options:\n")
_T("    -i ... info (shows syntax and names of compiled functions)\n")
_T("    -t ... trace bytecodes during execution\n")
_T("     # ... marks begin of user argument list\n"); 


static bool BPPAPI dbgWait(BppVirtualMachine*)
{
#ifdef NOCONIO
#ifdef WINCE
#define MB_SYSTEMMODAL MB_TOPMOST|MB_SETFOREGROUND
#endif
	return (MessageBox(GetActiveWindow(),_T("Press OK for next step\nor Cancel to leave step mode."),
		_T("Single Step Mode"),MB_OKCANCEL|MB_SYSTEMMODAL) == IDOK);
#else
	return (getch() != 27);
#endif
}


#ifdef STKLEN
extern unsigned _stklen = STKLEN;
#endif

int
#ifdef _WIN32_WCE_EMULATION
__cdecl
#endif
 _tmain(int argc, BppChar* argv[])
{
//#ifdef __OLDCPP__
//	_ovrbuffer = 0x0800;
//	int dummy = _OvrInitExt(0, 0);
//	int dummy2 = _OvrInitEms(0, 0, 0);
//
//	int dummy3 = printf("%d %d\n", _ovrbuffer, dummy2);
//#endif	
	BppFileStreamPrinter fprt(stdout);
	BppVirtualMachine vm(&fprt);
	vm.setDbgWaitProc(dbgWait);
	vm.cmdargc() = argc;
	vm.cmdargv() = argv;
	FILE* fp = _tfopen(argv[0],_T("rb"));

	const BppChar* pname = fp ? argv[0] : searchPath(GETPRGNAME);
	 struct {
		 BppInt fpos;
		 char tag[4];
	 } tagstruct;
	if (pname && (!fp))
		 fp = _tfopen(pname,_T("rb"));
	if (fp)
	{
		 fseek(fp,-8,SEEK_END);
		 fread(&tagstruct,8,1,fp);
			 tagstruct.tag[3] = 0;
		 if (strcmp(tagstruct.tag,"BPR") == 0)
		 {
			 fseek(fp,tagstruct.fpos,SEEK_SET);
		  bool ok = vm.readModule(fp);
		  fclose(fp);
			 if (!ok)
			 {
				  _tprintf(_T("error reading module %s\n"),argv[0]);
				  return -1;
			 }
			 if (!vm.execute(_T("main"),argc,(const BppChar**)argv))
				 return -1;
		  return (int) (BppInt) vm.getResult();
		 }
		 else
			fclose(fp);
	}
	bool showInfo = false;
	bool doTrace = false;
	BppVector moduleVec;
	if (argc < 2)
	{
		_tprintf(BANNER,_BPP_VER / 100,_BPP_VER % 100,_T(__DATE__)+7);
		return -1;
	}
	for (int i=1; i<argc; i++)
	{
		const BppChar* arg = argv[i];
		BppChar a0 = arg[0];
		if (a0 == _T('#')) break; // rest of cmdline contains user args
		if (a0 == _T('-')) // option
		{
			switch (arg[1])
			{
			case _T('t'):
				doTrace = true;
				break;
			case _T('i'):
				showInfo = true;
				break;
			default:
				_tprintf(_T("invalid option %s\n"),arg);
				_tprintf(BANNER, _BPP_VER / 100, _BPP_VER % 100,__DATE__+7);
				return -1;
			}
			continue;
		}
		else // assume module
		{
			BppString* s = new BppString(arg);
			if (_tcschr(arg,_T('.')) == 0)
				  (*s) += _T(".bpm");
			moduleVec.push_back(s);
		}
	}
	size_t cnt = moduleVec.size();
	size_t j;
	for (j=0; j<cnt; j++)
	{
		const BppChar* modulename = ((BppString*)moduleVec[j])->c_str();
		const BppChar* fname = searchEnv(_T("BPPLIB"),modulename);
		if (fname == 0)
			fname = modulename;

		if (!vm.readModule(fname))
			return -1;
	}
	if (showInfo) _tprintf(_T("%s"),BANNER);
	if (!vm.execute(_T("main"),argc,(const BppChar**)argv,doTrace))
	{
		return -1;
	}
	return (int) (BppInt) vm.getResult();
}

#ifdef NOCONIO
int WINAPI _tWinMain(HINSTANCE instance, HINSTANCE prev_instance, BppChar* command_line, int show_command)
{    
	 int    argc;
	 BppChar** argv;    
	 BppChar*  arg;
	 int    index;
	 int    result;    // count the arguments
	 BppChar strchar = 0;
	 argc = 1;
	 arg  = command_line;
	 
	 while (arg[0] != 0) 
	{        
		while (arg[0] == _T(' ')) 
		{
				arg++;
		  }
		if ((arg[0] == _T('\'')) || (arg[0] == _T('"')))
		{
			strchar = arg[0];
			++arg;
		}
		  if (arg[0] != 0) 
		{
				argc++;
				while ((arg[0] != 0) && (arg[0] !=  ((strchar == 0) ? _T(' ') : strchar))) 
			{
					 arg++;
				}
			if (strchar != 0)
			{
				strchar = 0;
				++arg;
			}
		  }
	 }    
	 
	 // tokenize the arguments

	 argv = (BppChar**)allocmem(argc * sizeof(BppChar**)); 
	arg = command_line;
	 index = 1;    
	strchar = 0;
	while (arg[0] != 0) 
	{        
		while (arg[0] == _T(' ')) 
		{
				arg++;
		  }        
		if ((arg[0] == _T('\'')) || (arg[0] == _T('"')))
		{
			strchar = arg[0];
			++arg;
		}
		if (arg[0] != 0) 
		{
				argv[index] = arg;
				index++;
				while ((arg[0] != 0) && (arg[0] !=  ((strchar == 0) ? _T(' ') : strchar))) 
			{
					 arg++;
				}
			if ((arg[0] != 0) && (strchar != 0))
			{
				strchar = 0;
				arg[0] = 0;
				++arg;
			}
				if (arg[0] != 0) 
			{
					 arg[0] = 0;    
					 arg++;
				}
		  }
	 
	 }        // put the program name into argv[0]

	 BppChar filename[_MAX_PATH];
	 
	 GetModuleFileName(NULL, filename, _MAX_PATH);
	 argv[0] = filename;    // call the user specified main function    
	 
	 result = _tmain(argc, argv);
	 
	 free(argv);
	 return result;}
#endif

#if (!defined(WIN32)) && defined(_UNICODE)
#include <bppbuf.h>
int main(int argc, char* argv[]) {
   struct Helper {
      wchar_t ** args;
	  BppBuffer* buffers;
	  int cnt;
	  Helper(int argc, char* argv[]) : cnt(argc) {
	     args = new wchar_t*[argc];
		 buffers = new BppBuffer[argc];
		 for (int i=0;i<cnt;++i) {
			 buffers[i] = str2wcsBuf(argv[i]);
			 args[i] = (wchar_t*) buffers[i].data();
		 }
	  }
	  ~Helper() {
	      delete [] args;
		  delete [] buffers;
	  }
   } helper(argc,argv);
   return _wmain(argc,helper.args);
   
}
#endif
