#ifndef BPPDBG_H
#define BPPDBG_H
#include <bppdef.h>
#include <bppvec.h>
#include <bppcomp.h>
#include <bppconst.h>
//enum BppOpCode;
class BppVirtualMachine;
class IBppPrinter;
class BppInterpreter;
class BppProcInfo;

class BPPLIB_DLLEXP BppDebugger
{
public:
	BppDebugger(BppVirtualMachine& vm, IBppPrinter* printer = 0);
	virtual ~BppDebugger();

	virtual void decodeProcedure(BppVector* codeVec);
	virtual void traceInstruction(ValPtr sp, ValPtr bp, ValPtr fp, BppByte* pcode, unsigned pc);
	virtual const BppChar* getOpCodeName(BppOpCode opCode) const;
	void setInterpreter(BppInterpreter* interpreter);
	void setCurrentProc(BppProcInfo* currentProc);
	bool active;
protected:
	friend class BppInterpreter;
	BppDebugger(const BppDebugger&);
	BppDebugger& operator=(const BppDebugger&);
	BppInterpreter* _interpreter;
	BppProcInfo* _currentProc;
	void printValue(const BppValue& val, bool safe = false); 
	BppVirtualMachine& _vm;
	IBppPrinter* _printer;
};
#endif //BPPDBG_H
