#ifndef BPPMSG_H
#define BPPMSG_H
#ifndef DOXY
#include <bppdef.h>
#endif
// common type names
extern const BppChar* TN_var;
extern const BppChar* TN_null;
extern const BppChar* TN_int;
extern const BppChar* TN_double;
extern const BppChar* TN_object;
extern const BppChar* TN_string;
extern const BppChar* TN_bool;
extern const BppChar* TN_buffer;
extern const BppChar* TN_charbuffer;
extern const BppChar* TN_vector;
extern const BppChar* TN_dictionary;

// common symbol names

extern const BppChar* SYMN_dtor;
extern const BppChar* SYMN_this;
extern const BppChar* SYMN_self;
extern const BppChar* SYMN_BPPLIB;
extern const BppChar* SYMN_BPPINC;
extern const BppChar* SYMN_defined;
extern const BppChar* SYMN_equals;
extern const BppChar* SYMN_compare;
extern const BppChar* SYMN_native;
extern const BppChar* SYMN_BC_dtor;
extern const BppChar* SYMN_toString;
extern const BppChar* SYMN__OSTYPE;
extern const BppChar* SYMN__UNICODE;
extern const BppChar* SYMN__PTRSIZE;
extern const BppChar* SYMN_foreach;

// Common literal names
extern const BppChar* LN_EDOM;
extern const BppChar* LN_ERANGE;
extern const BppChar* LN_LC_ALL;
extern const BppChar* LN_LC_COLLATE;
extern const BppChar* LN_LC_CTYPE;
extern const BppChar* LN_LC_MONETARY;
extern const BppChar* LN_LC_NUMERIC;
extern const BppChar* LN_LC_TIME;
extern const BppChar* LN_SEEK_SET;
extern const BppChar* LN_SEEK_CUR;
extern const BppChar* LN_SEEK_END;
extern const BppChar* LN_true;
extern const BppChar* LN_false;
extern const BppChar* LN_UNICODE;
extern const BppChar* LN_WIN32;
extern const BppChar* LN_WINCE;
extern const BppChar* LN_DOS;
extern const BppChar* LN_MSDOS;
extern const BppChar* LN_UNIX;
extern const BppChar* LN_LINUX;
extern const BppChar* LN_BPPI64;
extern const BppChar* LN_NPOS;
extern const BppChar* LN_PTRSIZE;
extern const BppChar* LN_CHARSIZE;
extern const BppChar* LN_WCHARSIZE;
extern const BppChar* LN_bplusplus;

// Compiler messages
extern const BppChar* CMP_INVALID_FILEHANDLE;
extern const BppChar* CMP_INVALID_FILESOURCE;
extern const BppChar* CMP_INVALID_TYPENAME_FMT;
extern const BppChar* CMP_DECLARATION_EXPECTED;
extern const BppChar* CMP_DECLARATION_FUNC_OR_VAR_EXPEXTED;
extern const BppChar* CMP_MEMBER_DECLARATION_EXPECTED;
extern const BppChar* CMP_DTOR_DECLARATION_EXPECTED;
extern const BppChar* CMP_VAR_NULL_NOT_ALLOWED;
extern const BppChar* CMP_RETURN_AUTO_NOT_ALLOWED;
extern const BppChar* CMP_MUST_INITIALIZE_AUTO;
extern const BppChar* CMP_MUST_INITIALIZE_CONST;
extern const BppChar* CMP_VOID_CONST;
extern const BppChar* CMP_CONST_NONMEMBERFUNC;
extern const BppChar* CMP_INVALID_OPERATOR_PREFIX;
extern const BppChar* CMP_INVALID_OPERATOR_BEHIND_PREFIX;
extern const BppChar* CMP_INVALID_OPERATOR_DEFINITION;
extern const BppChar* CMP_CLASS_CANT_BE_OWN_BASE;
extern const BppChar* CMP_ILLEGAL_REDEFINITION_OF_BASE;
extern const BppChar* CMP_UNEXPECTED_EOF;
extern const BppChar* CMP_UNEXPECTED_CONST;
extern const BppChar* CMP_UNEXPECTED_MUTABLE;
extern const BppChar* CMP_UNEXPECTED_EOF_IN_BLOCK;
extern const BppChar* CMP_STATIC_OPERATORS_NOT_ALLOWED;
extern const BppChar* CMP_ILLEGAL_TYPE_BEFORE_CONVOP;
extern const BppChar* CMP_DTOR_CANT_BE_STATIC;
extern const BppChar* CMP_CTOR_CANT_BE_STATIC;
extern const BppChar* CMP_DTOR_MUST_BE_PUBLIC;
extern const BppChar* CMP_DTOR_CANT_RETURN_VALUE;
extern const BppChar* CMP_CTOR_CANT_DEFINE_RETURNTYPE;
extern const BppChar* CMP_DTOR_CANT_HAVE_ARGS;
extern const BppChar* CMP_ILLEGAL_DTOR_DEF;
extern const BppChar* CMP_UNEXPECTED_NULL_BEFORE_MEMBER;
extern const BppChar* CMP_CLASS_MEMBERDEF_NOT_ALLOWED;
extern const BppChar* CMP_TYPE_MISMATCH_FMT3;
extern const BppChar* CMP_ILLEGAL_REDEF_TO_DATA_MEMBER;
extern const BppChar* CMP_ILLEGAL_REDEF_TO_STATIC_DATA_MEMBER;
extern const BppChar* CMP_ILLEGAL_REDEF_TO_FUNCTION;
extern const BppChar* CMP_WARN_REDEF_DATA_MEMBER;
extern const BppChar* CMP_WARN_REDEF_STATIC_DATA_MEMBER;
extern const BppChar* CMP_UNEXPECTED_NULL_BEFORE_CLASSVAR;
extern const BppChar* CMP_UNEXPECTED_ELSE_DIRECTIVE;
extern const BppChar* CMP_UNEXPECTED_ELIF_DIRECTIVE;
extern const BppChar* CMP_UNEXPECTED_ENDIF_DIRECTIVE;
extern const BppChar* CMP_LIBRARY_IMPORT_FAILED;
extern const BppChar* CMP_NMODULE_IMPORT_FAILED;
extern const BppChar* CMP_UNDEFINED_PREPROC_SYMBOL;
extern const BppChar* CMP_INCLUDE_FILENAME_EXPECTED;
extern const BppChar* CMP_FILE_NOT_FOUND;
extern const BppChar* CMP_ILLEGAL_GLOBAL_REDEF_FMT;
extern const BppChar* CMP_ILLEGAL_REDEFINITION;
extern const BppChar* CMP_NO_LOCAL_VARSPACE;
extern const BppChar* CMP_STATIC_VAR_ALREADY_DEFINED_FMT;
extern const BppChar* CMP_ARGUMENT_ALREADY_DEFINED_FMT;
extern const BppChar* CMP_LOCAL_VAR_ALREADY_DEFINED_FMT;
extern const BppChar* CMP_MULTIPLE_DEFAULT_NOT_ALLOWED;
extern const BppChar* CMP_CASE_OR_DEFAULT_EXPECTED;
extern const BppChar* CMP_BREAK_OUTSIDE_LOOP;
extern const BppChar* CMP_CONTINUE_OUTSIDE_LOOP;
extern const BppChar* CMP_RETURNVAL_NOT_ALLOWED;
extern const BppChar* CMP_INVALID_RETURNVAL_FOR_NULL;
extern const BppChar* CMP_RETURNVAL_EXPECTED;
extern const BppChar* CMP_NOT_STATIC_MEMBER;
extern const BppChar* CMP_NOT_CLASS_MEMBER;
extern const BppChar* CMP_INVALID_NONVIRTUAL_MCALL;
extern const BppChar* CMP_PRIMARY_EXPECTED;
extern const BppChar* CMP_UNDEFINED_CLASS;
extern const BppChar* CMP_UNDEFINED_VAR_FMT;
extern const BppChar* CMP_INVALID_DATA_MEMBER;
extern const BppChar* CMP_NO_THISREF_FOUND;
extern const BppChar* CMP_INDEXED_LITREF_NOT_ALLOWED;
extern const BppChar* CMP_ELLIPSE_MUST_BE_LAST;
extern const BppChar* CMP_DUPLICATED_IDENT_FMT;
extern const BppChar* CMP_EXPECTED_FOUND_FMT3;
extern const BppChar* CMP_LVALUE_EXPECTED;
extern const BppChar* CMP_COMMA_SQBRACKET_EXPECTED;
extern const BppChar* CMP_COMMA_CURBRACKET_EXPECTED;
extern const BppChar* CMP_LITERAL_EXPECTED;
extern const BppChar* CMP_EOF_IN_ARGUMENTLIST;
extern const BppChar* CMP_MACRO_REDEFINE_FMT;
extern const BppChar* CMP_INVALID_POP_CDEFINE;
extern const BppChar* CMP_ILLEGAL_NAMESPACE_IN_CLASS;
extern const BppChar* CMP_UNEXPECTED_PROTECTION_SPECIFIER;

extern const BppChar* SCN_INVALID_TOKEN;
extern const BppChar* SCN_INVALID_TOKEN_PTPT;
extern const BppChar* SCN_INVALID_RAW_STRINGLIT;
extern const BppChar* SCN_INVALID_NUMBERLIT;
extern const BppChar* SCN_EOF_IN_RAW_STRINGLIT;
extern const BppChar* SCN_SPECIAL_CHARACTER;
extern const BppChar* SCN_NUMBERLIT_EXPECTED;
extern const BppChar* SCN_CLOSING_SINGLEQUOTE_EXPECTED;
extern const BppChar* SCN_INVALID_QUOTED_NUMBERLIT;
extern const BppChar* SCN_INTLIT_OUT_OF_RANGE;
extern const BppChar* SCN_REALLIT_OUT_OF_RANGE;
extern const BppChar* SCN_PARSEERR_FMT5;

extern const BppChar* VM_ERR_OPEN_FILE_FMT;

extern const BppChar* BCI_NO_BYTECODE;
extern const BppChar* BCI_INTERPRET_BYTECODE;
extern const BppChar* BCI_TYPE_MISMATCH_ARG_FMT3;
extern const BppChar* BCI_TOO_FEW_ARGS;
extern const BppChar* BCI_SEND_OBJECT_EXPECTED;
extern const BppChar* BCI_SEND_NO_CLASS;
extern const BppChar* BCI_BC_PREFIX;
extern const BppChar* BCI_DC_PREFIX;
extern const BppChar* BCI_NULLPTR_TO_NATIVE;
extern const BppChar* BCI_NULLPTR_TO_BYTECODE;
extern const BppChar* BCI_HAS_NO_METHODIMPL;
extern const BppChar* BCI_INVALID_VALUETYPE_FMT2;
extern const BppChar* BCI_INVALID_OBJECT_TYPE_FMT3;
extern const BppChar* BCI_INVALID_OBJECT_TYPE_FMT2;
extern const BppChar* BCI_ASSIGN_TO_CONST;
extern const BppChar* BCI_NO_METHOD_FOR_NAME;
extern const BppChar* BCI_ERROR_FMT2;
extern const BppChar* BCI_INVALID_ARGTYPE;
extern const BppChar* BCI_INVALID_ARGTYPE_FMT;
extern const BppChar* BCI_INVALID_ARG_PCLASS_NULL;
extern const BppChar* BCI_INVALID_RETURN_FMT2;
extern const BppChar* BCI_CANT_CONVERT_TO_NUMBER_FMT2;
extern const BppChar* BCI_INVALID_BUFFER_SIZE;
extern const BppChar* BCI_INVALID_VARIABLEREF;
extern const BppChar* BCI_CONVERSION_OP_NOT_DEFINRD_FMT;
extern const BppChar* BCI_MISSING_FUNCTION_NAME;
extern const BppChar* BCI_MISSING_CLASS_NAME;
extern const BppChar* BCI_SYMBOL_NOT_FOUND_FMT;
extern const BppChar* BCI_CLASS_NOT_FOUND_FMT;
extern const BppChar* BCI_MISSING_FUNCTION_OBJECTREF;
extern const BppChar* BCI_MISSING_CLASSREF;
extern const BppChar* BCI_SYMBOL_NOT_FOUND_IN_CLASS_FMT2;
extern const BppChar* BCI_SYMBOL_NOT_STATIC_MEMBER_FMT2;
extern const BppChar* BCI_LEFT_STRING_OP_NULL;
extern const BppChar* BCI_RIGHT_STRING_OP_NULL;
extern const BppChar* BCI_DIVIDE_ZERO_ERR;
extern const BppChar* BCI_CALL_NONPROCEDURE;
extern const BppChar* BCI_STACK_CORRUPTED;
extern const BppChar* BCI_OUT_OF_RANGE;
extern const BppChar* BCI_OBJECT_EXPECTED;
extern const BppChar* BCI_MEMBER_DATA_EXPECTED;


extern const BppChar* FLIB_INVALID_ARG;
extern const BppChar* FLIB_INVALID_SECOND_ARG;
extern const BppChar* FLIB_INVALID_ARG_TYPE;
extern const BppChar* FLIB_INVALID_ARG_VALUE;
extern const BppChar* FLIB_INVALID_ARG_TYPE_DEST;
extern const BppChar* FLIB_INVALID_VALUE_TYPE;
extern const BppChar* FLIB_INVALID_FUNCTION_ARG;
extern const BppChar* FLIB_CONST_ARG_NOT_ALLOWED;
extern const BppChar* FLIB_INVALID_CONTAINER;
extern const BppChar* FLIB_INVALID_CONTAINER_TYPE;
extern const BppChar* FLIB_FILE_EXPECTED_BR;
extern const BppChar* FLIB_BUFFER_EXPECTED_BR;
extern const BppChar* FLIB_INT_EXPECTED_BR;
extern const BppChar* FLIB_STRING_EXPECTED_BR;
extern const BppChar* FLIB_VECTOR_EXPECTED_BR;
extern const BppChar* FLIB_STRING_OR_CHAR_EXPECTED_BR;
extern const BppChar* FLIB_SEQUENCE_CONTAINER_EXPECTED_BR;
extern const BppChar* FLIB_ARG_CONTAINER_BR;
extern const BppChar* FLIB_ARG_CAPACITY_BR;
extern const BppChar* FLIB_ARG_SIZE_BR;
extern const BppChar* FLIB_DEST_IS_NULL;
extern const BppChar* FLIB_SOURCE_IS_NULL;
extern const BppChar* FLIB_ARG_IS_NULL;
extern const BppChar* FLIB_INDEX_OUT_OF_RANGE;
extern const BppChar* FLIB_CLASS_NOT_FOUND;
extern const BppChar* FLIB_FIRST_ARG_NOT_CLASS;
extern const BppChar* FLIB_FIRST_ARG_NOT_STRING;
extern const BppChar* FLIB_UNKNOWN_CLASS_NAME;

extern const BppChar* FLIB_INVALID_TYPE_OF_VALUE_ARG;
extern const BppChar* FLIB_INVALID_TYPE_OF_REG_ARG;
extern const BppChar* FLIB_INVALID_REGNAME;
extern const BppChar* FLIB_INVALID_CALLBACKARGNUM_FMT;
extern const BppChar* FLIB_INVALID_CALLBACKINSTANCENUM_FMT;
extern const BppChar* FLIB_UNKNOWN_ERROR;
extern const BppChar* FLIB_INVALID_INDEX;
extern const BppChar* FLIB_SYSTEM_CALL_FAILED;

extern const BppChar* DIO_OPEN_WRITE_FAILED_FMT;
extern const BppChar* DIO_OPEN_READ_FAILED_FMT;
extern const BppChar* DIO_WRITE_ENTRY_FAILED_FMT;
#ifdef _DEBUG
extern const BppChar* DIO_READ_DICT_SORTFLAG_FAILED_FMT;
extern const BppChar* DIO_READ_PTR_FAILED_FMT;
extern const BppChar* DIO_ILLEGAL_BASE_REDEFINITION_FMT;
extern const BppChar* DIO_ILLEGAL_OWNER_REDEFINITION_FMT;
extern const BppChar* DIO_ERROR_READ_STRING_FMT;
#endif

extern const BppChar* REX_PATTERN_EMPTY;
extern const BppChar* REX_INVALID_ARG_VECTOR_EXPECTED;
extern const BppChar* REX_TEXT_IS_NULL;
extern const BppChar* REX_REPLACEMENT_IS_NULL;
extern const BppChar* REX_KEY_EXPECTED;
extern const BppChar* REX_OBJ_NOT_INITIALIZED;
extern const BppChar* REX_INVALID_KEY;

extern const BppChar* STRUC_INVALID_BUFFER;
extern const BppChar* STRUC_INVALID_ITEM_DESC;
extern const BppChar* STRUC_MEMBER_NOT_CONTAINED;
extern const BppChar* STRUC_INVALID_MEMBER_DESC;
extern const BppChar* STRUC_VECTOR_EXPECTED;
extern const BppChar* STRUC_DICT_EXPECTED;
extern const BppChar* STRUC_SET_VALUE_FAILED;
extern const BppChar* STRUC_GET_VALUE_FAILED;
extern const BppChar* STRUC_GET_DATA_FAILED;
extern const BppChar* STRUC_INVALID_INDEX;
extern const BppChar* STRUC_PURE_VCALL_GETDESC;
extern const BppChar* STRUC_MISSING_STRUCT_DESC;
extern const BppChar* STRUC_CREATE_BUFFER_DESC_FAILED;
extern const BppChar* STRUC_INVALID_MEMBER_DEF;
extern const BppChar* STRUC_SUB_PROXY_NOT_DEFINED;


#endif // !BPPMSG


