#ifndef DICTIO_H
#define DICTIO_H

#include <stdio.h>
#ifndef DOXY
#include <bppdef.h>
#endif
class IBppPrinter;
struct ObjListEntry;
//struct VarListEntry;
class BppDictionaryEntry;
class BppDictionary;
class BppString;
class BppValue;
class BppVirtualMachine;


class BPPLIB_DLLEXP BppDictionaryIO
{
public:
   BppDictionaryIO(BppVirtualMachine& vm);
   ~BppDictionaryIO();
   bool readModule(const BppString& filename);
   bool readModule(FILE* fp);
   bool writeModule(const BppString& filename);
   bool writeModule(FILE* fp);
   bool readSingleValue(FILE* fp, BppValue& value);
   bool writeSingleValue(FILE* fp, BppValue& value);
private:
#ifndef DOXY
   BppDictionaryIO(const BppDictionaryIO&);
   BppDictionaryIO& operator=(const BppDictionaryIO&);
#endif
   bool writeValue(FILE* fp, BppValue& value, bool writeClassref = false);
   bool readValue(FILE* fp, BppValue& value, bool readClassref = false);
   bool writeDictionary(FILE* fp, BppDictionary& dict, bool ignoreNativeFuncs = false);
   bool writeDictEntry(FILE* fp, BppDictionaryEntry& entry, bool ignoreNativeFuncs = false);
   bool readDictionary(FILE* fp, BppDictionary& dict, bool readSortedFlag = false);
   bool readDictEntry(FILE* fp, BppDictionary& dict);
   void dissolveObjRefs();
   BppString* readString(FILE* fp);
   BppIntPtr readPtr(FILE* fp, bool& ok);
   bool readBytes(FILE* fp, void* pbuf, BppUInt cnt);
   bool writeString(FILE* fp, const BppChar* str);
   bool writePtr(FILE* fp, BppIntPtr ptr);
   bool writeBytes(FILE* fp, const void* src, BppUInt cnt);
   /// adds entry to object list
   bool addOLEntry(void* ID, const BppValue& val);
   /// add entry to object referencelist
   void addORefEntry(void* ID, BppValue* pval);
   /// delete object- and object referencelist
   void clearObjectLists();
   BppDictionary& _classes;
   BppDictionary& _symbols;
   IBppPrinter& _print;
   BppVirtualMachine& _vm;
   ObjListEntry* _objList;
   ObjListEntry* _objRefList;
   //VarListEntry* _varList;
};
#endif // DICTIO_H
