#include "bppdef.h"

const BppChar* TN_var = _T("var");
const BppChar* TN_null = _T("null");
const BppChar* TN_int = _T("int");
const BppChar* TN_double = _T("double");
const BppChar* TN_object = _T("object");
const BppChar* TN_string = _T("string");
const BppChar* TN_bool = _T("bool");
const BppChar* TN_buffer = _T("buffer");
const BppChar* TN_charbuffer = _T("charbuffer");
const BppChar* TN_vector = _T("vector");
const BppChar* TN_dictionary = _T("dictionary");

const BppChar* SYMN_dtor = _T("dtor");
const BppChar* SYMN_this = _T("this");
const BppChar* SYMN_self = _T("self");
const BppChar* SYMN_BPPLIB = _T("BPPLIB");
const BppChar* SYMN_BPPINC = _T("BPPINC");
const BppChar* SYMN_defined = _T("defined");
const BppChar* SYMN_equals = _T("equals");
const BppChar* SYMN_compare = _T("compare");
const BppChar* SYMN_native = _T("native");
const BppChar* SYMN_BC_dtor = _T("BC_dtor");
const BppChar* SYMN_toString = _T("toString");
const BppChar* SYMN__OSTYPE = _T("__OSTYPE__");
const BppChar* SYMN__UNICODE = _T("__UNICODE__");
const BppChar* SYMN__PTRSIZE = _T("__PTRSIZE__");
const BppChar* SYMN_foreach = _T("foreach");


const BppChar* LN_EDOM = _T("EDOM");
const BppChar* LN_ERANGE = _T("ERANGE");
const BppChar* LN_LC_ALL = _T("LC_ALL");
const BppChar* LN_LC_COLLATE = _T("LC_COLLATE");
const BppChar* LN_LC_CTYPE = _T("LC_CTYPE");
const BppChar* LN_LC_MONETARY = _T("LC_MONETARY");
const BppChar* LN_LC_NUMERIC = _T("LC_NUMERIC");
const BppChar* LN_LC_TIME = _T("LC_TIME");
const BppChar* LN_SEEK_SET = _T("SEEK_SET");
const BppChar* LN_SEEK_CUR = _T("SEEK_CUR");
const BppChar* LN_SEEK_END = _T("SEEK_END");
const BppChar* LN_true = _T("true");
const BppChar* LN_false = _T("false");
const BppChar* LN_UNICODE = _T("UNICODE");
const BppChar* LN_WIN32 = _T("WIN32");
const BppChar* LN_WINCE = _T("WINCE");
const BppChar* LN_MSDOS = _T("MSDOS");
const BppChar* LN_DOS = _T("DOS");
const BppChar* LN_UNIX = _T("UNIX");
const BppChar* LN_LINUX = _T("LINUX");
const BppChar* LN_BPPI64 = _T("BPPI64");
const BppChar* LN_NPOS = _T("NPOS");
const BppChar* LN_PTRSIZE = _T("PTRSIZE");
const BppChar* LN_CHARSIZE = _T("CHARSIZE");
const BppChar* LN_WCHARSIZE = _T("WCHARSIZE");
const BppChar* LN_bplusplus = _T("__bplusplus");

const BppChar* CMP_INVALID_FILEHANDLE = _T("BppCompiler::compile(FILE* fp) invalid file handle\n");
const BppChar* CMP_INVALID_FILESOURCE = _T("BppCompiler::compile(const BppChar* src) invalid source\n");
const BppChar* CMP_INVALID_TYPENAME_FMT = _T("invalid typename %s");
const BppChar* CMP_DECLARATION_EXPECTED = _T("declaration expected");
const BppChar* CMP_DECLARATION_FUNC_OR_VAR_EXPEXTED = _T("declaration of function or variable expected");
const BppChar* CMP_MEMBER_DECLARATION_EXPECTED = _T("member declaration expected");
const BppChar* CMP_DTOR_DECLARATION_EXPECTED = _T("destructor declaration expected");

const BppChar* CMP_VAR_NULL_NOT_ALLOWED = _T("variable of type 'null' not allowed");
const BppChar* CMP_RETURN_AUTO_NOT_ALLOWED = _T("return type 'auto' not allowed");
const BppChar* CMP_MUST_INITIALIZE_AUTO = _T("Variables of 'auto' type must be initialized.");
const BppChar* CMP_MUST_INITIALIZE_CONST = _T("Constants must be initialized.");
const BppChar* CMP_VOID_CONST = _T("unexpected const qualifier before void");
const BppChar* CMP_CONST_NONMEMBERFUNC = _T("unecpected const qualifier in non-member function declaration");
const BppChar* CMP_INVALID_OPERATOR_PREFIX = _T("invalid operator prefix");
const BppChar* CMP_INVALID_OPERATOR_BEHIND_PREFIX = _T("invalid operator token behind prefix");
const BppChar* CMP_INVALID_OPERATOR_DEFINITION = _T("invalid operator definition");
const BppChar* CMP_CLASS_CANT_BE_OWN_BASE = _T("class can't be its own base");
const BppChar* CMP_ILLEGAL_REDEFINITION_OF_BASE = _T("illegal redefinition of base class");
const BppChar* CMP_UNEXPECTED_EOF = _T("unexpected EOF");
const BppChar* CMP_UNEXPECTED_EOF_IN_BLOCK = _T("unexpected EOF in block");
const BppChar* CMP_UNEXPECTED_CONST = _T("unexpected const");
const BppChar* CMP_UNEXPECTED_MUTABLE = _T("unexpected mutable");
const BppChar* CMP_STATIC_OPERATORS_NOT_ALLOWED = _T("static operators not allowed");
const BppChar* CMP_ILLEGAL_TYPE_BEFORE_CONVOP = _T("illegal type before conversion operator");
const BppChar* CMP_DTOR_CANT_BE_STATIC = _T("destructor can't be static");
const BppChar* CMP_CTOR_CANT_BE_STATIC = _T("constructor can't be static");
const BppChar* CMP_DTOR_MUST_BE_PUBLIC = _T("destructor must be public");
const BppChar* CMP_DTOR_CANT_RETURN_VALUE = _T("destructor can't return a value");
const BppChar* CMP_CTOR_CANT_DEFINE_RETURNTYPE = _T("constructor can't define a return type");
const BppChar* CMP_DTOR_CANT_HAVE_ARGS = _T("Destructor can't have arguments.");
const BppChar* CMP_ILLEGAL_DTOR_DEF = _T("illegal destructor definition");
const BppChar* CMP_UNEXPECTED_NULL_BEFORE_MEMBER = _T("unexpected null-keyword before member variable declaration");
const BppChar* CMP_CLASS_MEMBERDEF_NOT_ALLOWED = _T("classes already used as base must not define new member variables");
const BppChar* CMP_TYPE_MISMATCH_FMT3 = _T("Type mismatch: %s(%s) = (%s).");
const BppChar* CMP_ILLEGAL_REDEF_TO_DATA_MEMBER = _T("illegal redefinition to data member");
const BppChar* CMP_ILLEGAL_REDEF_TO_STATIC_DATA_MEMBER = _T("illegal redefinition to static data member");
const BppChar* CMP_ILLEGAL_REDEF_TO_FUNCTION = _T("illegal redefinition to function");
const BppChar* CMP_WARN_REDEF_DATA_MEMBER = _T("warning: redefinition of data member");
const BppChar* CMP_WARN_REDEF_STATIC_DATA_MEMBER = _T("warning: redefinition of static data member");
const BppChar* CMP_UNEXPECTED_NULL_BEFORE_CLASSVAR = _T("unexpected null-keyword before class variable declaration");
const BppChar* CMP_UNEXPECTED_ELSE_DIRECTIVE = _T("unexpected #else directive");
const BppChar* CMP_UNEXPECTED_ELIF_DIRECTIVE = _T("unexpected #elif directive");
const BppChar* CMP_UNEXPECTED_ENDIF_DIRECTIVE = _T("unexpected #endif directive");
const BppChar* CMP_LIBRARY_IMPORT_FAILED = _T("library import failed");
const BppChar* CMP_NMODULE_IMPORT_FAILED = _T("native module import failed");
const BppChar* CMP_UNDEFINED_PREPROC_SYMBOL = _T("undefined preprocessor symbol");
const BppChar* CMP_INCLUDE_FILENAME_EXPECTED = _T("include file name expected");
const BppChar* CMP_FILE_NOT_FOUND = _T("file not found");
const BppChar* CMP_ILLEGAL_GLOBAL_REDEF_FMT = _T("Illegal redefinition of global symbol '%s'.");
const BppChar* CMP_ILLEGAL_REDEFINITION = _T("illegal redefinition");
const BppChar* CMP_NO_LOCAL_VARSPACE = _T("No local variables space in current function");
const BppChar* CMP_STATIC_VAR_ALREADY_DEFINED_FMT = _T("Static variable of name '%s' already defined");
const BppChar* CMP_ARGUMENT_ALREADY_DEFINED_FMT = _T("Argument of name '%s' already defined");
const BppChar* CMP_LOCAL_VAR_ALREADY_DEFINED_FMT = _T("Local variable of name '%s' already defined");
const BppChar* CMP_MULTIPLE_DEFAULT_NOT_ALLOWED = _T("multiple 'default' branches not allowed");
const BppChar* CMP_CASE_OR_DEFAULT_EXPECTED = _T("'case' or 'default' expected");
const BppChar* CMP_BREAK_OUTSIDE_LOOP = _T("break outside of loop found");
const BppChar* CMP_CONTINUE_OUTSIDE_LOOP = _T("continue outside of loop found");
const BppChar* CMP_RETURNVAL_NOT_ALLOWED = _T("return value not allowed");
const BppChar* CMP_INVALID_RETURNVAL_FOR_NULL = _T("invalid return value for type 'null'");
const BppChar* CMP_RETURNVAL_EXPECTED = _T("return value expected");
const BppChar* CMP_NOT_STATIC_MEMBER = _T("not a static class member");
const BppChar* CMP_NOT_CLASS_MEMBER = _T("not a class member");
const BppChar* CMP_INVALID_NONVIRTUAL_MCALL = _T("invalid non-virtual member call, use obj->(class::member)() notation");
const BppChar* CMP_PRIMARY_EXPECTED = _T("primary expression expected");
const BppChar* CMP_UNDEFINED_CLASS = _T("undefined class");
const BppChar* CMP_UNDEFINED_VAR_FMT = _T("variable %s not defined");
const BppChar* CMP_INVALID_DATA_MEMBER = _T("invalid data member");
const BppChar* CMP_NO_THISREF_FOUND = _T("BppCompiler::_codeMethodCall : no 'this' reference found");
const BppChar* CMP_INDEXED_LITREF_NOT_ALLOWED = _T("Indexed access to literals not allowed");
const BppChar* CMP_ELLIPSE_MUST_BE_LAST = _T("Ellipse (...) must be last argument.");
const BppChar* CMP_DUPLICATED_IDENT_FMT = _T("Duplicated identifier '%s' found.");
const BppChar* CMP_EXPECTED_FOUND_FMT3 = _T("%s expected '%s', found '%s'");
const BppChar* CMP_LVALUE_EXPECTED = _T("lvalue expected");
const BppChar* CMP_COMMA_SQBRACKET_EXPECTED = _T("',' or ']' expected");
const BppChar* CMP_COMMA_CURBRACKET_EXPECTED = _T("',' or '}' expected");
const BppChar* CMP_LITERAL_EXPECTED = _T("literal expected");
const BppChar* CMP_EOF_IN_ARGUMENTLIST = _T("unexpected EOF in argument list");
const BppChar* CMP_MACRO_REDEFINE_FMT = _T("Warning: Redefinition of macro '%s'");
const BppChar* CMP_INVALID_POP_CDEFINE = _T("pragma cdefine pop used without push");
const BppChar* CMP_ILLEGAL_NAMESPACE_IN_CLASS = _T("namespace can't be defined in class.");
const BppChar* CMP_UNEXPECTED_PROTECTION_SPECIFIER = _T("unexpected protection specifier");

const BppChar* SCN_INVALID_TOKEN = _T("invalid token");
const BppChar* SCN_INVALID_TOKEN_PTPT = _T("invalid token ..");
const BppChar* SCN_INVALID_RAW_STRINGLIT = _T("invalid raw string literal");
const BppChar* SCN_INVALID_NUMBERLIT = _T("invalid number literal");
const BppChar* SCN_EOF_IN_RAW_STRINGLIT = _T("unexpected EOF in raw string literal");
const BppChar* SCN_SPECIAL_CHARACTER = _T("special character");
const BppChar* SCN_NUMBERLIT_EXPECTED = _T("number literal expected");
const BppChar* SCN_CLOSING_SINGLEQUOTE_EXPECTED = _T("closing single quote expected");
const BppChar* SCN_INVALID_QUOTED_NUMBERLIT = _T("invalid quoted number literal");
const BppChar* SCN_INTLIT_OUT_OF_RANGE = _T("integer literal out of range");
const BppChar* SCN_REALLIT_OUT_OF_RANGE = _T("real literal out of range");
const BppChar* SCN_PARSEERR_FMT5 = _T("--> %s \nin %s line %ld pos %u \n%s\n");

const BppChar* VM_ERR_OPEN_FILE_FMT = _T("error opening file %s\n");

const BppChar* BCI_NO_BYTECODE = _T("no bytecode: ");
const BppChar* BCI_INTERPRET_BYTECODE = _T("interpret(BppVector* byteCode)\n");
const BppChar* BCI_TYPE_MISMATCH_ARG_FMT3 = _T("Type mismatch for argument %d(%s) = (%s).");
const BppChar* BCI_TOO_FEW_ARGS = _T("Too few arguments.");
const BppChar* BCI_SEND_OBJECT_EXPECTED = _T("BppInterpreter::send : object expected\n");
const BppChar* BCI_SEND_NO_CLASS = _T("BppInterpreter::send : no class for object\n");
const BppChar* BCI_BC_PREFIX = _T("BC_");
const BppChar* BCI_DC_PREFIX = _T("DC_");
const BppChar* BCI_NULLPTR_TO_NATIVE = _T(" : NULL pointer to native function\n");
const BppChar* BCI_NULLPTR_TO_BYTECODE = _T(" : NULL pointer to bytecode\n");
const BppChar* BCI_HAS_NO_METHODIMPL = _T("has no method implementation\n");
const BppChar* BCI_INVALID_VALUETYPE_FMT2 = _T("invalid value type %s, %s expected");
const BppChar* BCI_INVALID_OBJECT_TYPE_FMT3 = _T("invalid %s type %s, object of class %s expected");
const BppChar* BCI_INVALID_OBJECT_TYPE_FMT2 = _T("invalid value type %s, object of class %s expected");
const BppChar* BCI_ASSIGN_TO_CONST = _T("Can't assign value to a constant.");
const BppChar* BCI_NO_METHOD_FOR_NAME = _T("no method for name ");
const BppChar* BCI_ERROR_FMT2 = _T("\nin \"%s\" line: %d");
const BppChar* BCI_INVALID_ARGTYPE = _T("invalid argument type");
const BppChar* BCI_INVALID_ARGTYPE_FMT = _T("invalid argument of type %s.");
const BppChar* BCI_INVALID_ARG_PCLASS_NULL = _T("Invalid argument (pclass == NULL). ");
const BppChar* BCI_INVALID_RETURN_FMT2 = _T("invalid return type %s, %s expected");
const BppChar* BCI_CANT_CONVERT_TO_NUMBER_FMT2 = _T("unable to convert \"%s\" into number of type %s.");
const BppChar* BCI_INVALID_BUFFER_SIZE = _T("invalid buffer size");
const BppChar* BCI_INVALID_VARIABLEREF = _T("invalid variable reference ");
const BppChar* BCI_CONVERSION_OP_NOT_DEFINRD_FMT = _T("conversion operator %s not defined.");
const BppChar* BCI_MISSING_FUNCTION_NAME = _T("Missing function name ");
const BppChar* BCI_MISSING_CLASS_NAME = _T("Missing class name. ");
const BppChar* BCI_SYMBOL_NOT_FOUND_FMT = _T("Symbol '%s' not found. ");
const BppChar* BCI_CLASS_NOT_FOUND_FMT = _T("Class '%s' not found. ");
const BppChar* BCI_MISSING_FUNCTION_OBJECTREF = _T("Missing function object reference ");
const BppChar* BCI_MISSING_CLASSREF = _T("Missing class reference ");
const BppChar* BCI_SYMBOL_NOT_FOUND_IN_CLASS_FMT2 = _T("Symbol '%s' not found in class '%s'. ");
const BppChar* BCI_SYMBOL_NOT_STATIC_MEMBER_FMT2 = _T("Symbol '%s' not a static member of class '%s'. ");
const BppChar* BCI_LEFT_STRING_OP_NULL = _T("left string operand is NULL");
const BppChar* BCI_RIGHT_STRING_OP_NULL = _T("right string operand is NULL");
const BppChar* BCI_DIVIDE_ZERO_ERR = _T("divide 0 error");
const BppChar* BCI_CALL_NONPROCEDURE = _T("call to non-procedure, type ");
const BppChar* BCI_STACK_CORRUPTED = _T("stack corrupted");
const BppChar* BCI_OUT_OF_RANGE = _T("subscript out of range");
const BppChar* BCI_OBJECT_EXPECTED = _T("object expected");
const BppChar* BCI_MEMBER_DATA_EXPECTED = _T("member data expected");


const BppChar* FLIB_INVALID_ARG = _T("invalid argument");
const BppChar* FLIB_INVALID_SECOND_ARG = _T("invalid second argument");
const BppChar* FLIB_INVALID_ARG_TYPE = _T("invalid argument type");
const BppChar* FLIB_INVALID_ARG_VALUE = _T("invalid argument value");
const BppChar* FLIB_INVALID_ARG_TYPE_DEST = _T("invalid argument type for destination");
const BppChar* FLIB_CONST_ARG_NOT_ALLOWED = _T("constant argument not allowed");
const BppChar* FLIB_INVALID_VALUE_TYPE = _T("invalid value type");
const BppChar* FLIB_INVALID_FUNCTION_ARG = _T("invalid function argument");
const BppChar* FLIB_INVALID_CONTAINER = _T("invalid container");
const BppChar* FLIB_INVALID_CONTAINER_TYPE = _T("invalid container type");
const BppChar* FLIB_FILE_EXPECTED_BR = _T(" (FILE expected)");
const BppChar* FLIB_BUFFER_EXPECTED_BR = _T(" (Buffer expected)");
const BppChar* FLIB_INT_EXPECTED_BR = _T(" (int expected)");
const BppChar* FLIB_STRING_EXPECTED_BR = _T(" (string expected)");
const BppChar* FLIB_VECTOR_EXPECTED_BR = _T(" (vector expected)");
const BppChar* FLIB_STRING_OR_CHAR_EXPECTED_BR = _T(" (string or character expected)");
const BppChar* FLIB_SEQUENCE_CONTAINER_EXPECTED_BR = _T(" (sequence container expected)");;
const BppChar* FLIB_ARG_CONTAINER_BR = _T(" (argument container)");
const BppChar* FLIB_ARG_CAPACITY_BR = _T(" (argument capacity)");
const BppChar* FLIB_ARG_SIZE_BR = _T(" (argument size)");
const BppChar* FLIB_DEST_IS_NULL = _T("destination is null");
const BppChar* FLIB_SOURCE_IS_NULL = _T("source is null");
const BppChar* FLIB_ARG_IS_NULL = _T("argument is NULL");
const BppChar* FLIB_INDEX_OUT_OF_RANGE = _T("index out of range");
const BppChar* FLIB_CLASS_NOT_FOUND = _T("class not found");
const BppChar* FLIB_FIRST_ARG_NOT_CLASS = _T("first argument is not a class");
const BppChar* FLIB_FIRST_ARG_NOT_STRING = _T("first argument is not a string");
const BppChar* FLIB_UNKNOWN_CLASS_NAME = _T("unknown class name ");

const BppChar* FLIB_INVALID_TYPE_OF_VALUE_ARG = _T("invalid type of value argument");
const BppChar* FLIB_INVALID_TYPE_OF_REG_ARG = _T("invalid type of register argument");
const BppChar* FLIB_INVALID_REGNAME = _T("invalid register name");
const BppChar* FLIB_INVALID_CALLBACKARGNUM_FMT = _T("callback function of %d arguments not supported");
const BppChar* FLIB_INVALID_CALLBACKINSTANCENUM_FMT = _T("callback function instance number %d not supported");
const BppChar* FLIB_UNKNOWN_ERROR = _T("Unknown error");
const BppChar* FLIB_INVALID_INDEX = _T("invalid index");
const BppChar* FLIB_SYSTEM_CALL_FAILED = _T("System call failed.");

const BppChar* DIO_OPEN_WRITE_FAILED_FMT = _T("opening %s for write failed\n");
const BppChar* DIO_OPEN_READ_FAILED_FMT = _T("opening %s for read failed\n");
const BppChar* DIO_WRITE_ENTRY_FAILED_FMT = _T("error while writing dictionary entry %s\n");
#ifdef _DEBUG
const BppChar* DIO_READ_DICT_SORTFLAG_FAILED_FMT = _T("error reading dictionary (sorted flag) (%d) at position %u\n");
const BppChar* DIO_READ_PTR_FAILED_FMT = _T("error reading pointer (invalid size) at position %u\n");
const BppChar* DIO_ILLEGAL_BASE_REDEFINITION_FMT = _T("illegal redefinition of base class for class %s\n");
const BppChar* DIO_ILLEGAL_OWNER_REDEFINITION_FMT = _T("illegal redefinition of owner class for class %s\n");
const BppChar* DIO_ERROR_READ_STRING_FMT = _T("error reading string at position %u\n");
#endif

const BppChar* REX_PATTERN_EMPTY = _T("Pattern must not be empty.");
const BppChar* REX_INVALID_ARG_VECTOR_EXPECTED = _T("Invalid argument, vector expected.");
const BppChar* REX_TEXT_IS_NULL = _T("text is null");
const BppChar* REX_REPLACEMENT_IS_NULL = _T("replacement is null");
const BppChar* REX_KEY_EXPECTED = _T("key expected");
const BppChar* REX_OBJ_NOT_INITIALIZED = _T("Object not initialized");
const BppChar* REX_INVALID_KEY = _T("invalid key ");

const BppChar* STRUC_INVALID_BUFFER = _T("invalid buffer");
const BppChar* STRUC_INVALID_ITEM_DESC = _T("invalid item descriptor");
const BppChar* STRUC_MEMBER_NOT_CONTAINED = _T("member not contained in struct");
const BppChar* STRUC_INVALID_MEMBER_DESC = _T("invalid member descriptor");
const BppChar* STRUC_VECTOR_EXPECTED = _T("vector expected");
const BppChar* STRUC_DICT_EXPECTED = _T("dictionary expected");
const BppChar* STRUC_SET_VALUE_FAILED = _T("set value failed");
const BppChar* STRUC_GET_VALUE_FAILED = _T("get value failed");
const BppChar* STRUC_GET_DATA_FAILED = _T("get data failed");
const BppChar* STRUC_INVALID_INDEX = _T("invalid index");
const BppChar* STRUC_PURE_VCALL_GETDESC = _T("pure virtual call of 'getStructDesc'");
const BppChar* STRUC_MISSING_STRUCT_DESC = _T("missing structure description");
const BppChar* STRUC_CREATE_BUFFER_DESC_FAILED = _T("create buffer description failed");
const BppChar* STRUC_INVALID_MEMBER_DEF = _T("Invalid definition for member.");
const BppChar* STRUC_SUB_PROXY_NOT_DEFINED = _T("Substructure proxy not defined");
