
#include "bpprobj.h"
#include <stdio.h>
#ifdef BPPCHKMEM
#include <set>
#include <debugapi.h>
static std::set<BppRefObject*>& RSET() {
	static std::set<BppRefObject*> rset;
	return rset;
}
#endif
BppRefObject::BppRefObject() BPPNOEXCEPT
:_refCnt(0)
{
#ifdef BPPCHKMEM
	RSET().insert(this);
#endif
}

BppRefObject::BppRefObject(const BppRefObject&) BPPNOEXCEPT
:_refCnt(0)
{
#ifdef BPPCHKMEM
	RSET().insert(this);
#endif
}

BppRefObject::~BppRefObject() BPPNOEXCEPT
{
#ifdef BPPCHKMEM
	std::set<BppRefObject*>::iterator it = RSET().find(this);
	if (it == RSET().end())
		DebugBreak();
	RSET().erase(this);
#endif
	_refCnt = 0;
}

/**
Function decrements reference counter. If value lower than one (i.e. no more references exist)
object will be deleted.
@return number of remaining references
*/
long BppRefObject::release()
{
	if (_refCnt > 0) {
		if (--_refCnt > 0)
			return _refCnt;
#ifdef BPPCHKMEM
		std::set<BppRefObject*>::iterator it = RSET().find(this);
		if (it == RSET().end())
			DebugBreak();
#endif
		delete this;
	}

	return 0;
}

