/*
 * Created by SharpDevelop.
 * User: erik
 * Date: 01.10.2008
 * Time: 13:19
 * 
 */

using System;
using System.Text;
using System.Runtime.InteropServices;

namespace bp2builder.InterOp
{
	
	/// <summary>
	/// Description of Bp2Printer.
	/// </summary>
	public abstract class Bp2Printer
	{
		public delegate void PrintDelegate(IntPtr pcszValue);	
		
		public Bp2Printer()
		{
			_cbDelegate = new PrintDelegate(CBPrint);
			_nativePrinter = BppCreateCallbackPrinter(_cbDelegate);
		}
		 
		~Bp2Printer()
		{
			BppReleasePrinter(_nativePrinter);
		}
		
		public IntPtr NativePrinter
		{
			get { return _nativePrinter; }
		}
		
		public abstract void DoPrint(string txt);

		private void CBPrint(IntPtr pcszValue)
		{
			if (pcszValue == IntPtr.Zero) return;
			//System.Text.StringBuilder sb = new System.Text.StringBuilder();
			// read bytewise because .NET CF 1.0 doesn't support other methods
			string s = "";
			byte b = Marshal.ReadByte(pcszValue);
			long i = (long) pcszValue;
			while (b != 0)
			{
				char c = (char) b;
				if (c == '\n')
					s += "\r\n";
				else
				  s += c;
				//sb.Append(((char)b).ToString());
				i++;
				b = Marshal.ReadByte((IntPtr) i);
			}
			DoPrint(s);
		}


#region dllimport
#if X64
#if DEBUG
#if _UNICODE
	  const string dllname = "bpplibud_64.dll";
#else
		const string dllname = "bpplibd_64.dll";
#endif
#else
#if _UNICODE
	  const string dllname = "bpplibu_64.dll";
#else
	  const string dllname = "bpplib_64.dll";
#endif
#endif
#else

#if DEBUG
#if _UNICODE
	  const string dllname = "bpplibud.dll";
#else
		const string dllname = "bpplibd.dll";
#endif
#else
#if _UNICODE
	  const string dllname = "bpplibu.dll";
#else
	  const string dllname = "bpplib.dll";
#endif
#endif
#endif
		[DllImport(dllname, EntryPoint = "Bpp_CreateCallbackPrinter")]
		private static extern IntPtr BppCreateCallbackPrinter(PrintDelegate cb);

	  [DllImport(dllname, EntryPoint = "Bpp_ReleasePrinter")]
		private static extern bool BppReleasePrinter(IntPtr pPrinter);
#endregion

		protected IntPtr _nativePrinter;
		private PrintDelegate _cbDelegate;
	
	}
}
