using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;
namespace vmtest
{
	/// <summary>
	/// Zusammenfassung fr ConsoleHelper.
	/// </summary>
	public class ConsoleHelper
	{
		[DllImport("kernel32.dll")]
		private static extern IntPtr GetConsoleWindow();

		[DllImport("kernel32.dll", SetLastError = true, ExactSpelling = true)]
		[return: MarshalAs(UnmanagedType.Bool)]
		private static extern bool AllocConsole();

		const int STD_INPUT_HANDLE = -10;
		const int STD_OUTPUT_HANDLE = -11;
		const int STD_ERROR_HANDLE = -12;

		[DllImport("kernel32.dll", SetLastError = true, ExactSpelling = true)]
		public static extern int GetStdHandle(int nStdHandle);

		[DllImport("user32.dll")]
		private static extern IntPtr SetParent(IntPtr hWndChild, IntPtr hWndNewParent);

		[DllImport("user32.dll")]
		private static extern int SetWindowLong(IntPtr hWnd, int nIndex,int dwNewLong	);
	
		[DllImport("user32.dll")]
		private static extern int GetWindowLong(IntPtr hWnd,int nIndex);

		[DllImport("user32.dll")]
		private static extern bool ShowWindow(IntPtr hWnd, int nCmdShow);

		const int GWL_STYLE = -16;
		const int GWL_WNDPROC = -4;
		const int WS_SYSMENU = 0x00080000;
		const int WS_VISIBLE = 0x10000000;
		const int WS_MINIMIZE = 0x20000000;
		const int WS_MAXIMIZE = 0x01000000;
		const int WS_BORDER = 0x00800000;
		const int SW_HIDE = 0;
		const int SW_SHOW = 5;
		//#define WS_OVERLAPPED       0x00000000L
		//#define WS_POPUP            0x80000000L
		//#define WS_CHILD            0x40000000L
		//#define WS_MINIMIZE         0x20000000L
		//#define WS_VISIBLE          0x10000000L
		//#define WS_DISABLED         0x08000000L
		//#define WS_CLIPSIBLINGS     0x04000000L
		//#define WS_CLIPCHILDREN     0x02000000L
		//#define WS_MAXIMIZE         0x01000000L
		//#define WS_CAPTION          0x00C00000L     /* WS_BORDER | WS_DLGFRAME  */
		//#define WS_BORDER           0x00800000L
		//#define WS_DLGFRAME         0x00400000L
		//#define WS_VSCROLL          0x00200000L
		//#define WS_HSCROLL          0x00100000L
		//#define WS_SYSMENU          0x00080000L
		//#define WS_THICKFRAME       0x00040000L
		//#define WS_GROUP            0x00020000L
		//#define WS_TABSTOP          0x00010000L
		//
		//#define WS_MINIMIZEBOX      0x00020000L
		//#define WS_MAXIMIZEBOX      0x00010000L
		public static void InitConsole()
		{
			IntPtr console = GetConsoleWindow();
			if (console == IntPtr.Zero)
			{
				AllocConsole();
				console = GetConsoleWindow();
			}
//			Control conCtrl = Control.FromHandle(console);
			int styleflags = GetWindowLong(console,GWL_STYLE);
//			string t = conCtrl.Text;
			styleflags &= (~WS_SYSMENU);
			styleflags = SetWindowLong(console,GWL_STYLE,styleflags);
			int hin = GetStdHandle(STD_INPUT_HANDLE);
			int hout = GetStdHandle(STD_OUTPUT_HANDLE);
			int herr = GetStdHandle(STD_ERROR_HANDLE);
            //bp2builder.InterOp.Bp2VM.SetDefaultDevices(hin,hout,herr);

		}

		public static void ShowConsole()
		{
			IntPtr console = GetConsoleWindow();
			if (console == IntPtr.Zero)
			{
				return;
			}
			ShowWindow(console,SW_SHOW);

		}

		public static void HideConsole()
		{
			IntPtr console = GetConsoleWindow();
			if (console == IntPtr.Zero)
			{
				return;
			}
			ShowWindow(console,SW_HIDE);

		}
	}
}
