/*
 * Created by SharpDevelop.
 * User: erik
 * Date: 01.10.2008
 * Time: 18:36
 * 
 */
using System;
using System.Drawing;
using System.Windows.Forms;
using bp2builder.InterOp;
using System.Runtime.InteropServices;
using bp2builder;
using System.IO;
using System.Collections;
using ScintillaNet;

namespace bp2ide
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form, IMsgFormatter
	{
		#region designer privates
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.Panel traceCtrlPane;
		private System.Windows.Forms.Button stopButton;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.Panel bottomPane;
		private System.Windows.Forms.Button runButton;
		private System.Windows.Forms.Splitter splitterHor;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.Button stepButton;
		private System.Windows.Forms.Splitter splitterVer;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel panel4;
		private System.Windows.Forms.MainMenu mainMenu;
		
		private System.Windows.Forms.TabPage errPage;
		private System.Windows.Forms.TextBox errText;
		private System.Windows.Forms.TabPage debugPage;
		private System.Windows.Forms.TextBox dbgText;
		private System.Windows.Forms.TabControl outTabCtrl;
		private System.Windows.Forms.Splitter bottomPaneSplitter;
		private System.Windows.Forms.TextBox outText;
		private System.Windows.Forms.Panel projectPane;
		private System.Windows.Forms.Panel upDownButtonPane;
		private System.Windows.Forms.Button downButton;
		private System.Windows.Forms.Button upButton;
		private System.Windows.Forms.Label projectLabel;
		private System.Windows.Forms.TabControl projectTabCtrl;
		private System.Windows.Forms.TabPage sourceTabPage;
		private System.Windows.Forms.TabPage modulesTabPage;
		private System.Windows.Forms.ListBox sourcesListBox;
		private System.Windows.Forms.ListBox modulesListBox;
		private System.Windows.Forms.MenuItem fileMenu;
		private System.Windows.Forms.MenuItem fileNewMenu;
		private System.Windows.Forms.MenuItem editMenu;
		private System.Windows.Forms.MenuItem fileNewProjectItem;
		private System.Windows.Forms.MenuItem fileNewSourceItem;
		private System.Windows.Forms.TabControl editorTabCtrl;
		private System.Windows.Forms.MenuItem fileOpenMenu;
		private System.Windows.Forms.MenuItem fileOpenProjectItem;
		private System.Windows.Forms.MenuItem fileOpenFileItem;
		private System.Windows.Forms.MenuItem fileSaveMenu;
		private System.Windows.Forms.MenuItem fileSaveProjectItem;
		private System.Windows.Forms.MenuItem fileSaveFileItem;
		private System.Windows.Forms.MenuItem fileSaveAsItem;
		private System.Windows.Forms.MenuItem fileExitItem;
		private System.Windows.Forms.MenuItem fileCloseMenu;
		private System.Windows.Forms.MenuItem fileCloseProjectItem;
		private System.Windows.Forms.MenuItem fileCloseFileItem;
		private System.Windows.Forms.MenuItem editUndoItem;
		private System.Windows.Forms.MenuItem editRedoItem;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem editCutItem;
		private System.Windows.Forms.MenuItem editCopyItem;
		private System.Windows.Forms.MenuItem editPasteItem;
		private System.Windows.Forms.MenuItem menuItem10;
		private System.Windows.Forms.MenuItem editSelectAllItem;
		private System.Windows.Forms.MenuItem viewMenu;
		private System.Windows.Forms.MenuItem viewToolbarItem;
		private System.Windows.Forms.MenuItem projectMenu;
		private System.Windows.Forms.MenuItem projectBuildItem;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem extraMenu;
		private System.Windows.Forms.MenuItem helpMenu;
		private System.Windows.Forms.MenuItem fileSaveAllItem;
		private System.Windows.Forms.MenuItem fileSeparator1;
		private System.Windows.Forms.MenuItem fileSeparator2;
		private System.Windows.Forms.MenuItem projectAddFileItem;
		private System.Windows.Forms.MenuItem projectRemoveFileItem;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem extraOptionItem;

		private System.Windows.Forms.SaveFileDialog saveProjectDialog;
		private System.Windows.Forms.MenuItem helpAboutItem;
		private System.Windows.Forms.OpenFileDialog openProjectDialog;
		private System.Windows.Forms.OpenFileDialog openFileDialog;
		private System.Windows.Forms.SaveFileDialog saveFileDialog;

		private System.Windows.Forms.MenuItem projectSettingsItem;
		private System.Windows.Forms.MenuItem projectAddExistingFileItem;
		private System.Windows.Forms.MenuItem projectAddModuleItem;
		private System.Windows.Forms.MenuItem projectRunItem;
		private System.Windows.Forms.MenuItem projectDebugItem;
		#endregion

		#region project related privates
		private TextBoxPrinter _outPrinter;
		private TextBoxPrinter _dbgPrinter;
		private TextBoxPrinter _errPrinter;
		private TextBoxInput _textInput;
		private Bp2VM _vm;
		private Bp2Project _currentProject  = null;
		private System.Windows.Forms.OpenFileDialog openModuleDialog;
		private System.Windows.Forms.ToolBarButton toolNewProjectItem;
		private System.Windows.Forms.ImageList toolImageList;
		private System.Windows.Forms.ToolBarButton toolNewFileItem;
		private System.Windows.Forms.ToolBarButton toolOpenItem;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ToolBarButton toolAddFileItem;
		private System.Windows.Forms.ToolBarButton toolAddExistingFileItem;
		private System.Windows.Forms.ToolBarButton toolCloseFileItem;
		private System.Windows.Forms.ToolBarButton toolBarSeparator1;
		private System.Windows.Forms.ToolBarButton toolFileSaveItem;
		private System.Windows.Forms.ToolBarButton toolSaveAllItem;
		private System.Windows.Forms.ToolBarButton toolBarSeparator2;
		private System.Windows.Forms.ToolBarButton toolCutItem;
		private System.Windows.Forms.ToolBarButton toolCopyItem;
		private System.Windows.Forms.ToolBarButton toolPasteItem;
		private System.Windows.Forms.ToolBarButton toolSelectAllItem;
		private System.Windows.Forms.ToolBarButton toolBarSeparator3;
		private System.Windows.Forms.ToolBarButton toolUndoItem;
		private System.Windows.Forms.ToolBarButton toolRedoItem;
		private System.Windows.Forms.ToolBarButton toolBarSeparator4;
		private System.Windows.Forms.ToolBarButton toolBuildItem;
		private System.Windows.Forms.ToolBarButton toolRunItem;
		private System.Windows.Forms.ToolBarButton toolProjectSettingsItem;
		private System.Windows.Forms.ToolBarButton toolDebugItem;
		private System.Windows.Forms.MenuItem projectCancelDebugItem;
		private System.Windows.Forms.ToolBarButton toolCancelDebugItem;
		string _defaultProjectLabel;
		#endregion

		[DllImport("kernel32.dll")]
		public static extern IntPtr GetConsoleWindow();

		[DllImport("kernel32.dll", SetLastError = true, ExactSpelling = true)]
		[return: MarshalAs(UnmanagedType.Bool)]
		public static extern bool AllocConsole();

		[DllImport("user32.dll")]
		public static extern IntPtr SetParent(IntPtr hWndChild, IntPtr hWndNewParent);

	  private string _PATH;
	  private string _BPPLIB;
	  private string _BPPINC;
		/// <summary>
		/// MainForm ctor
		/// </summary>
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			#region ctor code
//			IntPtr console = GetConsoleWindow();
//			if (console == IntPtr.Zero)
//			{
//				if (AllocConsole())
//                    console = GetConsoleWindow();
//			}
//			if (console != IntPtr.Zero)
//			{
//				//SetParent(console,this.consolePage.Handle);
//			}
		 _PATH = Environment.GetEnvironmentVariable("Path");
		 _BPPINC = Environment.GetEnvironmentVariable("BPPINC");
		 _BPPLIB = Environment.GetEnvironmentVariable("BPPLIB");

			_outPrinter = new TextBoxPrinter(outText);
			_dbgPrinter = new TextBoxPrinter(dbgText);
			_errPrinter = new TextBoxPrinter(errText);
			_textInput = new TextBoxInput(outText);
			_vm = new Bp2VM(_outPrinter);
			_vm.DebugPrinter = _dbgPrinter;
			_vm.ErrorPrinter = _errPrinter;
			_vm.SetCurrentInput(_textInput);

			outText.GotFocus += new EventHandler(this.OnControlFocus);
			outText.TextChanged += new EventHandler(this.OnControlFocus);
			dbgText.GotFocus += new EventHandler(this.OnControlFocus);
			dbgText.TextChanged += new EventHandler(this.OnControlFocus);
			errText.GotFocus += new EventHandler(this.OnControlFocus);
			errText.TextChanged += new EventHandler(this.OnControlFocus);
			sourcesListBox.GotFocus += new EventHandler(this.OnControlFocus);
			modulesListBox.GotFocus += new EventHandler(this.OnControlFocus);
			
			InitDebugButtons();

			initEditMenu();
			_msgProvider = new MenuItemMessageProvider();
			_msgProvider.Destination = this.statusBar1;
			_msgProvider.MsgFormatter = this;
			_defaultProjectLabel = projectLabel.Text;
			initMenuMessages();
			initProjectItems();
			#endregion
		}
		
		/// <summary>
		/// MainForm dtor
		/// </summary>
		~MainForm()
		{
		 Environment.SetEnvironmentVariable("Path", _PATH);
		 Environment.SetEnvironmentVariable("BPPINC",_BPPINC);
		 Environment.SetEnvironmentVariable("BPPLIB",_BPPLIB);
		 Bp2VM.setEnv("Path", _PATH);
		 Bp2VM.setEnv("BPPINC", _BPPINC);
		 Bp2VM.setEnv("BPPLIB", _BPPLIB);
	  }

		[STAThread]
		public static void Main(string[] args)
		{
			System.Diagnostics.Process process = System.Diagnostics.Process.GetCurrentProcess();
			process.StartInfo.UseShellExecute = false;
			process.StartInfo.RedirectStandardOutput = true;
			process.StartInfo.RedirectStandardError = true;
			process.StartInfo.CreateNoWindow = true;
			
			Application.Run(new MainForm());
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
            this.mainMenu = new System.Windows.Forms.MainMenu(this.components);
            this.fileMenu = new System.Windows.Forms.MenuItem();
            this.fileNewMenu = new System.Windows.Forms.MenuItem();
            this.fileNewProjectItem = new System.Windows.Forms.MenuItem();
            this.fileNewSourceItem = new System.Windows.Forms.MenuItem();
            this.fileOpenMenu = new System.Windows.Forms.MenuItem();
            this.fileOpenProjectItem = new System.Windows.Forms.MenuItem();
            this.fileOpenFileItem = new System.Windows.Forms.MenuItem();
            this.fileCloseMenu = new System.Windows.Forms.MenuItem();
            this.fileCloseProjectItem = new System.Windows.Forms.MenuItem();
            this.fileCloseFileItem = new System.Windows.Forms.MenuItem();
            this.fileSeparator1 = new System.Windows.Forms.MenuItem();
            this.fileSaveMenu = new System.Windows.Forms.MenuItem();
            this.fileSaveProjectItem = new System.Windows.Forms.MenuItem();
            this.fileSaveFileItem = new System.Windows.Forms.MenuItem();
            this.fileSaveAsItem = new System.Windows.Forms.MenuItem();
            this.fileSaveAllItem = new System.Windows.Forms.MenuItem();
            this.fileSeparator2 = new System.Windows.Forms.MenuItem();
            this.fileExitItem = new System.Windows.Forms.MenuItem();
            this.editMenu = new System.Windows.Forms.MenuItem();
            this.editUndoItem = new System.Windows.Forms.MenuItem();
            this.editRedoItem = new System.Windows.Forms.MenuItem();
            this.menuItem9 = new System.Windows.Forms.MenuItem();
            this.editCutItem = new System.Windows.Forms.MenuItem();
            this.editCopyItem = new System.Windows.Forms.MenuItem();
            this.editPasteItem = new System.Windows.Forms.MenuItem();
            this.menuItem10 = new System.Windows.Forms.MenuItem();
            this.editSelectAllItem = new System.Windows.Forms.MenuItem();
            this.viewMenu = new System.Windows.Forms.MenuItem();
            this.viewToolbarItem = new System.Windows.Forms.MenuItem();
            this.projectMenu = new System.Windows.Forms.MenuItem();
            this.projectAddFileItem = new System.Windows.Forms.MenuItem();
            this.projectAddExistingFileItem = new System.Windows.Forms.MenuItem();
            this.projectAddModuleItem = new System.Windows.Forms.MenuItem();
            this.projectRemoveFileItem = new System.Windows.Forms.MenuItem();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.projectBuildItem = new System.Windows.Forms.MenuItem();
            this.projectDebugItem = new System.Windows.Forms.MenuItem();
            this.projectRunItem = new System.Windows.Forms.MenuItem();
            this.projectCancelDebugItem = new System.Windows.Forms.MenuItem();
            this.menuItem11 = new System.Windows.Forms.MenuItem();
            this.projectSettingsItem = new System.Windows.Forms.MenuItem();
            this.extraMenu = new System.Windows.Forms.MenuItem();
            this.extraOptionItem = new System.Windows.Forms.MenuItem();
            this.helpMenu = new System.Windows.Forms.MenuItem();
            this.helpAboutItem = new System.Windows.Forms.MenuItem();
            this.panel4 = new System.Windows.Forms.Panel();
            this.editorTabCtrl = new System.Windows.Forms.TabControl();
            this.panel2 = new System.Windows.Forms.Panel();
            this.splitterVer = new System.Windows.Forms.Splitter();
            this.projectPane = new System.Windows.Forms.Panel();
            this.projectTabCtrl = new System.Windows.Forms.TabControl();
            this.sourceTabPage = new System.Windows.Forms.TabPage();
            this.sourcesListBox = new System.Windows.Forms.ListBox();
            this.modulesTabPage = new System.Windows.Forms.TabPage();
            this.modulesListBox = new System.Windows.Forms.ListBox();
            this.upDownButtonPane = new System.Windows.Forms.Panel();
            this.projectLabel = new System.Windows.Forms.Label();
            this.upButton = new System.Windows.Forms.Button();
            this.downButton = new System.Windows.Forms.Button();
            this.stepButton = new System.Windows.Forms.Button();
            this.menuItem8 = new System.Windows.Forms.MenuItem();
            this.menuItem5 = new System.Windows.Forms.MenuItem();
            this.menuItem6 = new System.Windows.Forms.MenuItem();
            this.splitterHor = new System.Windows.Forms.Splitter();
            this.runButton = new System.Windows.Forms.Button();
            this.bottomPane = new System.Windows.Forms.Panel();
            this.outText = new System.Windows.Forms.TextBox();
            this.bottomPaneSplitter = new System.Windows.Forms.Splitter();
            this.outTabCtrl = new System.Windows.Forms.TabControl();
            this.errPage = new System.Windows.Forms.TabPage();
            this.errText = new System.Windows.Forms.TextBox();
            this.debugPage = new System.Windows.Forms.TabPage();
            this.dbgText = new System.Windows.Forms.TextBox();
            this.traceCtrlPane = new System.Windows.Forms.Panel();
            this.stopButton = new System.Windows.Forms.Button();
            this.menuItem7 = new System.Windows.Forms.MenuItem();
            this.toolBar1 = new System.Windows.Forms.ToolBar();
            this.toolNewProjectItem = new System.Windows.Forms.ToolBarButton();
            this.toolNewFileItem = new System.Windows.Forms.ToolBarButton();
            this.toolAddFileItem = new System.Windows.Forms.ToolBarButton();
            this.toolAddExistingFileItem = new System.Windows.Forms.ToolBarButton();
            this.toolOpenItem = new System.Windows.Forms.ToolBarButton();
            this.toolCloseFileItem = new System.Windows.Forms.ToolBarButton();
            this.toolBarSeparator1 = new System.Windows.Forms.ToolBarButton();
            this.toolFileSaveItem = new System.Windows.Forms.ToolBarButton();
            this.toolSaveAllItem = new System.Windows.Forms.ToolBarButton();
            this.toolBarSeparator2 = new System.Windows.Forms.ToolBarButton();
            this.toolCutItem = new System.Windows.Forms.ToolBarButton();
            this.toolCopyItem = new System.Windows.Forms.ToolBarButton();
            this.toolPasteItem = new System.Windows.Forms.ToolBarButton();
            this.toolSelectAllItem = new System.Windows.Forms.ToolBarButton();
            this.toolBarSeparator3 = new System.Windows.Forms.ToolBarButton();
            this.toolUndoItem = new System.Windows.Forms.ToolBarButton();
            this.toolRedoItem = new System.Windows.Forms.ToolBarButton();
            this.toolBarSeparator4 = new System.Windows.Forms.ToolBarButton();
            this.toolBuildItem = new System.Windows.Forms.ToolBarButton();
            this.toolDebugItem = new System.Windows.Forms.ToolBarButton();
            this.toolRunItem = new System.Windows.Forms.ToolBarButton();
            this.toolCancelDebugItem = new System.Windows.Forms.ToolBarButton();
            this.toolProjectSettingsItem = new System.Windows.Forms.ToolBarButton();
            this.toolImageList = new System.Windows.Forms.ImageList(this.components);
            this.menuItem3 = new System.Windows.Forms.MenuItem();
            this.statusBar1 = new System.Windows.Forms.StatusBar();
            this.saveProjectDialog = new System.Windows.Forms.SaveFileDialog();
            this.openProjectDialog = new System.Windows.Forms.OpenFileDialog();
            this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
            this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
            this.openModuleDialog = new System.Windows.Forms.OpenFileDialog();
            this.panel4.SuspendLayout();
            this.panel2.SuspendLayout();
            this.projectPane.SuspendLayout();
            this.projectTabCtrl.SuspendLayout();
            this.sourceTabPage.SuspendLayout();
            this.modulesTabPage.SuspendLayout();
            this.upDownButtonPane.SuspendLayout();
            this.bottomPane.SuspendLayout();
            this.outTabCtrl.SuspendLayout();
            this.errPage.SuspendLayout();
            this.debugPage.SuspendLayout();
            this.traceCtrlPane.SuspendLayout();
            this.SuspendLayout();
            // 
            // mainMenu
            // 
            this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.fileMenu,
            this.editMenu,
            this.viewMenu,
            this.projectMenu,
            this.extraMenu,
            this.helpMenu});
            // 
            // fileMenu
            // 
            this.fileMenu.Index = 0;
            this.fileMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.fileNewMenu,
            this.fileOpenMenu,
            this.fileCloseMenu,
            this.fileSeparator1,
            this.fileSaveMenu,
            this.fileSaveAsItem,
            this.fileSaveAllItem,
            this.fileSeparator2,
            this.fileExitItem});
            resources.ApplyResources(this.fileMenu, "fileMenu");
            // 
            // fileNewMenu
            // 
            this.fileNewMenu.Index = 0;
            this.fileNewMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.fileNewProjectItem,
            this.fileNewSourceItem});
            resources.ApplyResources(this.fileNewMenu, "fileNewMenu");
            // 
            // fileNewProjectItem
            // 
            this.fileNewProjectItem.Index = 0;
            resources.ApplyResources(this.fileNewProjectItem, "fileNewProjectItem");
            this.fileNewProjectItem.Click += new System.EventHandler(this.fileNewProjectItem_Click);
            // 
            // fileNewSourceItem
            // 
            this.fileNewSourceItem.Index = 1;
            resources.ApplyResources(this.fileNewSourceItem, "fileNewSourceItem");
            this.fileNewSourceItem.Click += new System.EventHandler(this.fileNewSourceItem_Click);
            // 
            // fileOpenMenu
            // 
            this.fileOpenMenu.Index = 1;
            this.fileOpenMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.fileOpenProjectItem,
            this.fileOpenFileItem});
            resources.ApplyResources(this.fileOpenMenu, "fileOpenMenu");
            // 
            // fileOpenProjectItem
            // 
            this.fileOpenProjectItem.Index = 0;
            resources.ApplyResources(this.fileOpenProjectItem, "fileOpenProjectItem");
            this.fileOpenProjectItem.Click += new System.EventHandler(this.fileOpenProjectItem_Click);
            // 
            // fileOpenFileItem
            // 
            this.fileOpenFileItem.Index = 1;
            resources.ApplyResources(this.fileOpenFileItem, "fileOpenFileItem");
            this.fileOpenFileItem.Click += new System.EventHandler(this.fileOpenFileItem_Click);
            // 
            // fileCloseMenu
            // 
            this.fileCloseMenu.Index = 2;
            this.fileCloseMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.fileCloseProjectItem,
            this.fileCloseFileItem});
            resources.ApplyResources(this.fileCloseMenu, "fileCloseMenu");
            // 
            // fileCloseProjectItem
            // 
            this.fileCloseProjectItem.Index = 0;
            resources.ApplyResources(this.fileCloseProjectItem, "fileCloseProjectItem");
            this.fileCloseProjectItem.Click += new System.EventHandler(this.fileCloseProjectItem_Click);
            // 
            // fileCloseFileItem
            // 
            this.fileCloseFileItem.Index = 1;
            resources.ApplyResources(this.fileCloseFileItem, "fileCloseFileItem");
            this.fileCloseFileItem.Click += new System.EventHandler(this.fileCloseFileItem_Click);
            // 
            // fileSeparator1
            // 
            this.fileSeparator1.Index = 3;
            resources.ApplyResources(this.fileSeparator1, "fileSeparator1");
            // 
            // fileSaveMenu
            // 
            this.fileSaveMenu.Index = 4;
            this.fileSaveMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.fileSaveProjectItem,
            this.fileSaveFileItem});
            resources.ApplyResources(this.fileSaveMenu, "fileSaveMenu");
            // 
            // fileSaveProjectItem
            // 
            this.fileSaveProjectItem.Index = 0;
            resources.ApplyResources(this.fileSaveProjectItem, "fileSaveProjectItem");
            this.fileSaveProjectItem.Click += new System.EventHandler(this.fileSaveProjectItem_Click);
            // 
            // fileSaveFileItem
            // 
            this.fileSaveFileItem.Index = 1;
            resources.ApplyResources(this.fileSaveFileItem, "fileSaveFileItem");
            this.fileSaveFileItem.Click += new System.EventHandler(this.fileSaveFileItem_Click);
            // 
            // fileSaveAsItem
            // 
            this.fileSaveAsItem.Index = 5;
            resources.ApplyResources(this.fileSaveAsItem, "fileSaveAsItem");
            this.fileSaveAsItem.Click += new System.EventHandler(this.fileSaveAsItem_Click);
            // 
            // fileSaveAllItem
            // 
            this.fileSaveAllItem.Index = 6;
            resources.ApplyResources(this.fileSaveAllItem, "fileSaveAllItem");
            this.fileSaveAllItem.Click += new System.EventHandler(this.fileSaveAllItem_Click);
            // 
            // fileSeparator2
            // 
            this.fileSeparator2.Index = 7;
            resources.ApplyResources(this.fileSeparator2, "fileSeparator2");
            // 
            // fileExitItem
            // 
            this.fileExitItem.Index = 8;
            resources.ApplyResources(this.fileExitItem, "fileExitItem");
            this.fileExitItem.Click += new System.EventHandler(this.fileExitItem_Click);
            // 
            // editMenu
            // 
            this.editMenu.Index = 1;
            this.editMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.editUndoItem,
            this.editRedoItem,
            this.menuItem9,
            this.editCutItem,
            this.editCopyItem,
            this.editPasteItem,
            this.menuItem10,
            this.editSelectAllItem});
            resources.ApplyResources(this.editMenu, "editMenu");
            this.editMenu.Popup += new System.EventHandler(this.editMenu_Popup);
            // 
            // editUndoItem
            // 
            this.editUndoItem.Index = 0;
            resources.ApplyResources(this.editUndoItem, "editUndoItem");
            this.editUndoItem.Click += new System.EventHandler(this.editUndoItem_Click);
            // 
            // editRedoItem
            // 
            this.editRedoItem.Index = 1;
            resources.ApplyResources(this.editRedoItem, "editRedoItem");
            this.editRedoItem.Click += new System.EventHandler(this.editRedoItem_Click);
            // 
            // menuItem9
            // 
            this.menuItem9.Index = 2;
            resources.ApplyResources(this.menuItem9, "menuItem9");
            // 
            // editCutItem
            // 
            this.editCutItem.Index = 3;
            resources.ApplyResources(this.editCutItem, "editCutItem");
            this.editCutItem.Click += new System.EventHandler(this.editCutItem_Click);
            // 
            // editCopyItem
            // 
            this.editCopyItem.Index = 4;
            resources.ApplyResources(this.editCopyItem, "editCopyItem");
            this.editCopyItem.Click += new System.EventHandler(this.editCopyItem_Click);
            // 
            // editPasteItem
            // 
            this.editPasteItem.Index = 5;
            resources.ApplyResources(this.editPasteItem, "editPasteItem");
            this.editPasteItem.Click += new System.EventHandler(this.editPasteItem_Click);
            // 
            // menuItem10
            // 
            this.menuItem10.Index = 6;
            resources.ApplyResources(this.menuItem10, "menuItem10");
            // 
            // editSelectAllItem
            // 
            this.editSelectAllItem.Index = 7;
            resources.ApplyResources(this.editSelectAllItem, "editSelectAllItem");
            this.editSelectAllItem.Click += new System.EventHandler(this.editSelectAllItem_Click);
            // 
            // viewMenu
            // 
            this.viewMenu.Index = 2;
            this.viewMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.viewToolbarItem});
            resources.ApplyResources(this.viewMenu, "viewMenu");
            // 
            // viewToolbarItem
            // 
            this.viewToolbarItem.Checked = true;
            this.viewToolbarItem.Index = 0;
            resources.ApplyResources(this.viewToolbarItem, "viewToolbarItem");
            this.viewToolbarItem.Click += new System.EventHandler(this.viewToolbarItem_Click);
            // 
            // projectMenu
            // 
            this.projectMenu.Index = 3;
            this.projectMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.projectAddFileItem,
            this.projectAddExistingFileItem,
            this.projectAddModuleItem,
            this.projectRemoveFileItem,
            this.menuItem1,
            this.projectBuildItem,
            this.projectDebugItem,
            this.projectRunItem,
            this.projectCancelDebugItem,
            this.menuItem11,
            this.projectSettingsItem});
            resources.ApplyResources(this.projectMenu, "projectMenu");
            // 
            // projectAddFileItem
            // 
            this.projectAddFileItem.Index = 0;
            resources.ApplyResources(this.projectAddFileItem, "projectAddFileItem");
            this.projectAddFileItem.Click += new System.EventHandler(this.projectAddFileItem_Click);
            // 
            // projectAddExistingFileItem
            // 
            this.projectAddExistingFileItem.Index = 1;
            resources.ApplyResources(this.projectAddExistingFileItem, "projectAddExistingFileItem");
            this.projectAddExistingFileItem.Click += new System.EventHandler(this.projectAddExistingFileItem_Click);
            // 
            // projectAddModuleItem
            // 
            this.projectAddModuleItem.Index = 2;
            resources.ApplyResources(this.projectAddModuleItem, "projectAddModuleItem");
            this.projectAddModuleItem.Click += new System.EventHandler(this.projectAddModuleItem_Click);
            // 
            // projectRemoveFileItem
            // 
            this.projectRemoveFileItem.Index = 3;
            resources.ApplyResources(this.projectRemoveFileItem, "projectRemoveFileItem");
            this.projectRemoveFileItem.Click += new System.EventHandler(this.projectRemoveFileItem_Click);
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 4;
            resources.ApplyResources(this.menuItem1, "menuItem1");
            // 
            // projectBuildItem
            // 
            this.projectBuildItem.Index = 5;
            resources.ApplyResources(this.projectBuildItem, "projectBuildItem");
            this.projectBuildItem.Click += new System.EventHandler(this.projectBuildItem_Click);
            // 
            // projectDebugItem
            // 
            this.projectDebugItem.Index = 6;
            resources.ApplyResources(this.projectDebugItem, "projectDebugItem");
            this.projectDebugItem.Click += new System.EventHandler(this.projectDebugItem_Click);
            // 
            // projectRunItem
            // 
            this.projectRunItem.Index = 7;
            resources.ApplyResources(this.projectRunItem, "projectRunItem");
            this.projectRunItem.Click += new System.EventHandler(this.projectRunItem_Click);
            // 
            // projectCancelDebugItem
            // 
            resources.ApplyResources(this.projectCancelDebugItem, "projectCancelDebugItem");
            this.projectCancelDebugItem.Index = 8;
            this.projectCancelDebugItem.Click += new System.EventHandler(this.projectCancelDebugItem_Click);
            // 
            // menuItem11
            // 
            this.menuItem11.Index = 9;
            resources.ApplyResources(this.menuItem11, "menuItem11");
            // 
            // projectSettingsItem
            // 
            this.projectSettingsItem.Index = 10;
            resources.ApplyResources(this.projectSettingsItem, "projectSettingsItem");
            this.projectSettingsItem.Click += new System.EventHandler(this.projectSettingsItem_Click);
            // 
            // extraMenu
            // 
            this.extraMenu.Index = 4;
            this.extraMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.extraOptionItem});
            resources.ApplyResources(this.extraMenu, "extraMenu");
            // 
            // extraOptionItem
            // 
            this.extraOptionItem.Index = 0;
            resources.ApplyResources(this.extraOptionItem, "extraOptionItem");
            this.extraOptionItem.Click += new System.EventHandler(this.extraOptionItem_Click);
            // 
            // helpMenu
            // 
            this.helpMenu.Index = 5;
            this.helpMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.helpAboutItem});
            resources.ApplyResources(this.helpMenu, "helpMenu");
            // 
            // helpAboutItem
            // 
            this.helpAboutItem.Index = 0;
            resources.ApplyResources(this.helpAboutItem, "helpAboutItem");
            this.helpAboutItem.Click += new System.EventHandler(this.helpAboutItem_Click);
            // 
            // panel4
            // 
            this.panel4.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.panel4.Controls.Add(this.editorTabCtrl);
            resources.ApplyResources(this.panel4, "panel4");
            this.panel4.Name = "panel4";
            // 
            // editorTabCtrl
            // 
            resources.ApplyResources(this.editorTabCtrl, "editorTabCtrl");
            this.editorTabCtrl.Name = "editorTabCtrl";
            this.editorTabCtrl.SelectedIndex = 0;
            this.editorTabCtrl.SelectedIndexChanged += new System.EventHandler(this.editorTabCtrl_SelectedIndexChanged);
            // 
            // panel2
            // 
            this.panel2.Controls.Add(this.panel4);
            this.panel2.Controls.Add(this.splitterVer);
            this.panel2.Controls.Add(this.projectPane);
            resources.ApplyResources(this.panel2, "panel2");
            this.panel2.Name = "panel2";
            // 
            // splitterVer
            // 
            this.splitterVer.BackColor = System.Drawing.SystemColors.Control;
            resources.ApplyResources(this.splitterVer, "splitterVer");
            this.splitterVer.Name = "splitterVer";
            this.splitterVer.TabStop = false;
            // 
            // projectPane
            // 
            this.projectPane.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.projectPane.Controls.Add(this.projectTabCtrl);
            this.projectPane.Controls.Add(this.upDownButtonPane);
            resources.ApplyResources(this.projectPane, "projectPane");
            this.projectPane.Name = "projectPane";
            // 
            // projectTabCtrl
            // 
            resources.ApplyResources(this.projectTabCtrl, "projectTabCtrl");
            this.projectTabCtrl.Controls.Add(this.sourceTabPage);
            this.projectTabCtrl.Controls.Add(this.modulesTabPage);
            this.projectTabCtrl.Multiline = true;
            this.projectTabCtrl.Name = "projectTabCtrl";
            this.projectTabCtrl.SelectedIndex = 0;
            // 
            // sourceTabPage
            // 
            this.sourceTabPage.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.sourceTabPage.Controls.Add(this.sourcesListBox);
            resources.ApplyResources(this.sourceTabPage, "sourceTabPage");
            this.sourceTabPage.Name = "sourceTabPage";
            // 
            // sourcesListBox
            // 
            this.sourcesListBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
            resources.ApplyResources(this.sourcesListBox, "sourcesListBox");
            this.sourcesListBox.Name = "sourcesListBox";
            this.sourcesListBox.DoubleClick += new System.EventHandler(this.sourcesListBox_DoubleClick);
            // 
            // modulesTabPage
            // 
            this.modulesTabPage.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.modulesTabPage.Controls.Add(this.modulesListBox);
            resources.ApplyResources(this.modulesTabPage, "modulesTabPage");
            this.modulesTabPage.Name = "modulesTabPage";
            // 
            // modulesListBox
            // 
            this.modulesListBox.BorderStyle = System.Windows.Forms.BorderStyle.None;
            resources.ApplyResources(this.modulesListBox, "modulesListBox");
            this.modulesListBox.Name = "modulesListBox";
            // 
            // upDownButtonPane
            // 
            this.upDownButtonPane.Controls.Add(this.projectLabel);
            this.upDownButtonPane.Controls.Add(this.upButton);
            this.upDownButtonPane.Controls.Add(this.downButton);
            resources.ApplyResources(this.upDownButtonPane, "upDownButtonPane");
            this.upDownButtonPane.Name = "upDownButtonPane";
            // 
            // projectLabel
            // 
            resources.ApplyResources(this.projectLabel, "projectLabel");
            this.projectLabel.Name = "projectLabel";
            // 
            // upButton
            // 
            resources.ApplyResources(this.upButton, "upButton");
            this.upButton.Name = "upButton";
            this.upButton.Click += new System.EventHandler(this.upButton_Click);
            // 
            // downButton
            // 
            resources.ApplyResources(this.downButton, "downButton");
            this.downButton.Name = "downButton";
            this.downButton.Click += new System.EventHandler(this.downButton_Click);
            // 
            // stepButton
            // 
            resources.ApplyResources(this.stepButton, "stepButton");
            this.stepButton.Name = "stepButton";
            this.stepButton.Click += new System.EventHandler(this.StepButtonClick);
            // 
            // menuItem8
            // 
            this.menuItem8.Index = -1;
            resources.ApplyResources(this.menuItem8, "menuItem8");
            // 
            // menuItem5
            // 
            this.menuItem5.Index = -1;
            resources.ApplyResources(this.menuItem5, "menuItem5");
            // 
            // menuItem6
            // 
            this.menuItem6.Index = -1;
            resources.ApplyResources(this.menuItem6, "menuItem6");
            // 
            // splitterHor
            // 
            this.splitterHor.BackColor = System.Drawing.SystemColors.Control;
            resources.ApplyResources(this.splitterHor, "splitterHor");
            this.splitterHor.Name = "splitterHor";
            this.splitterHor.TabStop = false;
            // 
            // runButton
            // 
            resources.ApplyResources(this.runButton, "runButton");
            this.runButton.Name = "runButton";
            this.runButton.Click += new System.EventHandler(this.RunButtonClick);
            // 
            // bottomPane
            // 
            this.bottomPane.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.bottomPane.Controls.Add(this.outText);
            this.bottomPane.Controls.Add(this.bottomPaneSplitter);
            this.bottomPane.Controls.Add(this.outTabCtrl);
            this.bottomPane.Controls.Add(this.traceCtrlPane);
            resources.ApplyResources(this.bottomPane, "bottomPane");
            this.bottomPane.Name = "bottomPane";
            // 
            // outText
            // 
            this.outText.AcceptsReturn = true;
            this.outText.AcceptsTab = true;
            this.outText.BackColor = System.Drawing.SystemColors.Window;
            resources.ApplyResources(this.outText, "outText");
            this.outText.Name = "outText";
            this.outText.ReadOnly = true;
            // 
            // bottomPaneSplitter
            // 
            resources.ApplyResources(this.bottomPaneSplitter, "bottomPaneSplitter");
            this.bottomPaneSplitter.Name = "bottomPaneSplitter";
            this.bottomPaneSplitter.TabStop = false;
            // 
            // outTabCtrl
            // 
            resources.ApplyResources(this.outTabCtrl, "outTabCtrl");
            this.outTabCtrl.Controls.Add(this.errPage);
            this.outTabCtrl.Controls.Add(this.debugPage);
            this.outTabCtrl.HotTrack = true;
            this.outTabCtrl.Multiline = true;
            this.outTabCtrl.Name = "outTabCtrl";
            this.outTabCtrl.SelectedIndex = 0;
            // 
            // errPage
            // 
            this.errPage.Controls.Add(this.errText);
            resources.ApplyResources(this.errPage, "errPage");
            this.errPage.Name = "errPage";
            // 
            // errText
            // 
            this.errText.BackColor = System.Drawing.SystemColors.Window;
            resources.ApplyResources(this.errText, "errText");
            this.errText.Name = "errText";
            this.errText.ReadOnly = true;
            this.errText.DoubleClick += new System.EventHandler(this.errText_DoubleClick);
            // 
            // debugPage
            // 
            this.debugPage.Controls.Add(this.dbgText);
            resources.ApplyResources(this.debugPage, "debugPage");
            this.debugPage.Name = "debugPage";
            // 
            // dbgText
            // 
            this.dbgText.BackColor = System.Drawing.SystemColors.Window;
            resources.ApplyResources(this.dbgText, "dbgText");
            this.dbgText.Name = "dbgText";
            this.dbgText.ReadOnly = true;
            // 
            // traceCtrlPane
            // 
            resources.ApplyResources(this.traceCtrlPane, "traceCtrlPane");
            this.traceCtrlPane.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.traceCtrlPane.Controls.Add(this.stopButton);
            this.traceCtrlPane.Controls.Add(this.runButton);
            this.traceCtrlPane.Controls.Add(this.stepButton);
            this.traceCtrlPane.Name = "traceCtrlPane";
            // 
            // stopButton
            // 
            resources.ApplyResources(this.stopButton, "stopButton");
            this.stopButton.Name = "stopButton";
            this.stopButton.Click += new System.EventHandler(this.StopButtonClick);
            // 
            // menuItem7
            // 
            this.menuItem7.Index = -1;
            resources.ApplyResources(this.menuItem7, "menuItem7");
            // 
            // toolBar1
            // 
            resources.ApplyResources(this.toolBar1, "toolBar1");
            this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
            this.toolNewProjectItem,
            this.toolNewFileItem,
            this.toolAddFileItem,
            this.toolAddExistingFileItem,
            this.toolOpenItem,
            this.toolCloseFileItem,
            this.toolBarSeparator1,
            this.toolFileSaveItem,
            this.toolSaveAllItem,
            this.toolBarSeparator2,
            this.toolCutItem,
            this.toolCopyItem,
            this.toolPasteItem,
            this.toolSelectAllItem,
            this.toolBarSeparator3,
            this.toolUndoItem,
            this.toolRedoItem,
            this.toolBarSeparator4,
            this.toolBuildItem,
            this.toolDebugItem,
            this.toolRunItem,
            this.toolCancelDebugItem,
            this.toolProjectSettingsItem});
            this.toolBar1.Divider = false;
            this.toolBar1.ImageList = this.toolImageList;
            this.toolBar1.Name = "toolBar1";
            this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
            // 
            // toolNewProjectItem
            // 
            resources.ApplyResources(this.toolNewProjectItem, "toolNewProjectItem");
            this.toolNewProjectItem.Name = "toolNewProjectItem";
            // 
            // toolNewFileItem
            // 
            resources.ApplyResources(this.toolNewFileItem, "toolNewFileItem");
            this.toolNewFileItem.Name = "toolNewFileItem";
            // 
            // toolAddFileItem
            // 
            resources.ApplyResources(this.toolAddFileItem, "toolAddFileItem");
            this.toolAddFileItem.Name = "toolAddFileItem";
            // 
            // toolAddExistingFileItem
            // 
            resources.ApplyResources(this.toolAddExistingFileItem, "toolAddExistingFileItem");
            this.toolAddExistingFileItem.Name = "toolAddExistingFileItem";
            // 
            // toolOpenItem
            // 
            resources.ApplyResources(this.toolOpenItem, "toolOpenItem");
            this.toolOpenItem.Name = "toolOpenItem";
            // 
            // toolCloseFileItem
            // 
            resources.ApplyResources(this.toolCloseFileItem, "toolCloseFileItem");
            this.toolCloseFileItem.Name = "toolCloseFileItem";
            // 
            // toolBarSeparator1
            // 
            this.toolBarSeparator1.Name = "toolBarSeparator1";
            this.toolBarSeparator1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // toolFileSaveItem
            // 
            resources.ApplyResources(this.toolFileSaveItem, "toolFileSaveItem");
            this.toolFileSaveItem.Name = "toolFileSaveItem";
            // 
            // toolSaveAllItem
            // 
            resources.ApplyResources(this.toolSaveAllItem, "toolSaveAllItem");
            this.toolSaveAllItem.Name = "toolSaveAllItem";
            // 
            // toolBarSeparator2
            // 
            this.toolBarSeparator2.Name = "toolBarSeparator2";
            this.toolBarSeparator2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // toolCutItem
            // 
            resources.ApplyResources(this.toolCutItem, "toolCutItem");
            this.toolCutItem.Name = "toolCutItem";
            // 
            // toolCopyItem
            // 
            resources.ApplyResources(this.toolCopyItem, "toolCopyItem");
            this.toolCopyItem.Name = "toolCopyItem";
            // 
            // toolPasteItem
            // 
            resources.ApplyResources(this.toolPasteItem, "toolPasteItem");
            this.toolPasteItem.Name = "toolPasteItem";
            // 
            // toolSelectAllItem
            // 
            resources.ApplyResources(this.toolSelectAllItem, "toolSelectAllItem");
            this.toolSelectAllItem.Name = "toolSelectAllItem";
            // 
            // toolBarSeparator3
            // 
            this.toolBarSeparator3.Name = "toolBarSeparator3";
            this.toolBarSeparator3.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // toolUndoItem
            // 
            resources.ApplyResources(this.toolUndoItem, "toolUndoItem");
            this.toolUndoItem.Name = "toolUndoItem";
            // 
            // toolRedoItem
            // 
            resources.ApplyResources(this.toolRedoItem, "toolRedoItem");
            this.toolRedoItem.Name = "toolRedoItem";
            // 
            // toolBarSeparator4
            // 
            this.toolBarSeparator4.Name = "toolBarSeparator4";
            this.toolBarSeparator4.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // toolBuildItem
            // 
            resources.ApplyResources(this.toolBuildItem, "toolBuildItem");
            this.toolBuildItem.Name = "toolBuildItem";
            // 
            // toolDebugItem
            // 
            resources.ApplyResources(this.toolDebugItem, "toolDebugItem");
            this.toolDebugItem.Name = "toolDebugItem";
            // 
            // toolRunItem
            // 
            resources.ApplyResources(this.toolRunItem, "toolRunItem");
            this.toolRunItem.Name = "toolRunItem";
            // 
            // toolCancelDebugItem
            // 
            resources.ApplyResources(this.toolCancelDebugItem, "toolCancelDebugItem");
            this.toolCancelDebugItem.Name = "toolCancelDebugItem";
            // 
            // toolProjectSettingsItem
            // 
            resources.ApplyResources(this.toolProjectSettingsItem, "toolProjectSettingsItem");
            this.toolProjectSettingsItem.Name = "toolProjectSettingsItem";
            // 
            // toolImageList
            // 
            this.toolImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("toolImageList.ImageStream")));
            this.toolImageList.TransparentColor = System.Drawing.Color.Transparent;
            this.toolImageList.Images.SetKeyName(0, "");
            this.toolImageList.Images.SetKeyName(1, "");
            this.toolImageList.Images.SetKeyName(2, "");
            this.toolImageList.Images.SetKeyName(3, "");
            this.toolImageList.Images.SetKeyName(4, "");
            this.toolImageList.Images.SetKeyName(5, "");
            this.toolImageList.Images.SetKeyName(6, "");
            this.toolImageList.Images.SetKeyName(7, "");
            this.toolImageList.Images.SetKeyName(8, "");
            this.toolImageList.Images.SetKeyName(9, "");
            this.toolImageList.Images.SetKeyName(10, "");
            this.toolImageList.Images.SetKeyName(11, "");
            this.toolImageList.Images.SetKeyName(12, "");
            this.toolImageList.Images.SetKeyName(13, "");
            this.toolImageList.Images.SetKeyName(14, "");
            this.toolImageList.Images.SetKeyName(15, "");
            this.toolImageList.Images.SetKeyName(16, "");
            this.toolImageList.Images.SetKeyName(17, "");
            this.toolImageList.Images.SetKeyName(18, "");
            // 
            // menuItem3
            // 
            this.menuItem3.Index = -1;
            resources.ApplyResources(this.menuItem3, "menuItem3");
            // 
            // statusBar1
            // 
            resources.ApplyResources(this.statusBar1, "statusBar1");
            this.statusBar1.Name = "statusBar1";
            // 
            // saveProjectDialog
            // 
            this.saveProjectDialog.CreatePrompt = true;
            this.saveProjectDialog.DefaultExt = "bprj";
            resources.ApplyResources(this.saveProjectDialog, "saveProjectDialog");
            this.saveProjectDialog.RestoreDirectory = true;
            // 
            // openProjectDialog
            // 
            this.openProjectDialog.AddExtension = false;
            resources.ApplyResources(this.openProjectDialog, "openProjectDialog");
            // 
            // openFileDialog
            // 
            this.openFileDialog.AddExtension = false;
            resources.ApplyResources(this.openFileDialog, "openFileDialog");
            // 
            // saveFileDialog
            // 
            this.saveFileDialog.CreatePrompt = true;
            this.saveFileDialog.DefaultExt = "bpp";
            resources.ApplyResources(this.saveFileDialog, "saveFileDialog");
            this.saveFileDialog.RestoreDirectory = true;
            // 
            // openModuleDialog
            // 
            this.openModuleDialog.AddExtension = false;
            resources.ApplyResources(this.openModuleDialog, "openModuleDialog");
            // 
            // MainForm
            // 
            resources.ApplyResources(this, "$this");
            this.Controls.Add(this.panel2);
            this.Controls.Add(this.splitterHor);
            this.Controls.Add(this.bottomPane);
            this.Controls.Add(this.statusBar1);
            this.Controls.Add(this.toolBar1);
            this.Menu = this.mainMenu;
            this.Name = "MainForm";
            this.Closing += new System.ComponentModel.CancelEventHandler(this.MainFormClosing);
            this.Load += new System.EventHandler(this.MainForm_Load);
            this.MenuComplete += new System.EventHandler(this.MainForm_MenuComplete);
            this.panel4.ResumeLayout(false);
            this.panel2.ResumeLayout(false);
            this.projectPane.ResumeLayout(false);
            this.projectTabCtrl.ResumeLayout(false);
            this.sourceTabPage.ResumeLayout(false);
            this.modulesTabPage.ResumeLayout(false);
            this.upDownButtonPane.ResumeLayout(false);
            this.bottomPane.ResumeLayout(false);
            this.bottomPane.PerformLayout();
            this.outTabCtrl.ResumeLayout(false);
            this.errPage.ResumeLayout(false);
            this.errPage.PerformLayout();
            this.debugPage.ResumeLayout(false);
            this.debugPage.PerformLayout();
            this.traceCtrlPane.ResumeLayout(false);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion
		
		void MenuItem9Click(object sender, System.EventArgs e)
		{
//			_vm.ShowDecode = true;
//			_vm.Trace = true;
//			InitDebugButtons();
//			if (_vm.CompileText(this.editBox.Text))
//			{
//				_stopRequest = true;
//				stopButton.Enabled = true;
//				_vm.SetDbgWaitFunc(new Bp2VM.DbgWaitDelegate(HandleDbgWait));
//				_vm.SetBreakRequestFunc(new Bp2VM.BreakRequestDelegate(HandleStopRequest));
//				_vm.Execute();
//			}
//			InitDebugButtons();
		}

	  private void buildEnvVariables()
	  {
		 if (_currentProject == null) return;
		 string path = _PATH;
		 string bppinc = _BPPINC;
		 string bpplib = _BPPLIB;
		if ((path != null) && (path.Length > 0))
			path += ";";
		else
			path = "";
		 path += _currentProject.LocPath;
		 if (_currentProject.PathDirs.Length > 0)
		 {
			   path += ";";
			   path += _currentProject.PathDirs.Replace("$(PRJDIR)",_currentProject.LocPath);
		 }
		 Environment.SetEnvironmentVariable("Path", path);
		 Bp2VM.setEnv("Path", path);
			if ((bppinc != null) && (bppinc.Length > 0))
				bppinc += ";";
			else
				bppinc = "";
			bppinc += _currentProject.LocPath;
			if (_currentProject.IncDirs.Length > 0)
		 {
			   bppinc += ";";
			   bppinc += _currentProject.IncDirs.Replace("$(PRJDIR)", _currentProject.LocPath);
		 }
		 Environment.SetEnvironmentVariable("BPPINC", bppinc);
		 Bp2VM.setEnv("BPPINC", bppinc);
			if ((bpplib != null) && (bpplib.Length > 0))
				bpplib += ";";
			else
				bpplib = "";
			bpplib += _currentProject.LocPath;
		 if (_currentProject.LibDirs.Length > 0)
		 {
			   bpplib += ";";
			   bpplib += _currentProject.LibDirs.Replace("$(PRJDIR)", _currentProject.LocPath);
		 }
		 Environment.SetEnvironmentVariable("BPPLIB", bpplib);
		 Bp2VM.setEnv("BPPLIB", bpplib);
	  }

		/// <summary>
		/// initialization of message id's for menu items
		/// </summary>
		void initMenuMessages()
		{
			this._msgProvider.AddItem(fileMenu,"msg_fileMenu"); 
			this._msgProvider.AddItem(fileNewMenu,"msg_fileNewMenu"); 
			this._msgProvider.AddItem(fileNewProjectItem,"msg_fileNewProjectItem"); 
			this._msgProvider.AddItem(fileNewSourceItem,"msg_fileNewSourceItem"); 
			this._msgProvider.AddItem(fileOpenMenu,"msg_fileOpenMenu"); 
			this._msgProvider.AddItem(fileOpenProjectItem,"msg_fileOpenProjectItem"); 
			this._msgProvider.AddItem(fileOpenFileItem,"msg_fileOpenFileItem"); 
			this._msgProvider.AddItem(fileCloseMenu,"msg_fileCloseMenu"); 
			this._msgProvider.AddItem(fileCloseProjectItem,"msg_fileCloseProjectItem"); 
			this._msgProvider.AddItem(fileCloseFileItem,"msg_fileCloseFileItem"); 
			this._msgProvider.AddItem(fileSaveMenu,"msg_fileSaveMenu"); 
			this._msgProvider.AddItem(fileSaveProjectItem,"msg_fileSaveProjectItem"); 
			this._msgProvider.AddItem(fileSaveFileItem,"msg_fileSaveFileItem"); 
			this._msgProvider.AddItem(fileSaveAsItem,"msg_fileSaveAsItem"); 
			this._msgProvider.AddItem(fileSaveAllItem,"msg_fileSaveAllItem"); 
			this._msgProvider.AddItem(fileExitItem,"msg_fileExitItem"); 
			this._msgProvider.AddItem(editMenu,"msg_editMenu"); 
			this._msgProvider.AddItem(editUndoItem,"msg_editUndoItem"); 
			this._msgProvider.AddItem(editRedoItem,"msg_editRedoItem"); 
			this._msgProvider.AddItem(editCutItem,"msg_editCutItem"); 
			this._msgProvider.AddItem(editCopyItem,"msg_editCopyItem"); 
			this._msgProvider.AddItem(editPasteItem,"msg_editPasteItem"); 
			this._msgProvider.AddItem(editSelectAllItem,"msg_editSelectAllItem"); 
			this._msgProvider.AddItem(viewMenu,"msg_viewMenu"); 
			this._msgProvider.AddItem(viewToolbarItem,"msg_viewToolbarItem"); 
			this._msgProvider.AddItem(projectMenu,"msg_projectMenu"); 
			this._msgProvider.AddItem(projectAddFileItem,"msg_projectAddFileItem"); 
			this._msgProvider.AddItem(projectAddExistingFileItem,"msg_projectAddExistingFileItem"); 
			this._msgProvider.AddItem(projectAddModuleItem,"msg_projectAddModuleItem"); 
			this._msgProvider.AddItem(projectRunItem,"msg_projectRunItem"); 
			this._msgProvider.AddItem(projectDebugItem,"msg_projectDebugItem"); 
			this._msgProvider.AddItem(projectRemoveFileItem,"msg_projectRemoveFileItem"); 
			this._msgProvider.AddItem(projectSettingsItem,"msg_projectSettingsItem"); 
			this._msgProvider.AddItem(projectBuildItem,"msg_projectBuildItem"); 
			this._msgProvider.AddItem(extraMenu,"msg_extraMenu"); 
			this._msgProvider.AddItem(extraOptionItem,"msg_extraOptionItem"); 
			this._msgProvider.AddItem(helpMenu,"msg_helpMenu"); 
			this._msgProvider.AddItem(helpAboutItem,"msg_helpAboutItem"); 
		}
		
		/// <summary>
		/// enables/disabled items of edit menu
		/// </summary>
		void initEditMenu()
		{
		 Control editCtrl = CurrentEditor;
		 TextBoxBase editTBox = editCtrl as TextBoxBase;
		 RichTextBox rtb = editTBox as RichTextBox;
		 Scintilla scintilla = editCtrl as Scintilla;
			if ((null == editCtrl) || (!editCtrl.Enabled))
			{
				this.editRedoItem.Enabled = false;
				this.editUndoItem.Enabled = false;
				this.editCutItem.Enabled = false;
				this.editPasteItem.Enabled = false;
				this.editCopyItem.Enabled = false;
				this.editSelectAllItem.Enabled = false;
				this.toolCopyItem.Enabled = editCopyItem.Enabled;
				this.toolCutItem.Enabled = editCutItem.Enabled;
				this.toolPasteItem.Enabled = editPasteItem.Enabled;
				this.toolSelectAllItem.Enabled = editSelectAllItem.Enabled;
				this.toolRedoItem.Enabled = this.editRedoItem.Enabled;
				this.toolUndoItem.Enabled = this.editUndoItem.Enabled;
			}
		 if (null != editTBox)
		 {
			editUndoItem.Enabled = editTBox.CanUndo;
			editRedoItem.Enabled = (null != rtb) ? rtb.CanRedo : false;
			editCopyItem.Enabled = true;
			editCutItem.Enabled = (!editTBox.ReadOnly);
			editPasteItem.Enabled = (null != rtb) ? rtb.CanPaste(DataFormats.GetFormat(DataFormats.UnicodeText)) : (!editTBox.ReadOnly);
			editSelectAllItem.Enabled = (editTBox.Text.Length > 0);
		 }
		 else if (null != scintilla)
		 {
			editUndoItem.Enabled = scintilla.UndoRedo.CanUndo;
			editRedoItem.Enabled = scintilla.UndoRedo.CanRedo;
			editCopyItem.Enabled = scintilla.Selection.Length > 0;
			editCutItem.Enabled = (!scintilla.IsReadOnly) && (scintilla.Selection.Length > 0);
			editPasteItem.Enabled = scintilla.Clipboard.CanPaste;
			editSelectAllItem.Enabled = (scintilla.Text.Length > 0);
		 }
		 else
		 {
			editUndoItem.Enabled = false;
			editRedoItem.Enabled = false;
			editCopyItem.Enabled = false;
			editCutItem.Enabled = false;
			editPasteItem.Enabled = false;
			editSelectAllItem.Enabled = false;
		 }
			this.toolCopyItem.Enabled = editCopyItem.Enabled;
			this.toolCutItem.Enabled = editCutItem.Enabled;
			this.toolPasteItem.Enabled = editPasteItem.Enabled;
			this.toolSelectAllItem.Enabled = editSelectAllItem.Enabled;
			this.toolRedoItem.Enabled = this.editRedoItem.Enabled;
			this.toolUndoItem.Enabled = this.editUndoItem.Enabled;
		}
		private Control _currentEditor;
		private MenuItemMessageProvider _msgProvider;

		/// <summary>
		/// get/set currently selected edit control
		/// </summary>
		public Control CurrentEditor
		{
			get
			{
				if (null != _currentEditor)
				{
					if (_currentEditor.IsDisposed)
					{
						_currentEditor = null;
						initEditMenu();
					}
				}
				return _currentEditor;
			}
			set
			{
				_currentEditor = value;
				initEditMenu();
			}
		}

		public bp2builder.Bp2Project CurrentProject
		{
			get { return _currentProject; }
			set 
			{ 
				_currentProject = value; 
				if (null == _currentProject)
					projectLabel.Text = _defaultProjectLabel;
				else
					projectLabel.Text = _currentProject.Name;
				initProjectItems();
			}
		}

		private void initProjectItems()
		{
			bool enable = (_currentProject != null);
			this.projectRemoveFileItem.Enabled = enable;
			this.projectAddExistingFileItem.Enabled = enable;
			this.projectAddFileItem.Enabled = enable;
			this.projectAddModuleItem.Enabled = enable;
			this.projectBuildItem.Enabled = enable;
			this.projectDebugItem.Enabled = enable;
			this.projectRunItem.Enabled = enable;
			this.projectSettingsItem.Enabled = enable;
			this.fileCloseProjectItem.Enabled = enable;
			this.fileSaveProjectItem.Enabled = enable;
			this.projectPane.Enabled = enable;
			this.toolAddExistingFileItem.Enabled = enable;
			this.toolAddFileItem.Enabled = enable;
			this.toolBuildItem.Enabled = enable;
			this.toolDebugItem.Enabled = enable;
			this.toolProjectSettingsItem.Enabled = enable;
			this.toolRunItem.Enabled = enable;
		}
		void OnTabCloseRequest(EditorTabPage page)
		{
			closeSourceDoc(page.SourceDoc);
		}

		/// <summary>
		/// focus change handler for edit controls
		/// </summary>
		/// <param name="sender">selected control</param>
		/// <param name="e">ignored</param>
		void OnControlFocus(object sender, EventArgs e)
		{
			CurrentEditor = sender as Control;
		}

		#region debugging
		void InitDebugButtons()
		{
		   _stopRequest = false;
		   _stepResult = false;
		   _inStepWait = false;
		   stopButton.Enabled = false;
		   stepButton.Enabled = false;
		   runButton.Enabled = false;
		}

		bool HandleStopRequest(IntPtr pVM)
		{
		//	Application.DoEvents();
			if (_stopRequest)
			{
				_stopRequest = false;
				stopButton.Enabled = false;
				return true;
			}
			return false;
		}

	  bool HandleLineChanged(IntPtr pVM,IntPtr pcszFName, int lineNumber)
	  {
		  string fname = "";
		  unsafe { fname = new String((sbyte*)pcszFName); }
		  foreach (Object o in CurrentProject.Sources)
		  {
			  Bp2SourceDoc doc = o as Bp2SourceDoc;
			  if (doc != null && doc.Location == fname)
			  {
				  if (doc.Breakpoints.Contains(lineNumber))
				  {
					  _stopRequest = true;
					  stopButton.Enabled = false;
				  }
				  if (_stopRequest || _stepResult)
				  {
						Scintilla ed = doc.Editor as Scintilla;
						if (ed != null)
						{
							Application.DoEvents();
							ed.Caret.LineNumber = lineNumber - 1;
							ed.Selection.Start = ed.Caret.Position;
							ed.Selection.End = ed.Caret.Position;
							ed.Caret.EnsureVisible();
							ed.Focus();
							Application.DoEvents();
						}
					}
				  break;
			  }
		  }
		 return false;
	  }
	  
	  bool HandleDbgWait(IntPtr pVM)
		{
			_inStepWait = true;
			stepButton.Enabled = true;
			runButton.Enabled = true;
			stepButton.Refresh();
			runButton.Refresh();
			Application.DoEvents();
			while (_inStepWait)
			{
				System.Threading.Thread.Sleep(100);
				Application.DoEvents();
			}
			if (!_stepResult)
			{
				stopButton.Enabled = true;
				stepButton.Enabled = false;
				runButton.Enabled = false;
			}
			return _stepResult;
		}

		void StopButtonClick(object sender, System.EventArgs e)
		{
			_stopRequest = true;
			stopButton.Enabled = false;
		}
		
		void StepButtonClick(object sender, System.EventArgs e)
		{
			_stepResult = true;
			_inStepWait = false;
		}
		
		void RunButtonClick(object sender, System.EventArgs e)
		{
			_stepResult = false;
			_inStepWait = false;			
		}
		
		private bool _stopRequest = false;
		private bool _stepResult = false;
		private bool _inStepWait = false;
	  //private int _currentLine = -1;
	  //private string _currentSource = "";
		#endregion
		
		#region project handling


		private bool newProject()
		{
			string dlgTitle = saveProjectDialog.Title;
			saveProjectDialog.Title = MsgFormat("msg_NewProjectTitle");
			saveProjectDialog.FileName = "";
			DialogResult dlgresult = saveProjectDialog.ShowDialog();
			saveProjectDialog.Title = dlgTitle;
			if (dlgresult != DialogResult.OK) return false;
			if (!closeProject())
				return false;
			CurrentProject = new Bp2Project();
			CurrentProject.Location = saveProjectDialog.FileName;
			CurrentProject.Name = CurrentProject.ShortName;
			CurrentProject.Sources = sourcesListBox.Items;
			CurrentProject.Modules = modulesListBox.Items;
			CurrentProject.DestFile = CurrentProject.Name + ".bpm";
			if (!CurrentProject.Save())
			{
			   CurrentProject = null;
				return false;
			}
			else
			   CurrentProject = CurrentProject;
			CurrentProject.VM = _vm;
			CurrentProject.Changed = false;
			return true;
		}
		
		private Bp2SourceDoc newSourceFile()
		{
			string dlgTitle = saveFileDialog.Title;
			saveFileDialog.Title = MsgFormat("msg_NewSourceFileTitle");
			saveFileDialog.FileName = "";
			DialogResult dlgresult = saveFileDialog.ShowDialog();
			saveFileDialog.Title = dlgTitle;
			if (dlgresult != DialogResult.OK) return null;
			Bp2SourceDoc doc = new Bp2SourceDoc();
			doc.Location = saveFileDialog.FileName;
			doc.Text = "";
			doc.Loaded = true;
			if (!doc.Save())
			{
				return null;
			}
			doc.Changed = false;
			return doc;
		}

		private bool openProject()
		{
			openProjectDialog.FileName = "";
			if (DialogResult.OK != openProjectDialog.ShowDialog()) return false;
			if (!closeProject()) return false;
			CurrentProject = new Bp2Project();
			CurrentProject.Location = openProjectDialog.FileName;
			CurrentProject.Sources = sourcesListBox.Items;
			CurrentProject.Modules = modulesListBox.Items;
			if (!CurrentProject.Load())
			{
				CurrentProject = null;
				return false;
			}
			else
				CurrentProject = CurrentProject;
			CurrentProject.VM = _vm;
			CurrentProject.Changed = false;
			return true;
		}

		private bool saveProject()
		{
			if (null == CurrentProject)
				return true;
			if (!CurrentProject.Changed)
				return true;
			if (CurrentProject.Location == "")
				return saveProjectAs();
			return CurrentProject.Save();
		}

		private bool saveProjectAs()
		{
			if (null == CurrentProject)
				return false;
			if (CurrentProject.Location == "")
			{
				// TODO Standardverzeichnis setzen
				saveProjectDialog.FileName = CurrentProject.Name;
				saveProjectDialog.InitialDirectory = "";
			}
			else
			{
				saveProjectDialog.FileName = CurrentProject.FileName;
				saveProjectDialog.InitialDirectory = CurrentProject.FileDir;
			}
			string oldLoc = CurrentProject.Location;
			bool oldChange = CurrentProject.Changed;
			if (DialogResult.OK == saveProjectDialog.ShowDialog())
			{
				CurrentProject.Location = saveProjectDialog.FileName;
				if (saveProject()) return true;
				CurrentProject.Location = oldLoc;
				CurrentProject.Changed = oldChange;
			}
			return false;
		}

		private bool saveAll()
		{
			IEnumerator it = editorTabCtrl.TabPages.GetEnumerator();
			while (it.MoveNext())
			{
				EditorTabPage page = it.Current as EditorTabPage;
				if (null == page) continue;
				Bp2SourceDoc doc = page.SourceDoc;
				if (null == doc) continue;
				if (!saveSourceFile(doc))
					return false;
			}
			if (null == CurrentProject)
				return true;
			return saveProject();
		}

		private bool closeProject()
		{
			if (null == CurrentProject) return true;
			bool ok = true;

			IEnumerator it = CurrentProject.Sources.GetEnumerator();
			while (it.MoveNext())
			{
				Bp2SourceDoc doc = it.Current as Bp2SourceDoc;
				if (!closeSourceDoc(doc))
					return false;
			}

			if (CurrentProject.Changed)
			{
				DialogResult result = MessageBox.Show(MsgFormat("msg_PrjNotSaved",CurrentProject.Name),Application.ProductName,MessageBoxButtons.YesNoCancel);
				if (result == DialogResult.Yes)
					ok = ("" == CurrentProject.Location) ? saveProjectAs() : saveProject();
				else if (result == DialogResult.Cancel)
					ok = false;
			}
			if (!ok) return false;

			CurrentProject.Sources.Clear();
			CurrentProject.Modules.Clear();
			CurrentProject = null;
			return true;
		}


		private bool closeSourceDoc(Bp2SourceDoc doc)
		{
			if (null == doc)
				return true;
			if (doc.Changed)
			{
				DialogResult result = MessageBox.Show(MsgFormat("msg_FileNotSaved",doc.FileName),Application.ProductName,MessageBoxButtons.YesNoCancel);
				if (result == DialogResult.Yes)
				{
					if (!saveSourceFile(doc))
						return false;
				}
				else if (result == DialogResult.Cancel)
					return false;
			}
		 Control editor = doc.Editor;
			if (null != editor)
			{
				doc.Editor = null;
				EditorTabPage page = editor.Parent as EditorTabPage;
				if (null != page)
				{
					page.SourceDoc = null;
					editorTabCtrl.TabPages.Remove(page);
				}
			}
			doc.Loaded = false;
			doc.Changed = false;
			return true;
		}

		private bool saveSourceFile(Bp2SourceDoc doc)
		{
			if (null == doc) return false;
			if (doc.DocType != Bp2Doc.DocTypes.Source)
				return false;
			if (doc.Location == "")
				return saveSourceFileAs(doc);
			if (!doc.Changed) return true;
			if (doc.Save())
			{
				TextBoxBase rtb = doc.Editor as TextBoxBase;
			if (null != rtb)
			   rtb.Modified = false;
			else
			{
			   Scintilla sc = doc.Editor as Scintilla;
			   if (null != sc)
				  sc.Modified = false;
			}
			}
			return false;
		}

		private bool saveSourceFileAs(Bp2SourceDoc doc)
		{
			if (null == doc) return false;
			if (doc.DocType != Bp2Doc.DocTypes.Source)
				return false;
			this.saveFileDialog.FileName = doc.FileName;
			saveFileDialog.InitialDirectory = doc.FileDir;

			string oldLoc = doc.Location;
			bool oldChange = doc.Changed;
			if (DialogResult.OK == saveFileDialog.ShowDialog())
			{
				doc.Location = saveFileDialog.FileName;
				if (doc.Save()) 
				{
					if (null != doc.OwnerProject)
						  doc.OwnerProject.Changed = true;
					sourcesListBox.Refresh();
					TextBoxBase ed = doc.Editor as TextBoxBase;
			   if (null != ed)
			   {
				  ed.Modified = false;
				  TabPage page = ed.Parent as TabPage;
				  if (null != page)
				  {
					 page.Text = doc.ToString();
					 page.ToolTipText = doc.Location;
				  }
			   }
			   else
			   {
				  Scintilla sc = doc.Editor as Scintilla;
				  TabPage page = sc.Parent as TabPage;
				  if (null != page)
				  {
					 page.Text = doc.ToString();
					 page.ToolTipText = doc.Location;
				  }
			   }
					
					return true;
				}
				doc.Location = oldLoc;
				doc.Changed = oldChange;
			}
			return false;
		}


		private bool addExistingSourceFile()
		{
			if (null == CurrentProject) return false;
			if (DialogResult.OK != openFileDialog.ShowDialog()) return false;
			FileInfo info = new FileInfo(openFileDialog.FileName);
			if (!info.Exists) return false;
			IEnumerator it = sourcesListBox.Items.GetEnumerator();
			while (it.MoveNext())
			{
				Bp2SourceDoc sd = it.Current as Bp2SourceDoc;
				if (null != sd)
				{
					FileInfo info2 = new FileInfo(sd.Location);
					
					if (info.FullName == info2.FullName)
					{
						return false;
					}
				}
			}
			Bp2SourceDoc doc = new Bp2SourceDoc();
			doc.Location = openFileDialog.FileName;
			doc.Loaded = false;
			sourcesListBox.Items.Add(doc);
			CurrentProject.Changed = true;
			doc.Changed = false;
			return true;
		}

		private bool addNewSourceFile()
		{
			if (null == CurrentProject) return false;
			Bp2SourceDoc doc = newSourceFile();
			if (null == doc) return false;
			FileInfo info = new FileInfo(doc.Location);
			IEnumerator it = sourcesListBox.Items.GetEnumerator();
			while (it.MoveNext())
			{
				Bp2SourceDoc sd = it.Current as Bp2SourceDoc;
				if (null != sd)
				{
					FileInfo info2 = new FileInfo(sd.Location);
					
					if (info.FullName == info2.FullName)
					{
						return false;
					}
				}
			}
			sourcesListBox.Items.Add(doc);
			CurrentProject.Changed = true;
			doc.Changed = false;
			return true;
		}

		private bool addModule()
		{
			if (null == CurrentProject) return false;
			if (DialogResult.OK != openModuleDialog.ShowDialog()) return false;
			FileInfo info = new FileInfo(openModuleDialog.FileName);
			if (!info.Exists) return false;
			IEnumerator it = modulesListBox.Items.GetEnumerator();
			while (it.MoveNext())
			{
				Bp2SourceDoc sd = it.Current as Bp2SourceDoc;
				if (null != sd)
				{
					FileInfo info2 = new FileInfo(sd.Location);
					
					if (info.FullName == info2.FullName)
					{
						return false;
					}
				}
			}
			Bp2SourceDoc doc = new Bp2SourceDoc();
			doc.DocType = Bp2Doc.DocTypes.Module;
			doc.Location = openModuleDialog.FileName;
			doc.Loaded = false;
			modulesListBox.Items.Add(doc);
			CurrentProject.Changed = true;
			doc.Changed = false;
			return true;
		}

		private Bp2SourceDoc openFile()
		{
			if (DialogResult.OK == openFileDialog.ShowDialog())
			{
				return openFile(openFileDialog.FileName);
			}
			return null;
		}

		private Bp2SourceDoc openFile(string fullPath)
		{
			if (fullPath.Length == 0)
			   return null;

			Bp2SourceDoc sdoc = null;
			for (int i=0; i<sourcesListBox.Items.Count;++i)
			{
				Bp2SourceDoc sd = sourcesListBox.Items[i] as Bp2SourceDoc;
				if (null != sd)
				{
					FileInfo info = new FileInfo(fullPath);
					FileInfo info2 = new FileInfo(sd.Location);
					
					if (info.FullName == info2.FullName)
					{
						sdoc = sd;
						sourcesListBox.SelectedIndex = i;
						Control ed = sdoc.Editor;
						if (null != ed)
						{
							TabPage edpage = ed.Parent as TabPage;
							if (null != edpage)
							{
								editorTabCtrl.SelectedTab = edpage;
								ed.Select();
								return sdoc;
							}
						}
						break;
					}
				}
			}
			if (null == sdoc)
			{
				sdoc = new Bp2SourceDoc();
				sdoc.Location = fullPath;
				if (!sdoc.Load()) return null;
			}
			addSourceTab(sdoc);
			sdoc.Changed = false;
			return sdoc;
		}

		#endregion
		
		private void addSourceTab(Bp2SourceDoc sdoc)
		{
			EditorTabPage newPage = new EditorTabPage();
			editorTabCtrl.TabPages.Add(newPage);
			if (!sdoc.Loaded)
				sdoc.Load();
			newPage.Text = sdoc.ToString();
			newPage.ToolTipText = sdoc.Location;
			newPage.SourceDoc = sdoc;
			newPage.CloseRequestFunc = new EditorTabPage.CloseRequestDelegate(OnTabCloseRequest);
			newPage.Editor.GotFocus += new EventHandler(this.OnControlFocus);
			newPage.Editor.Enter += new EventHandler(this.OnControlFocus);
			newPage.Editor.TextChanged += new EventHandler(this.OnControlFocus);
			editorTabCtrl.SelectedTab = newPage;
			newPage.Editor.Select(); 
			sdoc.Changed = false;
			newPage.Modified = false;
		}

		void MainFormClosing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (_inStepWait)
			{
//				System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
				string cancelDebugMsg = _resources.GetString("cancelDebugMsg");
				string cancelDbgMsgCaption = _resources.GetString("cancelDbgMsgCaption");
				if (MessageBox.Show(cancelDebugMsg,cancelDbgMsgCaption,MessageBoxButtons.YesNo,MessageBoxIcon.Question) == DialogResult.No)
					e.Cancel = true;
				else
					_inStepWait = false;
			}
			if (!closeProject())
				e.Cancel = true;
		}


		
		private static System.Resources.ResourceManager _resources = new System.Resources.ResourceManager("bp2ide.MainFormStrings",typeof(MainForm).Assembly);

		public virtual string MsgFormat(string name, params object[] args)
		{
			string fmt = _resources.GetString(name);
			if (null == fmt)
			{
				fmt = " ";
				if (args.Length > 0)
				{
					for (int i=0; i< args.Length; ++i)
						fmt += String.Format("{{{0}}} ",i);
				}
				else fmt = name;
			}
			return String.Format(fmt,args);
		}

		#region menu item handler
		private void fileNewProjectItem_Click(object sender, System.EventArgs e)
		{
		   newProject();
		}

		private void fileNewSourceItem_Click(object sender, System.EventArgs e)
		{
			Bp2Doc d = newSourceFile();
			if (null != d)
				openFile(d.Location);
		}

		private void fileOpenProjectItem_Click(object sender, System.EventArgs e)
		{
			openProject();
		}

		private void fileOpenFileItem_Click(object sender, System.EventArgs e)
		{
			openFile();
		}

		private void fileCloseProjectItem_Click(object sender, System.EventArgs e)
		{
			closeProject();
		}

		private void fileCloseFileItem_Click(object sender, System.EventArgs e)
		{
			EditorTabPage page = editorTabCtrl.SelectedTab as EditorTabPage;
			if (null != page)
				closeSourceDoc(page.SourceDoc);
		}

		private void fileSaveProjectItem_Click(object sender, System.EventArgs e)
		{
			saveProject();
		}

		private void fileSaveFileItem_Click(object sender, System.EventArgs e)
		{
			EditorTabPage page = editorTabCtrl.SelectedTab as EditorTabPage;
			if (null != page)
				saveSourceFile(page.SourceDoc);
		}

		private void fileSaveAsItem_Click(object sender, System.EventArgs e)
		{
			EditorTabPage page = editorTabCtrl.SelectedTab as EditorTabPage;
			if (null != page)
				saveSourceFileAs(page.SourceDoc);
		}

		private void fileSaveAllItem_Click(object sender, System.EventArgs e)
		{
			saveAll();
		}

		private void fileExitItem_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void editUndoItem_Click(object sender, System.EventArgs e)
		{
			TextBoxBase ed = CurrentEditor as TextBoxBase;
		 if (null != ed)
		 {
			if (ed.CanUndo)
			   ed.Undo();
		 }
		 else
		 {
			Scintilla sc = CurrentEditor as Scintilla;
			if (null != sc)
			{
			   if (sc.UndoRedo.CanUndo)
				  sc.UndoRedo.Undo();
			}
		 }
		}

		private void editRedoItem_Click(object sender, System.EventArgs e)
		{
		 RichTextBox ed = CurrentEditor as RichTextBox;
		 if (null != ed)
		 {
			if (ed.CanRedo)
			   ed.Redo();
		 }
		 else
		 {
			Scintilla sc = CurrentEditor as Scintilla;
			if (null != sc)
			{
			   if (sc.UndoRedo.CanRedo)
				  sc.UndoRedo.Redo();
			}
		 }
	  }

		private void editCutItem_Click(object sender, System.EventArgs e)
		{
		 TextBoxBase ed = CurrentEditor as TextBoxBase;
		 if (null != ed)
		 {
			if (!ed.ReadOnly)
			   ed.Cut();
		 }
		 else
		 {
			Scintilla sc = CurrentEditor as Scintilla;
			if (null != sc)
			{
			   if (!sc.IsReadOnly)
				  sc.Clipboard.Cut();
			}
		 }
	  }

		private void editCopyItem_Click(object sender, System.EventArgs e)
		{
		 TextBoxBase ed = CurrentEditor as TextBoxBase;
		 if (null != ed)
		 {
			   ed.Copy();
		 }
		 else
		 {
			Scintilla sc = CurrentEditor as Scintilla;
			if (null != sc)
			{
				  sc.Clipboard.Copy();
			}
		 }
	  }

		private void editPasteItem_Click(object sender, System.EventArgs e)
		{
		 TextBoxBase ed = CurrentEditor as TextBoxBase;
		 if (null != ed)
		 {
			if (!ed.ReadOnly)
			   ed.Paste();
		 }
		 else
		 {
			Scintilla sc = CurrentEditor as Scintilla;
			if (null != sc)
			{
			   if (!sc.IsReadOnly)
				  sc.Clipboard.Paste();
			}
		 }
	  }

		private void editSelectAllItem_Click(object sender, System.EventArgs e)
		{
		 TextBoxBase ed = CurrentEditor as TextBoxBase;
		 if (null != ed)
		 {
			ed.SelectAll();
		 }
		 else
		 {
			Scintilla sc = CurrentEditor as Scintilla;
			if (null != sc)
			{
			   sc.Selection.SelectAll();
			}
		 }
	  }

		private void viewToolbarItem_Click(object sender, System.EventArgs e)
		{
			viewToolbarItem.Checked = !viewToolbarItem.Checked;
			toolBar1.Visible = viewToolbarItem.Checked;
		}

		private void projectAddFileItem_Click(object sender, System.EventArgs e)
		{
		   addNewSourceFile();
		}

		private void projectAddExistingFileItem_Click(object sender, System.EventArgs e)
		{
			addExistingSourceFile();
		}

		private void projectRemoveFileItem_Click(object sender, System.EventArgs e)
		{
			if (null == CurrentProject) return;
			TabPage page = projectTabCtrl.SelectedTab;
			if (sourcesListBox.Parent == page)
			{
				Bp2SourceDoc doc = sourcesListBox.SelectedItem as Bp2SourceDoc;
				if (null == doc) return;
				sourcesListBox.Items.Remove(doc);
				CurrentProject.Changed = true;
			}
			else if (modulesListBox.Parent == page)
			{
				Bp2SourceDoc doc = modulesListBox.SelectedItem as Bp2SourceDoc;
				if (null == doc) return;
				modulesListBox.Items.Remove(doc);
				CurrentProject.Changed = true;
			}
		}

		private void projectAddModuleItem_Click(object sender, System.EventArgs e)
		{
			addModule();
		}

		private void projectDebugItem_Click(object sender, System.EventArgs e)
		{
			if (null == CurrentProject) return;
		 buildEnvVariables();
			errText.Clear();
			dbgText.Clear();
			outText.Clear();
			if (CurrentProject.NeedsBuild)
			{
				_vm.ShowDecode = CurrentProject.ShowCode;
//				_vm.ShowInfo = true;
				if (!CurrentProject.Build()) return;
			}
			_vm.Trace = CurrentProject.ShowTrace;
		 _stopRequest = CurrentProject.ShowTrace;
			string curdir = Directory.GetCurrentDirectory();
			try
			{
				stopButton.Enabled = true;
				_vm.SetDbgWaitFunc(new Bp2VM.DbgWaitDelegate(HandleDbgWait));
				_vm.SetBreakRequestFunc(new Bp2VM.BreakRequestDelegate(HandleStopRequest));
				_vm.SetLineChangedFunc(new Bp2VM.LineChangedDelegate(HandleLineChanged));
				projectCancelDebugItem.Enabled = true;
				toolCancelDebugItem.Enabled = true;

				Directory.SetCurrentDirectory(CurrentProject.FileDir);

				projectCancelDebugItem.Enabled = true;
				toolCancelDebugItem.Enabled = true;
				string odir = CurrentProject.OutDir;
				if (odir.Length == 0 || (!Directory.Exists(odir)))
					odir = CurrentProject.FileDir;
				Directory.SetCurrentDirectory(odir);

				_vm.Execute();
			}
			catch (Exception ex)
			{
				_errPrinter.DoPrint(ex.Message);
			}
			finally
			{
				Directory.SetCurrentDirectory(curdir);
				InitDebugButtons();
				_vm.SetDbgWaitFunc(null);
				_vm.SetBreakRequestFunc(null);
				toolCancelDebugItem.Enabled = false;
				projectCancelDebugItem.Enabled = false;
			}
		}

		private void projectRunItem_Click(object sender, System.EventArgs e)
		{
			if (null == CurrentProject) return;
		 buildEnvVariables();
		 errText.Clear();
			dbgText.Clear();
			outText.Clear();
			if (CurrentProject.NeedsBuild)
			{
				_vm.ShowDecode = CurrentProject.ShowCode;
//				_vm.ShowInfo = true;
				if (!CurrentProject.Build()) return;
			}
			_vm.Trace = false;
			string curdir = Directory.GetCurrentDirectory();
			try
			{
				Directory.SetCurrentDirectory(CurrentProject.FileDir);

				projectCancelDebugItem.Enabled = true;
				toolCancelDebugItem.Enabled = true;
					string odir = CurrentProject.OutDir;
					if (odir.Length == 0 || (!Directory.Exists(odir)))
						odir = CurrentProject.FileDir;
					Directory.SetCurrentDirectory(odir);
 
				_vm.Execute();
			}
			catch (Exception ex)
			{
				_errPrinter.DoPrint(ex.Message);
			}
			finally
			{
				Directory.SetCurrentDirectory(curdir);
			}
			toolCancelDebugItem.Enabled = false;
			projectCancelDebugItem.Enabled = false;
		}

		private void projectCancelDebugItem_Click(object sender, System.EventArgs e)
		{
		   _stopRequest = false;
			_vm.Cancel();
		}

		private void projectBuildItem_Click(object sender, System.EventArgs e)
		{
			if (null == CurrentProject) return;
		 buildEnvVariables();

			errText.Clear();
			dbgText.Clear();
			outText.Clear();
//			if (CurrentProject.NeedsBuild)
//			{
				_vm.ShowDecode = CurrentProject.ShowCode;
//				_vm.ShowInfo = true;
				CurrentProject.Build();
//			}
		}

		private void projectSettingsItem_Click(object sender, System.EventArgs e)
		{
			if (null != CurrentProject)
			{
				ProjectSettingsDialog dlg = new ProjectSettingsDialog();
				dlg.ProjectName = CurrentProject.Name;
				dlg.OutputDir = CurrentProject.OutDir;
				dlg.OutputModule = CurrentProject.DestFile;
				dlg.CreateModule = CurrentProject.BuildModule;
			dlg.CreateDebugInfo = CurrentProject.CreateDebugInfo;
			dlg.ShowCode = CurrentProject.ShowCode;
			dlg.ShowTrace = CurrentProject.ShowTrace;
			dlg.IncludeDirs = CurrentProject.IncDirs;
			dlg.PathDirs = CurrentProject.PathDirs;
			dlg.LibDirs = CurrentProject.LibDirs;
                dlg.Defines = CurrentProject.Defines;
				if (DialogResult.OK == dlg.ShowDialog())
				{
					CurrentProject.Name = dlg.ProjectName;
					CurrentProject.OutDir = dlg.OutputDir;
					CurrentProject.DestFile = dlg.OutputModule;
					CurrentProject.BuildModule = dlg.CreateModule;
			   CurrentProject.CreateDebugInfo = dlg.CreateDebugInfo;
			   CurrentProject.ShowCode = dlg.ShowCode;
			   CurrentProject.ShowTrace = dlg.ShowTrace;
			   CurrentProject.IncDirs = dlg.IncludeDirs;
			   CurrentProject.LibDirs = dlg.LibDirs;
			   CurrentProject.PathDirs = dlg.PathDirs;
                    CurrentProject.Defines = dlg.Defines;
					CurrentProject = CurrentProject;
				}
			}
		}

		private void extraOptionItem_Click(object sender, System.EventArgs e)
		{
		
		}

		private void helpAboutItem_Click(object sender, System.EventArgs e)
		{
			AboutBox ab = new AboutBox();
			ab.ShowDialog(this);
		}
		#endregion

		private void editorTabCtrl_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			EditorTabPage page = editorTabCtrl.SelectedTab as EditorTabPage;
			if (null != page)
				CurrentEditor = page.Editor;
			else
				CurrentEditor = null;

		}

		private void editMenu_Popup(object sender, System.EventArgs e)
		{
			initEditMenu();
		}

		private void sourcesListBox_DoubleClick(object sender, System.EventArgs e)
		{
			Bp2SourceDoc doc = sourcesListBox.SelectedItem as Bp2SourceDoc;
			if (null != doc)
			{
				this.openFile(doc.Location);
			}
		}

		private void upButton_Click(object sender, System.EventArgs e)
		{
			if (null == CurrentProject) return;
			TabPage page = projectTabCtrl.SelectedTab;
			if (sourcesListBox.Parent == page)
			{
				Bp2SourceDoc doc = sourcesListBox.SelectedItem as Bp2SourceDoc;
				if (null == doc) return;
				int idx = sourcesListBox.SelectedIndex;
				if (idx > 0)
				{
					sourcesListBox.Items.Remove(doc);
					sourcesListBox.Items.Insert(idx-1,doc);
					sourcesListBox.SelectedItem = doc;
					CurrentProject.Changed = true;
				}
			}
			else if (modulesListBox.Parent == page)
			{
				Bp2SourceDoc doc = modulesListBox.SelectedItem as Bp2SourceDoc;
				if (null == doc) return;
				int idx = modulesListBox.SelectedIndex;
				if (idx > 0)
				{
					modulesListBox.Items.Remove(doc);
					modulesListBox.Items.Insert(idx-1,doc);
					modulesListBox.SelectedItem = doc;
					CurrentProject.Changed = true;
				}
			}
		
		}

		private void downButton_Click(object sender, System.EventArgs e)
		{
			if (null == CurrentProject) return;
			TabPage page = projectTabCtrl.SelectedTab;
			if (sourcesListBox.Parent == page)
			{
				Bp2SourceDoc doc = sourcesListBox.SelectedItem as Bp2SourceDoc;
				if (null == doc) return;
				int idx = sourcesListBox.SelectedIndex;
				if (idx < sourcesListBox.Items.Count-1)
				{
					sourcesListBox.Items.Remove(doc);
					sourcesListBox.Items.Insert(idx+1,doc);
					sourcesListBox.SelectedItem = doc;
					CurrentProject.Changed = true;
				}
			}
			else if (modulesListBox.Parent == page)
			{
				Bp2SourceDoc doc = modulesListBox.SelectedItem as Bp2SourceDoc;
				if (null == doc) return;
				int idx = modulesListBox.SelectedIndex;
				if (idx < modulesListBox.Items.Count-1)
				{
					modulesListBox.Items.Remove(doc);
					modulesListBox.Items.Insert(idx+1,doc);
					modulesListBox.SelectedItem = doc;
					CurrentProject.Changed = true;
				}
			}		
		}

		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if (e.Button == this.toolNewFileItem)
				this.fileNewSourceItem_Click(fileNewSourceItem,e);
			else if (e.Button == this.toolNewProjectItem)
				this.fileNewProjectItem_Click(fileNewProjectItem,e);
			else if (e.Button == this.toolAddFileItem)
				this.projectAddFileItem_Click(projectAddFileItem,e);
            else if (e.Button == this.toolAddExistingFileItem)
                this.projectAddExistingFileItem_Click(projectAddExistingFileItem, e);
            else if (e.Button == this.toolOpenItem)
				this.fileOpenFileItem_Click(fileOpenFileItem,e);
			else if (e.Button == this.toolCloseFileItem)
				this.fileCloseFileItem_Click(fileCloseFileItem,e);
			else if (e.Button == this.toolFileSaveItem)
				this.fileSaveFileItem_Click(fileSaveFileItem,e);
			else if (e.Button == this.toolSaveAllItem)
				this.fileSaveAllItem_Click(fileSaveAllItem,e);
			else if (e.Button == this.toolCutItem)
				this.editCutItem_Click(editCutItem,e);
			else if (e.Button == this.toolCopyItem)
				this.editCopyItem_Click(editCopyItem,e);
			else if (e.Button == this.toolPasteItem)
				this.editPasteItem_Click(editPasteItem,e);
			else if (e.Button == this.toolSelectAllItem)
				this.editSelectAllItem_Click(editSelectAllItem,e);
			else if (e.Button == this.toolUndoItem)
				this.editUndoItem_Click(editUndoItem,e);
			else if (e.Button == this.toolRedoItem)
				this.editRedoItem_Click(editRedoItem,e);
			else if (e.Button == this.toolBuildItem)
				this.projectBuildItem_Click(projectBuildItem,e);
			else if (e.Button == this.toolDebugItem)
				this.projectDebugItem_Click(projectDebugItem,e);
			else if (e.Button == this.toolRunItem)
				this.projectRunItem_Click(projectRunItem,e);
			else if (e.Button == this.toolCancelDebugItem)
				this.projectCancelDebugItem_Click(projectCancelDebugItem,e);
			else if (e.Button == this.toolProjectSettingsItem)
				this.projectSettingsItem_Click(projectSettingsItem,e);
		}

		private void MainForm_MenuComplete(object sender, System.EventArgs e)
		{
			this.statusBar1.Text = "";
		}

		private void selectErrPosition(string errtxt)
		{
			if (!errtxt.StartsWith("in ")) return;
			errtxt = errtxt.Substring(3).Trim();
			int linepos = errtxt.IndexOf("line");
			string filepart = linepos > 0 ? errtxt.Substring(0, linepos).Trim(' ', '"') : errtxt.Trim(' ','"');
			int l = 1;
			int c = 1;
			if (linepos > 0)
			{
				string[] parts = errtxt.Substring(linepos).Split(' ');
				int n = parts.Length;
				for (int i=0;i< n-1;++i)
				{
					if (parts[i].StartsWith("line"))
					{
						try
						{
							l = Convert.ToInt32(parts[i + 1]);
						}
						catch (Exception) { l = 1; }
					}
					else   if (parts[i].StartsWith("pos"))
					{
						try
						{
							c = Convert.ToInt32(parts[i + 1]);
						}
						catch (Exception) { c = 1; }
					}
				}
				Bp2SourceDoc doc = openFile(filepart);
				if (doc != null)
				{
					Scintilla ed = doc.Editor as Scintilla;
					if (null == ed) return;
					ed.Caret.LineNumber = l-1;
					int p = ed.Caret.Position;
					ed.Caret.Position = p + (c - 1);
					ed.Selection.Start = ed.Caret.Position;
					ed.Selection.End = ed.Caret.Position;

				}
			}

		}

		private void errText_DoubleClick(object sender, EventArgs e)
		{
			int pos = this.errText.SelectionStart;
			int line = this.errText.GetLineFromCharIndex(pos);
			if (line >= 0 && 2*line < errText.Lines.Length)
			{
				selectErrPosition(errText.Lines[2*line]);
			}
		}

        private void MainForm_Load(object sender, EventArgs e)
        {
			string txt = this.Text;
#if X64
			txt += " 64 Bit";
#else
            txt += " 32 Bit";
#endif
#if _UNICODE
			txt += " Unicode";
#endif
#if DEBUG
			txt += " Debug";
#endif
			this.Text = txt;
		}
    }
}
