using System;
using System.Windows.Forms;
using System.Collections;

namespace bp2ide
{
	/// <summary>
	/// Zusammenfassung fr MenuItemMessageProvider.
	/// </summary>
	public class MenuItemMessageProvider
	{
		public MenuItemMessageProvider()
		{
            _itemMap = new Hashtable();
		}

		public bool AddItem(MenuItem item, string msgId)
		{
			if (null == item) return false;
			if (null == msgId) msgId = "";
			if (_itemMap.Contains(item)) return false;
			_itemMap.Add(item,msgId);
			item.Select += new EventHandler(OnItemSelect);
			return true;
		}

		public Control Destination
		{
			get { return _destination; }
			set { _destination = value; }
		}

		public IMsgFormatter MsgFormatter
		{
			get { return _msgFormatter; }
			set { _msgFormatter = value; }
		}

		private void OnItemSelect(object sender, System.EventArgs e)
		{
			if ((null == _destination) || (_destination.IsDisposed))
				return;
			string msgId = _itemMap[sender] as string;
			if (null != msgId)
			{
				if (null != _msgFormatter)
				   _destination.Text = _msgFormatter.MsgFormat(msgId);
				else
					_destination.Text = msgId;
			}
		}
		

		private Control _destination = null;
		private IMsgFormatter _msgFormatter;
		private Hashtable _itemMap;
	}
}
