using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace bp2ide
{
	/// <summary>
	/// Zusammenfassung fr ProjectSettingsDialog.
	/// </summary>
	public class ProjectSettingsDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox projectName;
		private System.Windows.Forms.Label projectNameLabel;
		private System.Windows.Forms.Label outputDirLabel;
		private System.Windows.Forms.TextBox outputDir;
		private System.Windows.Forms.Button outputDirButton;
		private System.Windows.Forms.Label outputModuleLabel;
		private System.Windows.Forms.TextBox outputModule;
		private System.Windows.Forms.CheckBox createModule;
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.Button btnCancel;
		private System.Windows.Forms.FolderBrowserDialog outputDirDialog;
		private System.Windows.Forms.ToolTip toolTip1;
		private CheckBox createDebugInfo;
		private TabControl tabControl1;
		private TabPage buildOptions;
		private TabPage dirOptions;
		private Label includeDirsLabel;
		private TextBox includeDirs;
		private Label libDirsLabel;
		private TextBox libDirs;
		private Label pathDirsLabel;
		private TextBox pathDirs;
		private TabPage debugOptions;
		private CheckBox showCode;
		private CheckBox showTrace;
		private TabPage defines;
		private TextBox defineList;
		private System.ComponentModel.IContainer components;

		public ProjectSettingsDialog()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(ProjectSettingsDialog));
            this.projectName = new System.Windows.Forms.TextBox();
            this.projectNameLabel = new System.Windows.Forms.Label();
            this.outputDirLabel = new System.Windows.Forms.Label();
            this.outputDir = new System.Windows.Forms.TextBox();
            this.outputDirButton = new System.Windows.Forms.Button();
            this.outputModuleLabel = new System.Windows.Forms.Label();
            this.outputModule = new System.Windows.Forms.TextBox();
            this.createModule = new System.Windows.Forms.CheckBox();
            this.btnOk = new System.Windows.Forms.Button();
            this.btnCancel = new System.Windows.Forms.Button();
            this.outputDirDialog = new System.Windows.Forms.FolderBrowserDialog();
            this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.defineList = new System.Windows.Forms.TextBox();
            this.createDebugInfo = new System.Windows.Forms.CheckBox();
            this.tabControl1 = new System.Windows.Forms.TabControl();
            this.buildOptions = new System.Windows.Forms.TabPage();
            this.defines = new System.Windows.Forms.TabPage();
            this.dirOptions = new System.Windows.Forms.TabPage();
            this.pathDirsLabel = new System.Windows.Forms.Label();
            this.libDirsLabel = new System.Windows.Forms.Label();
            this.includeDirsLabel = new System.Windows.Forms.Label();
            this.pathDirs = new System.Windows.Forms.TextBox();
            this.libDirs = new System.Windows.Forms.TextBox();
            this.includeDirs = new System.Windows.Forms.TextBox();
            this.debugOptions = new System.Windows.Forms.TabPage();
            this.showTrace = new System.Windows.Forms.CheckBox();
            this.showCode = new System.Windows.Forms.CheckBox();
            this.tabControl1.SuspendLayout();
            this.buildOptions.SuspendLayout();
            this.defines.SuspendLayout();
            this.dirOptions.SuspendLayout();
            this.debugOptions.SuspendLayout();
            this.SuspendLayout();
            // 
            // projectName
            // 
            resources.ApplyResources(this.projectName, "projectName");
            this.projectName.Name = "projectName";
            this.toolTip1.SetToolTip(this.projectName, resources.GetString("projectName.ToolTip"));
            this.projectName.Validating += new System.ComponentModel.CancelEventHandler(this.projectName_Validating);
            // 
            // projectNameLabel
            // 
            resources.ApplyResources(this.projectNameLabel, "projectNameLabel");
            this.projectNameLabel.Name = "projectNameLabel";
            this.toolTip1.SetToolTip(this.projectNameLabel, resources.GetString("projectNameLabel.ToolTip"));
            // 
            // outputDirLabel
            // 
            resources.ApplyResources(this.outputDirLabel, "outputDirLabel");
            this.outputDirLabel.Name = "outputDirLabel";
            this.toolTip1.SetToolTip(this.outputDirLabel, resources.GetString("outputDirLabel.ToolTip"));
            // 
            // outputDir
            // 
            resources.ApplyResources(this.outputDir, "outputDir");
            this.outputDir.Name = "outputDir";
            this.toolTip1.SetToolTip(this.outputDir, resources.GetString("outputDir.ToolTip"));
            // 
            // outputDirButton
            // 
            resources.ApplyResources(this.outputDirButton, "outputDirButton");
            this.outputDirButton.Name = "outputDirButton";
            this.toolTip1.SetToolTip(this.outputDirButton, resources.GetString("outputDirButton.ToolTip"));
            this.outputDirButton.Click += new System.EventHandler(this.outputDirButton_Click);
            // 
            // outputModuleLabel
            // 
            resources.ApplyResources(this.outputModuleLabel, "outputModuleLabel");
            this.outputModuleLabel.Name = "outputModuleLabel";
            this.toolTip1.SetToolTip(this.outputModuleLabel, resources.GetString("outputModuleLabel.ToolTip"));
            // 
            // outputModule
            // 
            resources.ApplyResources(this.outputModule, "outputModule");
            this.outputModule.Name = "outputModule";
            this.toolTip1.SetToolTip(this.outputModule, resources.GetString("outputModule.ToolTip"));
            // 
            // createModule
            // 
            resources.ApplyResources(this.createModule, "createModule");
            this.createModule.Name = "createModule";
            this.toolTip1.SetToolTip(this.createModule, resources.GetString("createModule.ToolTip"));
            // 
            // btnOk
            // 
            resources.ApplyResources(this.btnOk, "btnOk");
            this.btnOk.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.btnOk.Name = "btnOk";
            this.toolTip1.SetToolTip(this.btnOk, resources.GetString("btnOk.ToolTip"));
            // 
            // btnCancel
            // 
            resources.ApplyResources(this.btnCancel, "btnCancel");
            this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btnCancel.Name = "btnCancel";
            this.toolTip1.SetToolTip(this.btnCancel, resources.GetString("btnCancel.ToolTip"));
            // 
            // outputDirDialog
            // 
            resources.ApplyResources(this.outputDirDialog, "outputDirDialog");
            // 
            // defineList
            // 
            this.defineList.AcceptsReturn = true;
            resources.ApplyResources(this.defineList, "defineList");
            this.defineList.Name = "defineList";
            this.toolTip1.SetToolTip(this.defineList, resources.GetString("defineList.ToolTip"));
            // 
            // createDebugInfo
            // 
            resources.ApplyResources(this.createDebugInfo, "createDebugInfo");
            this.createDebugInfo.Name = "createDebugInfo";
            this.toolTip1.SetToolTip(this.createDebugInfo, resources.GetString("createDebugInfo.ToolTip"));
            this.createDebugInfo.UseVisualStyleBackColor = true;
            // 
            // tabControl1
            // 
            resources.ApplyResources(this.tabControl1, "tabControl1");
            this.tabControl1.Controls.Add(this.buildOptions);
            this.tabControl1.Controls.Add(this.defines);
            this.tabControl1.Controls.Add(this.dirOptions);
            this.tabControl1.Controls.Add(this.debugOptions);
            this.tabControl1.Name = "tabControl1";
            this.tabControl1.SelectedIndex = 0;
            this.toolTip1.SetToolTip(this.tabControl1, resources.GetString("tabControl1.ToolTip"));
            // 
            // buildOptions
            // 
            resources.ApplyResources(this.buildOptions, "buildOptions");
            this.buildOptions.Controls.Add(this.projectName);
            this.buildOptions.Controls.Add(this.createDebugInfo);
            this.buildOptions.Controls.Add(this.projectNameLabel);
            this.buildOptions.Controls.Add(this.outputDir);
            this.buildOptions.Controls.Add(this.outputDirLabel);
            this.buildOptions.Controls.Add(this.createModule);
            this.buildOptions.Controls.Add(this.outputDirButton);
            this.buildOptions.Controls.Add(this.outputModuleLabel);
            this.buildOptions.Controls.Add(this.outputModule);
            this.buildOptions.Name = "buildOptions";
            this.toolTip1.SetToolTip(this.buildOptions, resources.GetString("buildOptions.ToolTip"));
            this.buildOptions.UseVisualStyleBackColor = true;
            // 
            // defines
            // 
            resources.ApplyResources(this.defines, "defines");
            this.defines.Controls.Add(this.defineList);
            this.defines.Name = "defines";
            this.toolTip1.SetToolTip(this.defines, resources.GetString("defines.ToolTip"));
            this.defines.UseVisualStyleBackColor = true;
            // 
            // dirOptions
            // 
            resources.ApplyResources(this.dirOptions, "dirOptions");
            this.dirOptions.Controls.Add(this.pathDirsLabel);
            this.dirOptions.Controls.Add(this.libDirsLabel);
            this.dirOptions.Controls.Add(this.includeDirsLabel);
            this.dirOptions.Controls.Add(this.pathDirs);
            this.dirOptions.Controls.Add(this.libDirs);
            this.dirOptions.Controls.Add(this.includeDirs);
            this.dirOptions.Name = "dirOptions";
            this.toolTip1.SetToolTip(this.dirOptions, resources.GetString("dirOptions.ToolTip"));
            this.dirOptions.UseVisualStyleBackColor = true;
            // 
            // pathDirsLabel
            // 
            resources.ApplyResources(this.pathDirsLabel, "pathDirsLabel");
            this.pathDirsLabel.Name = "pathDirsLabel";
            this.toolTip1.SetToolTip(this.pathDirsLabel, resources.GetString("pathDirsLabel.ToolTip"));
            // 
            // libDirsLabel
            // 
            resources.ApplyResources(this.libDirsLabel, "libDirsLabel");
            this.libDirsLabel.Name = "libDirsLabel";
            this.toolTip1.SetToolTip(this.libDirsLabel, resources.GetString("libDirsLabel.ToolTip"));
            // 
            // includeDirsLabel
            // 
            resources.ApplyResources(this.includeDirsLabel, "includeDirsLabel");
            this.includeDirsLabel.Name = "includeDirsLabel";
            this.toolTip1.SetToolTip(this.includeDirsLabel, resources.GetString("includeDirsLabel.ToolTip"));
            // 
            // pathDirs
            // 
            resources.ApplyResources(this.pathDirs, "pathDirs");
            this.pathDirs.Name = "pathDirs";
            this.toolTip1.SetToolTip(this.pathDirs, resources.GetString("pathDirs.ToolTip"));
            // 
            // libDirs
            // 
            resources.ApplyResources(this.libDirs, "libDirs");
            this.libDirs.Name = "libDirs";
            this.toolTip1.SetToolTip(this.libDirs, resources.GetString("libDirs.ToolTip"));
            // 
            // includeDirs
            // 
            resources.ApplyResources(this.includeDirs, "includeDirs");
            this.includeDirs.Name = "includeDirs";
            this.toolTip1.SetToolTip(this.includeDirs, resources.GetString("includeDirs.ToolTip"));
            // 
            // debugOptions
            // 
            resources.ApplyResources(this.debugOptions, "debugOptions");
            this.debugOptions.Controls.Add(this.showTrace);
            this.debugOptions.Controls.Add(this.showCode);
            this.debugOptions.Name = "debugOptions";
            this.toolTip1.SetToolTip(this.debugOptions, resources.GetString("debugOptions.ToolTip"));
            this.debugOptions.UseVisualStyleBackColor = true;
            // 
            // showTrace
            // 
            resources.ApplyResources(this.showTrace, "showTrace");
            this.showTrace.Name = "showTrace";
            this.toolTip1.SetToolTip(this.showTrace, resources.GetString("showTrace.ToolTip"));
            this.showTrace.UseVisualStyleBackColor = true;
            // 
            // showCode
            // 
            resources.ApplyResources(this.showCode, "showCode");
            this.showCode.Name = "showCode";
            this.toolTip1.SetToolTip(this.showCode, resources.GetString("showCode.ToolTip"));
            this.showCode.UseVisualStyleBackColor = true;
            // 
            // ProjectSettingsDialog
            // 
            this.AcceptButton = this.btnOk;
            resources.ApplyResources(this, "$this");
            this.CancelButton = this.btnCancel;
            this.ControlBox = false;
            this.Controls.Add(this.tabControl1);
            this.Controls.Add(this.btnCancel);
            this.Controls.Add(this.btnOk);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "ProjectSettingsDialog";
            this.ShowInTaskbar = false;
            this.toolTip1.SetToolTip(this, resources.GetString("$this.ToolTip"));
            this.tabControl1.ResumeLayout(false);
            this.buildOptions.ResumeLayout(false);
            this.buildOptions.PerformLayout();
            this.defines.ResumeLayout(false);
            this.defines.PerformLayout();
            this.dirOptions.ResumeLayout(false);
            this.dirOptions.PerformLayout();
            this.debugOptions.ResumeLayout(false);
            this.debugOptions.PerformLayout();
            this.ResumeLayout(false);

		}
		#endregion


		public string ProjectName
		{
			get { return projectName.Text; }
			set { projectName.Text = value; }
		}

		public string OutputDir
		{
			get { return outputDir.Text; }
			set { outputDir.Text = value; }
		}

		public string OutputModule
		{
			get { return outputModule.Text; }
			set { outputModule.Text = value; }
		}

		public bool CreateModule
		{
			get { return createModule.Checked; }
			set { createModule.Checked = value; }
		}

		public string IncludeDirs
		{
			get { return includeDirs.Text; }
			set { includeDirs.Text = value; }
		}

		public string LibDirs
		{
			get { return libDirs.Text; }
			set { libDirs.Text = value; }
		}

        public string Defines
        {
            get { return defineList.Text;  }
            set { defineList.Text = value; }
        }
        public string PathDirs
		{
			get { return pathDirs.Text; }
			set { pathDirs.Text = value; }
		}

		public bool CreateDebugInfo
		{
			get { return createDebugInfo.Checked; }
			set { createDebugInfo.Checked = value; }
		}

		public bool ShowCode
		{
			get { return showCode.Checked; }
			set { showCode.Checked = value; }
		}

		public bool ShowTrace
		{
			get { return showTrace.Checked; }
			set { showTrace.Checked = value; }
		}

		private void projectName_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (projectName.Text.Length == 0)
			{
				e.Cancel = true;
				btnOk.Enabled = false;
			}
			else
				btnOk.Enabled = true;
		}

		private void outputDirButton_Click(object sender, System.EventArgs e)
		{
			outputDirDialog.SelectedPath = OutputDir;
			if (DialogResult.OK == outputDirDialog.ShowDialog())
			{
				OutputDir = outputDirDialog.SelectedPath;
			}
		}

	}
}
