
using bp2builder.InterOp;
using System.Windows.Forms;

namespace bp2ide
{
	/// <summary>
	/// 
	/// </summary>
	public class TextBoxInput : Bp2Input
	{
		public TextBoxInput(TextBoxBase textBox)
		{
			_textBox = textBox;
		}

		private void OnChar(object sender, KeyPressEventArgs e)
		{
			_lastChar = e.KeyChar;
		}

		public override string DoGetString()
		{
			KeyPressEventHandler hdl = new KeyPressEventHandler(OnChar);
			_lastChar = '\0';
			_textBox.ScrollToCaret();
			_textBox.Focus();
//			TabControl tctl = _textBox.Parent.Parent as TabControl;
//			if (null != tctl)
//				tctl.SelectedTab = _textBox.Parent as TabPage;
			_textBox.SelectionStart = _textBox.Text.Length;
			_startPos = _textBox.SelectionStart;
			_textBox.KeyPress += hdl;
			bool readOnly = _textBox.ReadOnly;
			_textBox.ReadOnly = false;
			while (_lastChar != '\r')
			{
				System.Threading.Thread.Sleep(50);
				Application.DoEvents();
			}
			_textBox.KeyPress -= hdl;
			_textBox.ReadOnly = readOnly;
			string  result = _textBox.Text.Substring(_startPos).Replace("\r","");
			if (result.EndsWith("\n"))
				return result.Substring(0,result.Length-1);
			return result;
		}

		public override char DoGetChar()
		{
			KeyPressEventHandler hdl = new KeyPressEventHandler(OnChar);
			_lastChar = '\0';
			_textBox.ScrollToCaret();
			_textBox.Focus();
//			TabControl tctl = _textBox.Parent.Parent as TabControl;
//			if (null != tctl)
//				tctl.SelectedTab = _textBox.Parent as TabPage;
			_textBox.SelectionStart = _textBox.Text.Length;
			_startPos = _textBox.SelectionStart;
			_textBox.KeyPress += hdl;
			bool readOnly = _textBox.ReadOnly;
			_textBox.ReadOnly = false;
			while (_lastChar == '\0')
			{
				System.Threading.Thread.Sleep(50);
				Application.DoEvents();
			}
			_textBox.KeyPress -= hdl;
			_textBox.ReadOnly = readOnly;
			return _lastChar;
		}

		char _lastChar = '\0';
		int _startPos = 0;
		TextBoxBase _textBox;
	}
}
